/* ###############################################
   # Copyright 2002, 2003 Roberto Borgione       #
   #                      Albert Renom           #
   # graph2002.c - PNG File generator            #
   #       v1.0 (01-2001)                        #
   #       v2.0 (02-2002)                        #
   ###############################################
 
   This file is part of NetMeter.

   NetMeter is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   NetMeter is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with NetMeter; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

/*
###########################################################
To compile on FreeBSD v4.3

0. GD library download on http://www.boutell.com/gd/
1. change the directory of GD library in #INCLUDE directives
2. gcc -c graphR.c
3. gcc -o graph2 graphR.o /usr/local/lib/libgd.so
4. That's all!
###########################################################
###########################################################
*/


//###########################################################
//Patch funcion
//###########################################################
void RobertoFill           (void);
void RobertoAxis           (void);
void RobertoNetmeterGraph  (void);
void RobertoNetmeterGraph2 (void);
void RobertoIctGraph       (void);
//###########################################################

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#include </usr/include/gd.h>
#include </usr/include/gdfontt.h>
#include </usr/include/gdfonts.h>
#include </usr/include/gdfontmb.h>
#include </usr/include/gdfontl.h>
#include </usr/include/gdfontg.h>

#define FT		gdFontTiny
#define FS		gdFontSmall
#define FM		gdFontMediumBold
#define FL		gdFontLarge
#define FG		gdFontGiant

#define PixT	5
#define PixS	6
#define PixM	7
#define PixL	8
#define PixG	9

#define PiyT	8
#define PiyS	10
#define PiyM	10
#define PiyL	14
#define PiyG	14

typedef struct {
		char nom[500];
}label;
typedef struct {
		char d1[500];
} indata;
label arg[50];
int lab[25];
int dat[25];
int marg, mlab,mdat;
int TX=2000;
int FX;

//##########ROBERTO PATCH old 480
int TY=1000;
//###############################
int beginx;
int beginy;


//######### Roberto PATCH ##############################

int   xpatt[50];
int   ypatt[50];
float fnum;
float fmin;
int   fpoint;
int  RPATTERN=0;
int  PATTERNVALUE=15;
int  RBACK=0;
int  RZERO=0;   
int  RFILL=0;   
int  GlobalXSIZE=200;
int  GlobalYSIZE=400;
int  GlobalLINES=10;
int  count, countflow, maxflow;
char line[2500],flowname[500],flow_names[30][250];   // MAX 30 different Flow name 
int  first,last,new;
int x,y,size;
int old_next;
//#######################################################

gdImagePtr im;
gdImagePtr f_im;
FILE *faux;
FILE *faux2;
int i, w, zx, zy,j,k,mul;
int ret, msec;
int next;
int colors[255];
int lines ;
label *tlabel;
indata *data;
double	*max_args;
char pctn[100];
int ty;
int aux=1;
int l,d;
double rest,max, p1,p2,p3,p4,p5,dato,suma;
double emax=0;
double limmax=0;
double point[4];
double apoint;
double sum;
double mxf;
double sfil;
char col[2];
int titx, tity,rot,esc;
int ml,xl;
int EY,EX;
int firstX;
int off, off1,lon;
int ofs, ofs1;
char sl [50];
char ls [50];
char titn [200];
char ant[500];
char tfont [3];
char font [20];
char te[10];
char fin;
int mult, divd;
int PX, PY,pxx,pyy;
int ctl;
int fila;
int espacio;
int espx=0;
int espax=0;
int nley,aley,mley,lley;
char resto[100];
char antes[100];
int more=10;
int eje=1;
double vec[50];
double vant[50];
int nolin=1;

/* flags d'activacio per linia de comnades */
	
int param;
int defcolors=0;
int output=0;
int input=0;
int title=0;
int limax=0;
char lmax[50];
int conf=0;
int row,fi;
int retn=0;
int mull=0;
int text=0;
int esp=0;
int legend=0;
int acum=0;
int fil=0;
int max_col=30;
int MXC=0;
int pid;
int mem;
int final;
int sur=0;
int others=0;
int toeste=0;
int teste=0;
int loeste=0;
int leste=0;
int lonlabel=0;

int brect[8];
double sz;
/*char *f ="/users/albert/ARIAL.TTF";*/
char *err;
	
char kind[2];
char typeG[5];
char Graph[5];
char Dtitle[80];
char Dlegend[80];
char Oname[80];
char Oper[10];
char Iname[80];
char Dcolor[80];
char test [80];
char Deix[80];
char CFG[80];
char OF[5];
char OTROS[5];
char linia_cfg[2500];
char syst[100];
char Dlin[50];
char Drm [25];
//#######################################################

// ##################################################
// DRAW a pattern (I) max 8  on (X,Y) coord of (SIZE)
// ##################################################
void pattern(int x, int y, int i,int size)
{
   int MAX_PATTERN=10;


   if ((i % MAX_PATTERN)==2 )  
   {
       gdImageFilledRectangle(im, x-size, y-size, x+size,y+size, colors[i]);
       gdImageRectangle(im, x-size, y-size, x+size,y+size, colors[1]);
   }
   if ((i % MAX_PATTERN)==3 )  
   {
       size++; 
       gdImageFilledRectangle(im, x-3, y-1, x+3,y+1, colors[i]);
       gdImageFilledRectangle(im, x-1, y-3, x+1,y+3, colors[i]);
       gdImageLine(im,x-size,y,x,y-size,colors[1]);
       gdImageLine(im,x-size,y,x,y+size,colors[1]);
       gdImageLine(im,x,y-size,x+size,y,colors[1]);
       gdImageLine(im,x,y+size,x+size,y,colors[1]);                     
   }
   if ((i % MAX_PATTERN)==4 )  
   {
       y++;
       size++; 
       gdImageFilledRectangle(im, x-3, y-1, x+3,y, colors[i]);
       gdImageFilledRectangle(im, x-1, y-3, x+1,y, colors[i]);
       gdImageLine(im,x-size,y+1,x+size,y+1,colors[1]);
       gdImageLine(im,x-size-1,y+1,x,y-size,colors[1]);
       gdImageLine(im,x,y-size,x+size+1,y+1,colors[1]);
   }
   if ((i % MAX_PATTERN)==5 )  
   {
       y--;
       size++; 
       gdImageFilledRectangle(im, x-3, y, x+3,y+1, colors[i]);
       gdImageFilledRectangle(im, x-1, y, x+1,y+3, colors[i]);

       gdImageLine(im,x-size,y-1,x+size,      y-1,colors[1]);
       gdImageLine(im,x-size-1,y-1,x, y+size,colors[1]);
       gdImageLine(im,x,y+size,x+size+1,y-1,colors[1]);                     
   }
   if ((i % MAX_PATTERN)==6 )  
   {
       x++;
       gdImageFilledRectangle(im, x-size, y-1,    x+size-1,y+1, colors[i]);
       gdImageFilledRectangle(im, x-size, y-2, x-size+2,y+2, colors[i]);
       gdImageLine(im,x-size-1,y-size-1,x-size-1,y+size+1,colors[1]);
       gdImageLine(im,x-size-1,y-size-1,x+size,y,colors[1]);
       gdImageLine(im,x-size-1,y+size+1,x+size,y,colors[1]);
   }
   if ((i % MAX_PATTERN)==8 )  
   {
       x--;
       gdImageFilledRectangle(im, x-size+1,   y-1, x+size+1,y+1, colors[i]);
       gdImageFilledRectangle(im, x-size+2,   y-2, x+size+1,y+2, colors[i]);
       gdImageLine(im,x+size+1,y-size-1,x+size+1,y+size+1,colors[1]);
       gdImageLine(im,x+size+1,y-size-1,x-size,y,colors[1]);
       gdImageLine(im,x+size+1,y+size+1,x-size,y,colors[1]);
   }
   if ((i % MAX_PATTERN)==7 )  
   {
       gdImageFilledRectangle(im, x-2, y-size-1, x+2,y+size+1, colors[i]);
       gdImageRectangle(im,       x-2, y-size-1, x+2,y+size+1, colors[1]);
   }
   if ((i % MAX_PATTERN)==9 )  
   {
       gdImageFilledRectangle(im, x-size-1, y-2, x+size+1,y+2, colors[i]);
       gdImageRectangle(im,       x-size-1, y-2, x+size+1,y+2, colors[1]);
   }
}







				
/************************************************************/
/************** FUNCIONS DE SEGON NIVELL ********************/
/************************************************************/

/************************************************************/
/* Funcio d'erros 					    */
/************************************************************/

void merror(int quin)
{
switch (quin)
	{
	case 1: printf("ERROR: Parametro desconocido\n");break;
	case 2: printf("ERROR: Falta fichero de datos\n");break;
	case 3: printf("ERROR: Formato de fichero incorrecto\n"); break;
	case 4: printf("ERROR: Formato del titulo incorrecto\n"); break;
	case 5: printf("ERROR: Formato de la leyenda incorrecto\n");break;
	case 6: printf("ERROR: Fichero no existe\n");break;
	case 7: printf("ERROR: Faltan Parametros\n");break;
	case 8: printf("ERROR: En fichero configuracion\n");break;
	case 9: printf("ERROR: Formato del color incorrecto\n"); break;
	case 10: printf("ERROR: Maximo Eje Y intoducido es menor que max Graph\n"); break;
	case 11: printf("ERROR: Fila inexistente\n"); break;
	case 12: printf("ERROR: Opcio Incorrecta\n");break;
	default: printf("ERROR indeterminado\n");
	}
printf("USAGE: graph nombre_fichero {-s|-c|-l|-la} -dat [#columna]+ \n");
printf("\t [-o fich_salida] [-e {int | flt | tim}] [-op {log | por}] [-fil num_fial]\n");
printf("\t [-f fuente] [-tx max-X] [-ty max-Y] [-lab [#columna]+]  \n");
printf("\t [-mxc num_colum ] [-lmax maximo] [-cfg fichero_conf]\n");
printf("\t [ -mul num] [-div num] [-esp num] [-xes num] [-sum {graf|text}]\n");
exit(-1);
}

/************************************************************/
/* Funcio que llegueix una linia del fitxer d'entrada 	    */
/* i emmagatzema els resultats en un array, i el numero de  */
/* camps que s'han llegit (NF)				    */
/************************************************************/

int read_line (char *lin)
{
 int fin;
 int i=0;
 int offs,offs1;
 
 offs=0;
 bzero (arg[i].nom,500);
 fin = sscanf (lin,"%s", arg[i].nom);
 if (strncmp("#",arg[i].nom,1)== 0)
 {
 	return (-1);
 }	
 if (strlen(lin)==0)
 {
 	return (-1);
 }
 while (fin!=-1)
 {
	
	offs1 = strlen(arg[i].nom);
	offs= offs + offs1 +1;
	i++;
	fin = sscanf (&lin[offs],"%s", arg[i].nom);
 }
 return (i);
}
/************************************************************/
/* Funcio que calcula quina es la suma d'una fila           */
/************************************************************/
double sumar_fila ( char *dat)
{

 double suma, dt;
 int fin;
 int ofs, ofs1;
 char sl [50];
 
 fin = 0; ofs=0; suma=0;
 fin = sscanf (dat,"%s",sl);
 while (fin!=-1)
 {
	sscanf (sl,"%lf", &dt);
	suma += dt;
	ofs1 = strlen(sl);
	ofs= ofs + ofs1 +1;
	fin = sscanf (&dat[ofs],"%s", sl);	 
 }
 return suma;
}

/************************************************************/
/* Funcio que calcula quin es el percentage de cadascun     */
/* dels valos de la taula de data. 			    */
/************************************************************/
void percentage (char  *pctg, char *dat, double val)
{ 
	int fin;
	float  pg;
	double dt;
	char sl[1024],ant[1024];
	int off, off1,lon;
	
	pg=0;fin=0;
	off=0;
	fin = sscanf (dat,"%s", sl);
	while (fin!=-1)
 	{
		sscanf (sl,"%lf", &dt);
		off1 = strlen(sl);
		off= off + off1 +1;
		if (val==0) { pg=0;}
		else {pg = (dt/val)*100;}
		lon=strlen(pctg);
		if (lon==0)
		{
			sprintf (pctg,"%lf",pg);
		}
		else
		{
			sprintf(ant,"%s",pctg);
			sprintf(pctg,"%s %lf",ant,pg);
		}		
		fin = sscanf (&dat[off],"%s", sl);	
	}
}

/********************************************************/
/* Funci que converteix en format huma			*/
/********************************************************/
void human (double xm, char *strn, char *kin)
{	
	char sr[10];
	int i=0;
	float dive;
	char CH[2];

	if (strcasecmp(kin,"E")==0)
	{
		dive=1000.0;
		sprintf (CH, " ");
	}
	if (strcasecmp(kin,"B")==0)
	{
		dive=1024.0;
		sprintf (CH, "B");
	}
	while (xm >= dive)
	{
		xm=xm/dive;
		i++;
	}
	switch (i)
	{
		case 1: sprintf (sr, " K");break;
		case 2: sprintf (sr, " M");break;
		case 3: sprintf (sr, " G");break;
		case 4: sprintf (sr, " T");break;
		default: sprintf (sr, " ");
	}

//###### Roberto Patch ############
        if (   (strcasecmp(typeG,"N")==0) 
            || (strcasecmp(typeG,"X")==0) 
            || (strcasecmp(typeG,"R")==0) )
        {
           sprintf (CH, " ");
        }
	sprintf (strn,"%.2f%s%s",xm,sr,CH);
//#################################	
}
/********************************************************/
/* Funci que converteix en format time			*/
/********************************************************/
void floatTotime (char *strn)
{
	int hour;
	float min;
	double m;
	sscanf (strn,"%i%f",&hour,&min);
	m=rint(min*60.);
	sprintf(strn,"%iH %2.fm",hour,m);
}

/************************************************************/
/* Funcio que esciur text en la imatge 		            */
/************************************************************/

void write_IM (gdImagePtr img, int x, int y, int rt, char *fn, char 
*name, int color)
{
 
 if (rt==0)
 {
	if (strcasecmp(fn,"FT")==0)
	{ 
		gdImageString(img, FT, x, y , name, color);
	}
	if (strcasecmp(fn,"FS")==0)
	{ 
		gdImageString(img, FS, x, y , name, color);
	}
	if (strcasecmp(fn,"FM")==0)
	{ 
		gdImageString(img, FM, x, y , name, color);
	}
	if (strcasecmp(fn,"FL")==0)
	{ 
		gdImageString(img, FL, x, y , name, color);
	}
	if (strcasecmp(fn,"FG")==0)
	{ 
		gdImageString(img, FG, x, y , name, color);
	}
 }
 else
 {
	if (strcasecmp(fn,"FT")==0)
	{ 
		gdImageStringUp(img, FT, x, y , name, color);
	}
	if (strcasecmp(fn,"FS")==0)
	{ 
		gdImageStringUp(img, FS, x, y , name, color);
	}
	if (strcasecmp(fn,"FM")==0)
	{ 
		gdImageStringUp(img, FM, x, y , name, color);
	}
	if (strcasecmp(fn,"FL")==0)
	{ 
		gdImageStringUp(img, FL, x, y , name, color);
	}
	if (strcasecmp(fn,"FG")==0)
	{ 
		gdImageStringUp(img, FG, x, y , name, color);
	}
 }
}
/****************************************************/
/* Funcio que retorna el cos X o Y d'una font	    */
/****************************************************/

int cos_font (char posf, char typef[])
{
	
	if (strcasecmp(typef,"FT")==0)
	{	 
		if (posf=='X'){return PixT;}
		if (posf=='Y'){return PiyT;}
	}
	if (strcasecmp(typef,"FS")==0)
	{ 
		if (posf=='X'){return PixS;}
		if (posf=='Y'){return PiyS;}
	}
	if (strcasecmp(typef,"FM")==0)
	{ 
		if (posf=='X'){return PixM;}
		if (posf=='Y'){return PiyM;}
	}
	if (strcasecmp(typef,"FL")==0)
	{ 
		if (posf=='X'){return PixL;}
		if (posf=='Y'){return PiyL;}
	}
	if (strcasecmp(typef,"FG")==0)
	{ 
		if (posf=='X'){return PixG;}
		if (posf=='Y'){return PiyG;}
	}
}	
/****************************************************************/
/* Funci que defineix els color, mxim 255 color, 		*/
/* i el primer color qu ees defineix es el que fara de 	        */
/* background							*/
/****************************************************************/
int def_colors (gdImagePtr img, char *nom,int *color,int defcol)
{
	FILE *fe;
	int fi;
	int r,g,b;
	int i,ret,aux,param;
	char linia[80];
	
	if (defcol==1)
	{
		i=0;fi=0;
		fe=fopen (nom, "r");
		do
		{			
			bzero (linia,80);
			fi = fscanf (fe,"%[^\n]\n", linia);
			ret = read_line(linia);
			if (ret != -1)
			{
				if (ret < 3) 
				{
					printf ("%s\n",linia);
					merror (9);
				}
				param=0;
				aux = sscanf(arg[param].nom,"%i",&r);
				param++;
				aux = sscanf(arg[param].nom,"%i",&g);
				param++;
				aux = sscanf(arg[param].nom,"%i",&b);
				color[i]= gdImageColorAllocate(img, r, g, b);
			}
			i++;
		} while (!feof(fe));
		fclose (fe);	
	}
	else
	{
		color[0]= gdImageColorAllocate(img, 255, 255, 255); 
		color[1]= gdImageColorAllocate(img, 0, 0, 0);
		color[2]= gdImageColorAllocate(img, 255, 0, 0);
		color[3]= gdImageColorAllocate(img, 0, 255, 0);
		color[4]= gdImageColorAllocate(img, 0, 0, 255);
		color[5]= gdImageColorAllocate(img, 255, 255, 0);
		color[6]= gdImageColorAllocate(img, 255, 0, 255);
		color[7]= gdImageColorAllocate(img, 0, 255, 255);
		color[8]= gdImageColorAllocate(img, 255, 128,  64);
		color[9]= gdImageColorAllocate(img, 120, 120, 120);
		color[10]= gdImageColorAllocate(img, 230, 230, 230);
		i=10;
	}	
	return i;
}

			
/****************************************************************/
/************** FUNCIONS DE PRIMER NIVELL ***********************/
/****************************************************************/

/****************************************************************/
/* Aquesta fucnio obre el fitxer i guarda en una taula en els  	*/
/* camps que ens interessen. Ja sigui com a etiquetes o com a 	*/
/* valors 							*/
/****************************************************************/

int interessen (char *nom, label *lbl, indata *dt,double *mx, int 
*mlon,double
*all, double *maxf,int *lonlab, double *max_args)
{
	FILE *fe;
	int fi = 0; 
	double d1;
	int k,nl,nd;
	double sumafila;
	int ret, narg;
	char ant[500]; 
	char linia[500];
	int lon;
	int numlinia=0;
	
	fe = fopen( nom, "r");
	k=0;
	nd=0;
	while (nd < mdat)
	{
		max_args[nd]=0;
		nd++;
	}
	do
	{	
		fi = fscanf (fe,"%[^\n]\n", linia);	
		sumafila=0.0;	
		ret = read_line(linia);
		numlinia++;
		if (ret != -1)
		{
			if (ret<marg) 
			{
				printf ("en la linia %i\n",numlinia);
				merror(3);
			}
			lon=0;
			narg=0;
			while (narg < ret)
			{
				nl=0;
				while (nl < mlab)
				{
					if (lab[nl]==narg)
					{
						lon=strlen(lbl[k].nom);
						if (lon==0)
						{
						        sprintf(lbl[k].nom,"%s",arg[narg].nom);
						}
						else
						{
							sprintf(ant,"%s",lbl[k].nom);
							sprintf(lbl[k].nom,"%s %s",ant,arg[narg].nom);
						}
					}
					lon=strlen(lbl[k].nom);
					if(lon>*lonlab){*lonlab=lon;}
					nl++;
				}
				lon=strlen(lbl[k].nom);
				if (lon > *mlon) {*mlon=lon;}
				nd=0;lon=0;
				while (nd <mdat)
				{
					if (dat[nd]==narg)
					{
						lon=strlen(dt[k].d1);
						if (lon==0)
						{
							sprintf(dt[k].d1,"%s",arg[narg].nom);
						}
						else
						{
							sprintf(ant,"%s",dt[k].d1);
							sprintf(dt[k].d1,"%s %s",ant,arg[narg].nom);
						}
						sscanf(arg[narg].nom,"%lf", &d1);
						max_args[nd]+=d1;
						*all += d1;
						sumafila += d1;
					}
					nd++;
				}
				if (d1 > *mx) { *mx = d1; }
				if (sumafila > *maxf) {*maxf=sumafila;}
				narg++;
			}
			k++;
		}
		bzero (linia, 255);	
	} while (!feof(fe));
	fclose (fe);
	return (k);
}
/********************************************************/
/* Funci que dibuixa els eixos de coordenades de les	*/
/* les grfiques de columnes.				*/
/********************************************************/

void eixos (gdImagePtr img, int color, double mx, int ey,int ex,char 
*of,char *oper, char *tfn, char* kin)
{
	char str[100];
	double pos, lon;
	double y, mult;
	int i;
	char c;
	double num;
	
	c='%';


//######### Roberto PATCH ##############################
        if (    (strcasecmp(typeG,"I")==0) || (strcasecmp(typeG,"R")==0)
             || (strcasecmp(typeG,"X")==0) || (strcasecmp(typeG,"N")==0)                                         )

        {
           if (RBACK==1)            // new layout - like EXCEL
           {
             FX=FX-7-5;
             if (strcasecmp(typeG,"R")==0)   gdImageRectangle(im, EX, 27, FX, EY, colors[1]);
             else    gdImageRectangle(im, EX, 20, FX, EY, colors[1]);
             gdImageLine(img, ex,   30, ex, ey+7, color);   // Y AXIS 
	     gdImageLine(img, ex-7, ey, ex, ey,   color);   // X AXIS 
           }
           else
           {
              y=20;
       	      gdImageLine(img, ex, y, ex+3, y+7, color);
   	      gdImageLine(img, ex, y, ex-3, y+7, color);

              x=FX;
  	      gdImageLine(img, x-7, ey+3, x, ey, color); 
	      gdImageLine(img, x-7, ey-3, x, ey, color); 
              gdImageLine(img, ex,   20, ex, ey+7, color);   // Y AXIS 
	      gdImageLine(img, ex-7, ey,  x, ey,   color);   // X AXIS 
           }

           // -----------------------------------------------
        } else {
	   gdImageLine(img, ex, 20, ex, ey, color);
	   gdImageLine(img, ex, ey, FX, ey, color); 
        }	
//#####################################################
	if (strcasecmp(oper,"log")==0)
	{
		y=10;
		while (y <= mx)
		{
			pos=((log10(y)/log10(mx))*(ey-20));
			sprintf (str, "%0.lf", y);
			write_IM (img,beginx,ey-pos,0,tfn,str,color);
			gdImageDashedLine(img, ex-2, ey-pos, FX, ey-pos, color);
			y=y*10;
		}
	}
	else if (strcasecmp(oper,"por")==0)
	{
		y=10;
		while (y <= 100)
		{
			pos=((y/100)*(ey-20));
			sprintf (str, "%0.lf%c", y,c);
			write_IM (img,beginx,ey-pos,0,tfn,str,color);
			gdImageDashedLine(img, ex-2, ey-pos, FX, ey-pos, color);
			y=y+10;
		}
	}
//######### Roberto PATCH ##############################
	else if ( (strcasecmp(typeG,"R")!=0) && (strcasecmp(typeG,"X")!=0) )
//######################################################
             {
		if (strcasecmp(of,"int")==0){sprintf (str, "%0.lf", mx);}
		if (strcasecmp(of,"flt")==0){sprintf (str, "%lf", mx);}
		lon=strlen(str),
		bzero (str,100);
		i=0;
		y=mx/lon;
		mult=y;	
		pos=0;
		num= (mx/10.);
		mult =num;
		for (i=1;i<=9;i++) 
		{
			pos=(mult/mx)*(ey-20);
			bzero (str,100);
			human(mult,str,kin);
//######### Roberto PATCH ##############################
        if (strcasecmp(typeG,"N")==0)  write_IM (img,beginx+20,ey-pos-8,0,tfn,str,color);
 	else                           write_IM (img,beginx,ey-pos,0,tfn,str,color);
        //if ( (strcasecmp(typeG,"N")!=0) && (strcasecmp(typeG,"I")!=0) )
  	               gdImageDashedLine(img, ex-2, ey-pos, FX, ey-pos, color);
		       mult=mult + num;
//######################################################
		}
	     }
}

/********************************************************/
/* Funci que dibuixa les diferents columnes de les 	*/
/* grfiques amb columnes.Retorna la posici on ha	*/
/* dibuixat la x					*/
/********************************************************/

int columnes (gdImagePtr img, int x, int y, int color,int ey,int py)
{
	gdImageFilledRectangle(img, x, y, x+py, ey, color);
	return (x+py-1);
}

/****************************************************************/
/* Funci que dibuixa un "tall de pastis" d'una grfic		*/
/* pastis. El dibuixa ple i amb el color disitjat 		*/
/****************************************************************/

void linia_arc(gdImagePtr img,int cx,int cy,int h,float ang, float 
ang1,int
color,char *fn,double dat,char *absol,char *oper,char *of,int ley,char* 
kin)
{
	float x, y, x1, y1, x2, y2, x3, y3, x4, y4,an,an1,an2,an3,an4,porc;
	char porcen[100];
	int px, py,lon;
	char sl[100];
	double datos;
	char c;
	
	c='%';
	px=cos_font('X',fn);
	py=cos_font('Y',fn);
	an = (ang * 2 * M_PI)/360;
	an1= (ang1 * 2 * M_PI)/360;
	an2= ang1 - ang; 
	an3= ((ang1-ang)/2)+ ang;
	an4= (an3 * 2 * M_PI)/360;
	porc=(an2*100)/360;
	bzero(sl,100);
	lon=0;
	if ((strcasecmp(of,"int")==0)||(strcasecmp(of,"flt")==0))
	{
		sscanf (absol,"%lf",&datos);
		human (datos,sl,kin);
	}
	if (strcasecmp(oper,"por")==0)
	{
		sprintf (sl,"%.1lf%c", dat,c);
	}
	lon=strlen(sl);
	y = cy + (sin(an)*(h/2));
	x = cx + (cos(an)*(h/2));
	x1 = cx + (cos(an1)*(h/2));
	y1 = cy + (sin(an1)*(h/2));
	x2 = (cx + x + x1)/3;
	y2 = (cy + y + y1)/3;
	x4 = cx + (cos(an4)*(h/2));
	y4 = cy + (sin(an4)*(h/2));
	if (an2 >= 180.0)
	{
		if (x2 < cx) { x3= cx + (cx - x2);}
		if (x2 > cx) { x3= cx - (x2 - cx);}
		if (y2 < cy) { y3= cy + (cy - y2);}
		if (y2 > cy) { y3= cy - (y2 - cy);}
		if ((x2==cx)&&(y2==cy))
		{
			if ((ang==0.0)&&(ang1==180.0))
			{
				x3=cx;
				y3=cy+1;
			}
			else if ((ang==180.0)&&(ang1==360.0))
			{
				x3=cx;
				y3=cy-1;
			}
		}
	}
	else 
	{
		x3= x2;
		y3= y2; 
	}
	if ((an3 >= 90.0 ) && (an3 < 180.0)) {x4 = x4 - (px*lon);}
	if ((an3 >= 180.0 ) && (an3 < 270.0)){x4 = x4 - (px*lon); y4 = y4 - 
py;}
	if ((an3 >= 270.0 ) && (an3 < 360.0)){x4 = x4 + 5; y4 = y4 - py;}
	
	gdImageArc(img, cx, cy, h, h, 0, 360, color);
	gdImageArc(img, cx, cy, h, h, ang, ang1, color);
	gdImageLine(img, cx, cy, x, y, color);
	gdImageLine(img, cx, cy, x1, y1, color);
	gdImageFillToBorder(img, x3, y3, color,color);
	if (ley<=1)
	{
		write_IM(img, x4 , y4, 0,fn, sl, 1);
	}
}		


/************************************************************/
/* Conversio d'una fila a columnes per poder fer grafiques  */
/************************************************************/
int fila_to_col (indata *dt, int col, double *mx, double *sm)
{
 char fi[500];
 int i=0;
 int lines=0;
 double d1=0;
 
 *sm = sumar_fila (dt[col].d1);
 lines =read_line(dt[col].d1);
 bzero(dt[col].d1,500);
 while (i<lines)
 {
	strcpy(dt[i].d1,arg[i].nom);
	sscanf(arg[i].nom,"%lf", &d1);
	if (d1 > *mx) { *mx = d1; }
	i++;
 }
 return i;
}

/***********************************************************/
/* gurarda imatge a fitxers i destruir imatge		   */
/***********************************************************/
void guardar (gdImagePtr img, char *nom,int outp)
{
FILE *out;
 
 if (outp==1)
 {	
	out = fopen(nom, "wb");
 }
 else
 {
	out = fopen("./graph.png", "wb");
 }
 gdImagePng(img, out);	 
fclose(out);
 gdImageDestroy(img);
}
/********************************************************/
/* escriu el titol de la grafica			*/
/********************************************************/	
 void pontitulo (gdImagePtr img,char *nom,char *tfont,int *EX,int 
*EY,int tx,int color)
 {
 FILE  *faux;
 char linia_cfg[500];
 char ant [500];
 char titn [500];
 int retn,param,rot, titx,tity,ctl,lon,aux,fi;
 int PX,PY;
 
 faux=fopen (nom, "r");
 do
 {
 	bzero(linia_cfg,500);
 	aux = fscanf (faux,"%[^\n]\n", linia_cfg);
	retn = read_line(linia_cfg);
 	if (retn < 3) {merror (4);}
 	PY=cos_font('Y',tfont);
 	ctl=0;
	param=0;
	if (strcasecmp(arg[param].nom, "ESTE")==0)
	{
		rot=1;
		titx=tx;
		tity=*EY/2;
		ctl=1;
	}
	else if (strcasecmp(arg[param].nom, "OESTE")==0)
	{
		rot=1;
		titx=10;
		tity=*EY/2;
		ctl=1;
	}
	else if (strcasecmp(arg[param].nom, "NORTE")==0)
	{
		rot=0;
		titx=(tx-*EX)/2;
//		titx=((img->sx)-*EX)/2;
		tity=5;
		ctl=1;
	}
	else if (strcasecmp(arg[param].nom, "SUR")==0)
	{
		rot=0;
		titx=((img->sx)-*EX)/2;
		tity=TY-20;
		ctl=1;
	}
	else 
	{
		fi = sscanf(arg[param].nom,"%i",&titx);
		param++;
		fi = sscanf(arg[param].nom,"%i",&tity);
		param++;
		fi = sscanf(arg[param].nom,"%i",&rot);
			
			
	}
	param++;
	strcpy (tfont, arg[param].nom);
	param++;
	PY=cos_font('Y',tfont);
	PX=cos_font('X',tfont);
	bzero(titn,80);
	while(param < retn)
	{
		lon=strlen(titn);
		if (lon==0)
		{
			sprintf (titn,"%s",arg[param].nom);
		}
		else
		{
			sprintf(ant,"%s",titn);
			sprintf(titn,"%s %s",ant,arg[param].nom);
		}
		param++;
	}
	if (ctl==1)
	{
		lon=strlen(titn);
		if (strcasecmp(arg[0].nom,"ESTE")==0)
		{
			write_IM(img,titx,tity+((lon/2)*PX),rot,tfont,titn,color);
		}
		if (strcasecmp(arg[0].nom,"OESTE")==0)
		{
			write_IM(img,titx,tity+((lon/2)*PX),rot,tfont,titn,color);
		}
		if (strcasecmp(arg[0].nom,"NORTE")==0)
		{
//######### Roberto PATCH ###########################
                       if ( (strcasecmp(typeG,"R")==0) ||
                            (strcasecmp(typeG,"N")==0) ||
                            (strcasecmp(typeG,"I")==0) ||
                            (strcasecmp(typeG,"X")==0) )
                       {
               		titx=*EX+(next-*EX)/2-(PX*strlen(titn)/2);
	  	        write_IM(img,titx,tity,rot,tfont,titn,color);
		       }	
	  	       else write_IM(img,titx-((lon/3)*PX),tity,rot,tfont,titn,color);
//#####################################################
		}
		if (strcasecmp(arg[0].nom,"SUR")==0)
		{
//######### Roberto PATCH ###########################
                       if ( (strcasecmp(typeG,"R")==0) ||
                            (strcasecmp(typeG,"N")==0) ||
                            (strcasecmp(typeG,"X")==0) ||
                            (strcasecmp(typeG,"I")==0) )
                       {
               		titx=*EX+(next-*EX)/2-(PX*strlen(titn)/2);
			write_IM(img,titx,5+tity,rot,tfont,titn,color);
		       }	
	  	       else write_IM(img,titx,tity,rot,tfont,titn,color);
//#####################################################
	  	       
		}
	}
	else
	{	
	 write_IM(img,titx,tity,rot,tfont,titn,color);
	 if ((titx > 0)&&(titx < *EX)&&(tity>20)&&(tity<*EY)&&(titx > beginx))
	 {
		beginx=titx + PY+ 5;
		*EX= *EX + beginx;
	 }
	 if ((titx > *EX)&&(tity > *EY)&&(tity < beginy))
	 {
		beginy=TY-(TY-(tity-PY));
		*EY= beginy - (TY-*EY);
	 }
	}
	ctl=0;
 }while (!feof(faux));
 fclose(faux);
}





/********************************************************/
/* escriu el titol de la grafica			*/
/********************************************************/
void ponleyenda (gdImagePtr img,char *nom,int *EX,int *EY,int tx,int
mley,int nley,int lley, int *color, int max_col)
 {
 FILE  *faux;
 char linia_cfg[500];
 char tfont [3];
 int retn,param, titx,tity,aux,i,fi, lon;
 int PX,PY,row;
 
 param=0;
 faux=fopen (nom,"r");
 bzero(linia_cfg,255);
 aux = fscanf (faux,"%[^\n]\n", linia_cfg);
 retn = read_line(linia_cfg);
 if (strcasecmp(arg[param].nom, "ESTE")==0)
 {


    //###################################################### 
    //######### Roberto PATCH ##############################
    //###################################################### 
    if (     (strcasecmp(typeG,"R")==0) 
          || (strcasecmp(typeG,"N")==0)
          || (strcasecmp(typeG,"X")==0) )
    {
  	strcpy (tfont, "FM");          // CONST FM .... sorry :(
       	PX=cos_font('X',tfont);
	PY=cos_font('Y',tfont);
	titx=tx;
	tity=(*EY/2)-(PY*(nley/2));
	FX=titx-(mley*(PX-1)); 
	i=2;
	first=0;

        // the value is next changed at the end of the loop for according
        FX=FX+10;
	tity=(TY/2)-((countflow*15)/2)+7;
//        if (strcasecmp(typeG,"R")==0) 
        gdImageRectangle(img, FX, tity-8,FX+more-15 ,tity+y+15*countflow-5, colors[1]);
        for (count=0; count<countflow; count++)
        {
                // OLD CODE write label
		if (max_col == i) { i=2; }
		if (flow_names[count][0]=='+')
                {
  		    if (first==0) first=tity-9;
  		    else first=first+11; 
                    if (strcasecmp(typeG,"R")==0) 
    		       write_IM(img, FX+6+12+15 , first, 0,tfont, &flow_names[count][1], color[1]);
                    else 
    		       write_IM(img, FX+6+12 , first, 0,tfont, &flow_names[count][1], color[1]);
  		    i--;
                }
		else
		{
		   first=0;

                   x=FX+8;
                   y=tity;
                   size=3;

                   if (strcasecmp(typeG,"R")==0) 
                   {
                     gdImageLine(img,x-4,y,x+15+2,y,colors[i]);
                     pattern(x+7,y,i,3);
  		     write_IM(img, FX+6+12+15 , tity-5, 0,tfont, flow_names[count], color[1]);
                    }
                    else
                    {
                       if ((RPATTERN==1) && (strcasecmp(typeG,"X")) )pattern(x,y,i,3);
                       else
                       {
                          size=3;
                          gdImageFilledRectangle(img, x-size, y-size, x+size,y+size, colors[i]);
                          gdImageRectangle(img, x-size, y-size, x+size,y+size, colors[1]);
                       }   
   	   	       write_IM(img, FX+6+12 , tity-5, 0,tfont, flow_names[count], color[1]);
                    }
  		}
		tity+=15;
		i++;
	}
	FX=FX-10;
    }
    else
    {
	param++;
	strcpy (tfont, arg[param].nom);
	PX=cos_font('X',tfont);
	PY=cos_font('Y',tfont);
	titx=tx;
	tity=(*EY/2)-(PY*(nley/2));
	FX=titx-(mley*PX); 
	param++; i=2;
	while (param < retn)
	{			
		if (max_col == i) { i=2; }
                if (strcasecmp(typeG,"I")==0)	
                {
                   x=FX+8;
                   y=tity;
                   size=3;
                     gdImageFilledRectangle(img, x-size, y-size, x+size,y+size, colors[i]);
                     gdImageRectangle(img, x-size, y-size, x+size,y+size, colors[1]);
  		     write_IM(img, FX+6+12 , tity-5, 0,tfont, flow_names[count], color[1]);
                   
                }   
                else gdImageFilledRectangle(img, FX+5, tity, FX+10, tity+5, color[i]);
                write_IM(img, FX+17 , tity-5, 0,tfont, arg[param].nom, color[1]);
		tity+=10;
		param++;i++;
	}
    }
    //######################################################################## 
    //######################################################################## 
    
	
 }
 else if (strcasecmp(arg[param].nom, "OESTE")==0)
 {

	param++;
	strcpy (tfont, arg[param].nom);
	PX=cos_font('X',tfont);
	PY=cos_font('Y',tfont);
	titx=10;
	tity=(*EY/2);
	param++; i=2;
	while (param < retn)
	{			
		if (max_col == i) { i=2; }
		
gdImageFilledRectangle(img,titx,tity-(PY*(nley/2)),titx+5,tity-(PY*(nley/2))+5,color[i]);
		write_IM(img, titx+10 , tity-(PY*(nley/2))-5, 0,tfont, 
arg[param].nom, color[1]);
		tity+=10;
		param++;i++;
	}
 }	
 else if (strcasecmp(arg[param].nom, "NORTE")==0)
 {
	param++;
	strcpy (tfont, arg[param].nom);
	PX=cos_font('X',tfont);
	PY=cos_font('Y',tfont);
	titx=((tx-20-*EX)/2) ;
	tity=5;
	param++; i=2;
	while (param < retn)
	{			
	 if (max_col == i) { i=2; }
	 lon=strlen(arg[param].nom);
	 gdImageFilledRectangle(img, 
titx-((lley*PX)/2),tity,titx-((lley*PX/2))+5, tity+5, color[i]);
	 write_IM(img, titx-((lley*PX)/2)+10 , tity-5, 0,tfont, 
arg[param].nom, color[1]);
	 titx+=(lon*PX)+20;
	 param++;i++;
	}
 }
 else if (strcasecmp(arg[param].nom, "SUR")==0)
 {

	param++;
	strcpy (tfont, arg[param].nom);
	PX=cos_font('X',tfont);
	PY=cos_font('Y',tfont);
	titx=(tx-20-*EX)/2;
	tity=TY-20;
	param++; i=2;
	while (param < retn)
	{			
	 if (max_col == i) { i=2; }
	 lon=strlen(arg[param].nom);
	 gdImageFilledRectangle(img, 
titx-((lley*PX)/2),tity,titx-((lley*PX/2))+5, tity+5, color[i]);
	 write_IM(img, titx-((lley*PX)/2)+10 , tity-5, 0,tfont, 
arg[param].nom, color[1]);
	 titx+=(lon*PX)+20;
	 param++;i++;
	}
 }
 else 
 {
	fi = sscanf(arg[param].nom,"%i",&row);
	titx = row;
	param++;
	fi = sscanf(arg[param].nom,"%i",&row);
	tity = row;
	param++;
	strcpy (tfont, arg[param].nom);
	param++; i=2;
	while (param < retn)
	{			
		if (max_col == i) { i=2; }
		gdImageFilledRectangle(img, titx, tity, titx+5, tity+5, color[i]);
		write_IM(img, titx+10 , tity-5, 0,tfont, arg[param].nom, color[1]);
		tity+=10;
		param++;i++;
	}		
 }
 fclose(faux);
}
/***********************************************************/
/* redimensionar la  imatge i destruir la antiga	   */
/***********************************************************/
gdImagePtr resize (gdImagePtr img, int src_x,int src_y,int rez, char
*nom,
int *color,int defcol,int *max_c)
{	
 gdImagePtr f_im;
 
 f_im = gdImageCreate(src_x+rez,src_y);
 *max_c=def_colors(f_im, nom, color,defcol);
 gdImageCopyResized(f_im,img,0,0,0,0,src_x,src_y,src_x,src_y);
 gdImageDestroy(img);
 return f_im;
}





int interessen2 (char *nom, label *lbl, indata *dt,double *mx, int *mlon,double
*all, double *maxf,int *lonlab, double *max_args)
{
	FILE *fe;
	int fi = 0; 
	double d1;
	int k,nl,nd;
	double sumafila;
	int ret, narg;
	char ant[500]; 
	char linia[500];
	int lon;
	int numlinia=0;
	
	fe = fopen( nom, "r");
	k=0;
	nd=0;
	while (nd < mdat)
	{
		max_args[nd]=0;
		nd++;
	}
	do
	{	
		fi = fscanf (fe,"%[^\n]\n", linia);	
		sumafila=0.0;
		ret = read_line(linia);
		numlinia++;
		if (ret != -1)
		{
			if (ret<marg) 
			{
				printf ("en la linia %i\n",numlinia);
				merror(3);
			}
			lon=0;
			narg=0;
			while (narg < ret)
			{
				nl=0;
				while (nl < mlab)
				{
					if (lab[nl]==narg)
					{
						lon=strlen(lbl[k].nom);
						if (lon==0)
						{
							sprintf(lbl[k].nom,"%s",arg[narg].nom);
						}
						else
						{
							sprintf(ant,"%s",lbl[k].nom);
							sprintf(lbl[k].nom,"%s %s",ant,arg[narg].nom);
						}
					}
					lon=strlen(lbl[k].nom);
					if(lon>*lonlab){*lonlab=lon;}
					nl++;
				}
				lon=strlen(lbl[k].nom);
				if (lon > *mlon) {*mlon=lon;}
				nd=0;lon=0;
				while (nd <mdat)
				{
					if (dat[nd]==narg)
					{
						lon=strlen(dt[k].d1);
						if (lon==0)
						{
							sprintf (dt[k].d1,"%s",arg[narg].nom);
						}
						else
						{
							sprintf(ant,"%s",dt[k].d1);
							sprintf(dt[k].d1,"%s %s",ant,arg[narg].nom);
						}
						sscanf(arg[narg].nom,"%lf", &d1);
						max_args[nd]+=d1;
						*all += d1;
						sumafila += d1;
					}
					nd++;
				}
				if (d1 > *mx) { *mx = d1; }
				if (sumafila > *maxf) {*maxf=sumafila;}
				narg++;
			}
			k++;
		}
		bzero (linia, 255);	
	} while (!feof(fe));
	fclose (fe);
	return (k);
}

/*************************************************************/
/***************** PROGRAMA PRINCIPAL ************************/
/*************************************************************/

main (int argc, char *argv[]) 
{
	int div=0;
	
pid=getpid();
sprintf (Dtitle,"/tmp/tit%i", pid);
sprintf (Dlegend,"/tmp/leg%i", pid);
sprintf (Dcolor,"/tmp/col%i", pid);
sprintf (Dlin,"/tmp/lin%i",pid);
sprintf (Drm,"rm -f /tmp/*%i",pid);
marg=0;
mlab=0;
mdat=0;
mley=1;
strcpy(OF,"int");
strcpy(kind,"B");
strcpy(Oper,"nop");

if (argc < 3) { merror(2);}

if (strcasecmp(argv[1],"-cfg")==0)
{
	param=1;
}
else 
{
	param=2;
}
zx = TX/2;
zy = TY/2;	
w = TY-150;
i =0;
sprintf(font,"FS");	
bzero (vant, 50);

/****************************************************************/
/* Bucle que recull els parametres d'entrada 			*/
/****************************************************************/
	
while ((param < argc)&&(conf==0))
{
	if (strcasecmp(argv[param],"-CFG")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		conf=1;
		strcpy (CFG, argv[param]);
		bzero(test,80);
		sprintf (test,"test -s %s\n",CFG);
		if (system(test)!=0)
		{
			printf ("ERROR: %s\n",CFG);
			merror(6);
		}
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-DC")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		defcolors=1;
		strcpy (Dcolor, argv[param]);
		bzero(test,80);
		sprintf (test,"test -e %s\n",Dcolor);
		if (system(test)!=0)
		{
			printf ("ERROR: %s\n",Dcolor);
			merror(6);
		}
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-S")==0)
	{
		param++;
		strcpy (typeG, "S");
		continue;
	}
	if (strcasecmp(argv[param],"-EUROS")==0)
	{
		param++;
		strcpy (kind,"E");
		continue;
	}
	if (strcasecmp(argv[param],"-C")==0)
	{
		param++;
		strcpy (typeG, "C");
		continue;
	}
	if (strcasecmp(argv[param],"-LA")==0)
	{
		param++;
		strcpy (typeG, "LA");
		acum=1;
		continue;
	}
	if (strcasecmp(argv[param],"-L")==0)
	{
		param++;
		strcpy (typeG, "L");
		continue;
	}
	if (strcasecmp(argv[param],"-T")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		title=1;
		strcpy (Dtitle, argv[param]);
		bzero(test,80);
		sprintf (test,"test -e %s\n",Dtitle);
		if (system(test)!=0)
		{
			printf ("ERROR: %s\n",Dcolor);
			merror(6);
		}
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-LEG")==0)
	{
		param++;
		if ((param>=argc) || (strncmp(argv[param],"-",1)!=0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		legend=1;
		strcpy (Dlegend, argv[param]);
		bzero(test,80);
		sprintf (test,"test -e %s\n",Dlegend);
		if (system(test)!=0)
		{
			printf ("ERROR: %s\n",Dcolor);
			merror(6);
		}
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-O")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		output=1;
		strcpy (Oname, argv[param]);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-OP")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		strcpy (Oper, argv[param]);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-E")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		strcpy (OF, argv[param]);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-F")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		strcpy (font, argv[param]);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-MUL")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		mull=1;
		sscanf(argv[param],"%i",&mult);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-FIL")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		fil=1;
		sscanf(argv[param],"%i",&fila);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-ESP")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		esp=1;
		sscanf(argv[param],"%i",&espacio);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-XES")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		espx=1;
		sscanf(argv[param],"%i",&espax);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-SUM")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		others=1;
		strcpy (OTROS, argv[param]);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-DIV")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		div=1;
		sscanf(argv[param],"%i",&divd);
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-MXC")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		sscanf(argv[param],"%i",&row);
		MXC=row;
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-TX")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		sscanf(argv[param],"%i",&row);
		TX=row;
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-TY")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		sscanf(argv[param],"%i",&row);
		TY=row;
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-LMAX")==0)
	{
		param++;
		if ((param>=argc)||(strncmp(argv[param],"-",1)==0))
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7); 
		}
		sscanf(argv[param],"%s",lmax);
		limax=1;
		param++;
		continue;
	}
	if (strcasecmp(argv[param],"-LAB")==0)
	{
		param++;i=0;
		while ((param < argc)&&(strncmp(argv[param],"-",1)!=0) )
		{
			fi = sscanf(argv[param],"%i",&row);
			lab[i] = row;
			if (lab[i]> marg) { marg = lab[i]; }
			param++;i++;
		}
		if (i==0)
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7);
		}
		mlab=i;
		continue;
	}
	if (strcasecmp(argv[param],"-DAT")==0)
	{
		param++;i=0;
		while ( (param < argc)&&(strncmp(argv[param],"-",1)!=0) )
		{
			fi = sscanf(argv[param],"%i",&row);
			dat[i] = row;
			if (dat[i]> marg) { marg = dat[i]; }
			param++;i++;
		}
		if (i==0)
		{
			printf ("ERROR: %s\n",argv[param-1]);
			merror(7);
		}
		mdat=i;
		continue;
	}
	merror(1);
}
/****************************************************************/
/* Configuracio de les vairbales d'entorn a partir d'un fitxer	*/
/* de configuracio definit per l'usuari				*/
/****************************************************************/

if (conf==1)
{
	faux=fopen (CFG,"r");
	aux = 1;
	do
	{
		param=0;
		bzero (linia_cfg, 255);
		aux = fscanf (faux,"%[^\n]\n", linia_cfg);
		retn = read_line(linia_cfg);
		if (retn != -1)
		{

//######### Roberto PATCH ##############################
			if (strcasecmp(arg[param].nom,"RPATTERN")==0)
			{
                                RPATTERN=1;
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				sscanf(arg[param].nom,"%i",&PATTERNVALUE);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"RBACK")==0)
			{
                                RBACK=1;
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"RFILL")==0)
			{
                                RFILL=1;
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"RZERO")==0)
			{
                                RZERO=1;
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"RXSIZE")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				sscanf(arg[param].nom,"%i",&GlobalXSIZE);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"RYSIZE")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				sscanf(arg[param].nom,"%i",&GlobalYSIZE);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"RLINES")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				sscanf(arg[param].nom,"%i",&GlobalLINES);
				param++;
				continue;
			}
//#####################################################


			if (strcasecmp(arg[param].nom,"TYPE")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				strcpy (typeG, arg[param].nom);	
				if (strcasecmp (typeG,"LA")==0){ acum=1;}
				continue;
			}
			if (strcasecmp(arg[param].nom,"EUROS")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				strcpy (kind,"E");
				continue;
			}
			if (strcasecmp(arg[param].nom,"FONT")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				strcpy (font, arg[param].nom);
				continue;
			}
			if (strcasecmp(arg[param].nom,"EJE")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				strcpy (OF, arg[param].nom);
				continue;
			}
			if (strcasecmp(arg[param].nom,"MUL")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto\n",arg[(param-1)].nom);
					merror(8);
				}
				mull=1;
				sscanf(arg[param].nom,"%i",&mult);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"DIV")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				div=1;
				sscanf(arg[param].nom,"%i",&divd);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"FILA")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				fil=1;
				sscanf(arg[param].nom,"%i",&fila);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"ESP")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				esp=1;
				sscanf(arg[param].nom,"%i",&espacio);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"XES")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				espx=1;
				sscanf(arg[param].nom,"%i",&espax);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"SUM")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				others=1;
				strcpy (OTROS, arg[param].nom);
				continue;
			}
			if (strcasecmp(arg[param].nom,"OUTPUT")==0)
			{
				param++;
				strcpy (Oname, arg[param].nom);
				output=1;
				continue;
			}
			if (strcasecmp(arg[param].nom,"INPUT")==0)
			{
				param++;
				strcpy (Iname, arg[param].nom);
				input=1;
				continue;
			}
			if (strcasecmp(arg[param].nom,"OPER")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				strcpy (Oper, arg[param].nom);
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"COLOR")==0)
			{
				if (retn < 4)
				{
					printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
					merror(8);
				}
				param++;
				bzero(titn,80);
				while (param<retn)
				{
					lon=strlen(titn);
					if (lon==0)
					{
						sprintf (titn,"%s",arg[param].nom);
					}
					else
					{
						sprintf(ant,"%s",titn);
						sprintf(titn,"%s %s",ant,arg[param].nom);
					}
					param++;
				}
				faux2=fopen (Dcolor, "a");
				fprintf (faux2,"%s\n",titn);
				fclose (faux2);
				defcolors=1;
				continue;
			}
			if (strcasecmp(arg[param].nom,"TITLE")==0)
			{
				param++;
				bzero(titn,80);
				if (retn < 3)
				{
					printf("ERROR: parametro %s incorrecto\n",arg[(param-1)].nom);
					merror(8);
				}
				while (param<retn)
				{
					lon=strlen(titn);
					if (lon==0)
					{
						sprintf (titn,"%s",arg[param].nom);
						
if(strcasecmp(arg[param].nom,"OESTE")==0){toeste=1;}
						
if(strcasecmp(arg[param].nom,"ESTE")==0){teste=1;}
						
if(strcasecmp(arg[param].nom,"SUR")==0){sur=1;}
					}
					else
					{
						sprintf(ant,"%s",titn);
						sprintf(titn,"%s %s",ant,arg[param].nom);
					}
					param++;
				}
				faux2=fopen (Dtitle, "a");
				fprintf (faux2,"%s\n",titn);
				fclose (faux2);
				title=1;
				continue;
			}
			if (strcasecmp(arg[param].nom,"LEGEND")==0)
			{
				param++;
				bzero(titn,80);
				if (retn < 4)
				{
					printf("ERROR: parametro %s incorrecto\n",arg[(param-1)].nom);
					merror(8);
				}
				aley=0;mley=0;
				while (param<retn)
				{
					lon=strlen(titn);
					if (lon==0)
					{
						sprintf (titn,"%s",arg[param].nom);
						
if(strcasecmp(arg[param].nom,"OESTE")==0){loeste=1;}
						
if(strcasecmp(arg[param].nom,"ESTE")==0){leste=1;}
						
if(strcasecmp(arg[param].nom,"SUR")==0){sur=1;}
					}
					else
					{
						sprintf(ant,"%s",titn);
						sprintf(titn,"%s %s",ant,arg[param].nom);
					}
					aley=lon;
					lon=strlen(titn);
					if ((lon-aley)>mley) { mley=lon-aley;}
					param++;
				}
				nley=retn-4;
				lley=lon;


     if (      (strcasecmp(typeG,"R")==0) 
            || (strcasecmp(typeG,"X")==0) 
            || (strcasecmp(typeG,"N")==0) )
     {
        //######################################################################## 
        // ROBERTO PATCH
        //######################################################################## 
        //printf(" line_cfg =  %s \n",linia_cfg);
        strcpy(line,linia_cfg);
	countflow=0;
	maxflow=0;
        // searching flow name in this format "NAME FLOW 1"   "NAME FLOW 2"
        for (count=0; count<strlen(line); count++)
        {
          if (line[count]=='?') first=count;
          if (line[count]=='+') 
          {                      // match new name 
             last=count;
             strncpy(flowname,&line[first+1],last-first);
             flowname[last-first-1]='\0';
             //printf(" flowname =  %s \n",flowname);
             strcpy(flow_names[countflow],flowname);
             countflow++;
             if (strlen(flowname)>maxflow) maxflow=strlen(flowname); 
             first=count-1;
          }
          if (line[count]=='!') 
          {                      // match new name 
             last=count;
             strncpy(flowname,&line[first+1],last-first);
             flowname[last-first-1]='\0';
             //printf(" flowname =  %s \n",flowname);
             strcpy(flow_names[countflow],flowname);
             countflow++;
             if (strlen(flowname)>maxflow) maxflow=strlen(flowname); 
          }
        }
        nley=countflow; 
        mley=maxflow;
        //######################################################################## 
        //######################################################################## 
     }

				faux2=fopen (Dlegend, "a");
				fprintf (faux2,"%s\n",titn);
				fclose (faux2);
				legend=1;
				continue;
			}
			if (strcasecmp(arg[param].nom,"TX")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				sscanf(arg[param].nom,"%i",&row);
				TX=row;
				continue;
			}
			if (strcasecmp(arg[param].nom,"TY")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				sscanf(arg[param].nom,"%i",&row);
				TY=row;
				continue;
			}
			if (strcasecmp(arg[param].nom,"LMAX")==0)
			{
				param++;
				if (param>=retn)
				{
					printf ("ERROR: %s\n",arg[param-1].nom);
					merror(8); 
				}
				sscanf(argv[param],"%i",&lmax);
				limax=1;
				continue;
			}
			if (strcasecmp(arg[param].nom,"MXC")==0)
			{
				param++;
				if (param>=retn)
				{
					printf("ERROR: parametro %s incorrecto\n",arg[(param-1)].nom);
					merror(8);
				}
				sscanf(arg[param].nom,"%i",&row);
				MXC=row;
				param++;
				continue;
			}
			if (strcasecmp(arg[param].nom,"LAB")==0)
			{
				param++;i=0;
				while (param < retn) 
				{
					fi = sscanf(arg[param].nom,"%i",&row);
					lab[i] = row;
					if (lab[i]> marg) { marg = lab[i]; }
					param++;i++;
				}
				if (i==0)
				{
					printf ("ERROR: %s\n",argv[param-1]);
					merror(8);
				}
				mlab=i;
				continue;
			}
			if (strcasecmp(arg[param].nom,"DAT")==0)
			{
				param++;i=0;
				while (param < retn)
				{
					fi = sscanf(arg[param].nom,"%i",&row);
					dat[i] = row;
					if (dat[i]> marg) { marg = dat[i]; }
					param++;i++;
				}
				if (i==0)
				{
					printf ("ERROR: %s\n",argv[param-1]);
					merror(8);
				}
				mdat=i;
				continue;
			}
			printf("ERROR: parametro %s incorrecto \n",arg[param].nom);
			merror(8);
		}
	} while (!feof(faux));
	fclose (faux);
}
	
/****************************************************************/
/* Crea la imatge i fa reserva de memoria per les taules 	*/
/****************************************************************/
beginx=5;
beginy=TY-5;
FX=TX-20;

/*sz=10.;
err=gdImageStringTTF(NULL,&brect[0],0,f,sz,0.,0,0,f);
if(err) {printf("%s\n",err);}*/
im = gdImageCreate(TX,TY);
if (input==1)
{
	sprintf (test,"test -s %s\n",Iname);
	if (system(test)!=0){printf ("%s\n",argv[1]);merror(6);}
	sprintf (syst,"cat %s |wc -l > %s ", Iname,Dlin);
}
else 
{
	
	sprintf (test,"test -s %s\n",argv[1]);
	if (system(test)!=0){ printf ("%s\n",argv[1]);merror(6);}
	sprintf (syst,"cat %s |wc -l > %s ", argv[1],Dlin);
}
system (syst);
faux=fopen (Dlin, "r");
fi = fscanf(faux,"%i",&mem);
tlabel=(label*)(malloc(sizeof(label)*mem));
if (tlabel==NULL) 
{
	printf("Can't allocate enough memory.\n");
	exit(0);
}

data=(indata*)(malloc(sizeof(indata)*mem));
if (data==NULL) 
{
	printf("Can't allocate enough memory.\n");
	exit(0);
}
max_args=(double*)(malloc(sizeof(double)*mdat));
if (max_args==NULL)
{
        printf("Can't allocate enough memory.\n");
        exit(0);
}


/****************************************************************/
/* Defineix colors 					        */
/****************************************************************/

max_col=def_colors(im, Dcolor, colors,defcolors);
				
/****************************************************************/
/* Llegeix fitxer d'entrada 					*/
/****************************************************************/
max=0.0;
mxf=0;
ml=0;
if (input==1)
{
	lines =interessen(Iname,tlabel, data, &max, &ml, 
&sum,&mxf,&lonlabel,max_args);
}
else
{
	lines =interessen(argv[1],tlabel, data, &max, &ml, 
&sum,&mxf,&lonlabel,max_args);
}
if (fil==1)
{
	if (fila<lines)
	{
		lines=0;
		lines = fila_to_col(data,fila,&max,&sum); 
	}
	else
	{
		merror(11);
	}
}
if (mull==1){emax= max*mult;}
else if (div==1){emax= max/divd;}
else{emax= max;}
if (strcasecmp(typeG,"LA")==0) { emax=mxf;}


/****************************************************************/
/* Clacula els punts on posicionar l'eix en fucnio de la 	*/
/* llargada de les etiquetes en l'eix X , en l'exi Y.		*/
/****************************************************************/

EY=0;
pyy=cos_font('Y',font);
beginy= TY-pyy-10;
pxx=cos_font('X',font);
if (strcasecmp(OF,"tim")==0)
{
	sprintf (sl,"00H 00m\n");
	ml=strlen (sl);
}
EY=beginy-(ml*pxx);

if ((strcasecmp(OF,"int")==0)|| (strcasecmp(OF,"flt")==0))
{
	sprintf(sl,"000.00 BB");
}
if (strcasecmp(Oper,"log")==0)
{
	sprintf(sl,"%.0lf",emax);
}
if (strcasecmp(Oper,"por")==0)
{
	sprintf(sl,"00.0%");
}
xl=strlen (sl);
EX=10+(xl*pxx);

if (toeste==1) 
{
	beginx=5+pxx+15;
	EX=EX+beginx;
}
if (loeste==1) 
{
	beginx=(mley*pxx)+15;
	EX=EX+beginx;
}
if (sur==1) {EY=EY-pyy;}
if (teste==1){more=20;}
if (leste==1){more=mley*pxx;}

//######### Roberto PATCH ##############################
if  (strcasecmp(typeG,"X")==0)  
    more=mley*(pxx+1)+40;
if  (strcasecmp(typeG,"R")==0)  
    more=mley*(pxx+1)+50;
if (strcasecmp(typeG,"N")==0) 
    more=mley*(pxx+1)+40;

//######################################################		



/****************************************************************/
/* Dibuixa Grafica de Pastis(Sectores)				*/
/****************************************************************/

if (strcasecmp(typeG,"S")==0)
{		
	i=2;
	eje=0;
	j=0;
	if (strcasecmp(OF,"int")==0)
	{
		sprintf(sl,"%.0lf",emax);
	}
	if (strcasecmp(Oper,"por")==0)
	{
		sprintf(sl,"000.0%");
	}
	if (strcasecmp(OF,"flt")==0)
	{
		sprintf(sl,"%lf",emax);
	}
	xl=strlen (sl);
	zx=(w/2)+(xl*pxx)+5;
	w = (TX-((xl*pxx)*2)+(lonlabel*pxx)+10)/2;
/*	if (more > TX)
	{
		im=resize(im,TX,TY,(more-TX)+10,Dcolor,colors,defcolors,&max_col);
	}*/
	p2=0;
	ty= TY/2;
	bzero(pctn,100);
	titx=zx+(w/2)+(xl*pxx); tity=zy-((lines/2)*pyy);
	ret= read_line(data[j].d1);
	msec=0;
	while(msec<ret)
	{
		gdImageArc(im, zx, zy, w, w, 0, 360, colors[1]);
		gdImageFillToBorder(im, zx, zy, colors[1],colors[1]);
		read_line(data[j].d1);
		bzero(pctn,100);
		percentage(pctn, arg[msec].nom,max_args[msec]);
		fin = sscanf(pctn,"%lf",&dato);
		while (j<lines)
		{
			p1=p2;
			p2 = (360 * (dato/100)) + p2 ;
			if (max_col == i) { i=2; }
			linia_arc (im, zx, zy, w, 
p1,p2,colors[i],font,dato,arg[msec].nom,Oper,OF,ret,kind);
			ty+=10;
			bzero(pctn,100);
			if ((fil==0)&&(msec==0))
			{
				gdImageFilledRectangle(im, titx, tity, titx+5, tity+5, 
colors[i]);
				write_IM(im, titx+10 , tity-5, 0,font, tlabel[j].nom, 
colors[1]);
			}
			tity+=10;i++;j++;
			read_line(data[j].d1);
			percentage(pctn, arg[msec].nom,max_args[msec]);
			fin = sscanf(pctn,"%lf",&dato);
		}
		msec++;
		gdImageArc(im, zx, zy, w, w, 0, 360, colors[1]);
		w=w-50;
		j=0;i=2;
	}
	msec--;
	if (msec>0)
	{
		gdImageArc(im, zx, zy, w, w, 0, 360, colors[0]);
		gdImageFillToBorder(im, zx, zy, colors[0],colors[0]);
		gdImageArc(im, zx, zy, w, w, 0, 360, colors[1]);
	}
	next= titx;
}


/****************************************************************/
/* Dibuica grafica de columnes i multiples columnes		*/
/****************************************************************/

if (strcasecmp(typeG,"C")==0)
{
	j=0; 
	if (MXC > 0)
	{
	  if (MXC < lines)
	  {	
		l=MXC;
		bzero (resto,100);
		while (l< lines)
		{
			off=0; ofs=0;
			fin = sscanf(data[l].d1,"%s",sl);
			sscanf(resto,"%s",ls);
			bzero (antes,100);
			rest=0;
			while (fin!=-1)
 			{
				sscanf (sl,"%lf", &dato);
				off1= strlen(sl);
				off = off + off1 +1;
				lon=strlen(resto);
				if (lon==0)
				{	
					lon=strlen(antes);
					if (lon==0)
					{
						sprintf (antes,"%0.lf",dato);
					}
					else
					{
						strcpy (ant,antes);
						sprintf(antes,"%s %0.lf",ant,dato);
					}
				}
				else
				{
					sscanf (ls,"%lf", &rest);
					ofs1= strlen (ls);
					ofs = ofs + ofs1 +1 ;
					suma = rest + dato;
					lon=strlen(antes);
					if (lon==0)
					{
						sprintf (antes,"%0.lf",suma);
					}
					else
					{
						strcpy(ant,antes);
						sprintf(antes,"%s %0.lf",ant,suma);
					}
					sscanf (&resto[ofs],"%s", ls);
				}
				fin = sscanf (&data[l].d1[off],"%s", sl);
			}
			l++;
			bzero (resto,100);
			strcpy (resto, antes);
		}
		strcpy(data[MXC].d1,resto);
		sprintf (tlabel[MXC].nom,"Resto: %i ",lines-MXC);
		if (others==0)
		{
			lines=MXC;
		}
		else 
		{
			
			if (strcasecmp(OTROS,"GRAF")==0)
			{
				lines=MXC+1;
				if (rest > max) 
				{ 
					max=rest;
					if (mull==1){emax= max*mult;}
					else if (div==1){emax= max/divd;}
					else{emax= max;}
					if (strcasecmp(OF,"int")==0)
					{
						sprintf(sl,"%.0lf",emax);
					}
					if (strcasecmp(OF,"flt")==0)
					{
						sprintf(sl,"%lf",emax);
					}
					if (strcasecmp(Oper,"por")==0)
					{
						sprintf(sl,"000");
					}
					xl=strlen (sl);
					EX=10+(xl*pxx);
					EX = EX + beginx; 
				}
			}
			else if (strcasecmp(OTROS,"TEXT")==0)
			{
				lines=MXC;
				text=1;
			}
			else
			{
				printf ("ERROR: %s\n",OTROS);
				merror(12);
			}
		}
	  }
	}
	if (limax==1)
	{
		sscanf (lmax, "%lf", &limmax);
		if (emax>limmax) 
		{ 
			merror(10);
		}
		else
		{
			emax=limmax;
			max=limmax;
			if ((strcasecmp(OF,"int")==0)||(strcasecmp(OF,"flt")==0))
			{
				sprintf(sl,"000.00 BB");
			}
			if (strcasecmp(Oper,"por")==0)
			{
				sprintf(sl,"000%");
			}
			xl=strlen (sl);
			EX=10+(xl*pxx);
			EX = EX + beginx; 
		}
	}
	
	pyy=cos_font('Y',font);
	next=EX;
	while ((j<lines)&&(final!=-1))
	{
		firstX=next;
		fin = 0; off=0;mul=2;
		if (strcasecmp(Oper,"por")==0)
		{
			bzero(pctn,100);
			sfil=sumar_fila(data[j].d1);	
			percentage(pctn, data[j].d1,sfil);	
			fin = sscanf (pctn,"%s", sl);
			if (strncmp(sl,"100",3)==0)
			{
				bzero(pctn,100);
				percentage(pctn, data[j].d1,sum);
				final = sscanf (pctn,"%s", sl);
			}
		}
		else
		{
			final = sscanf (data[j].d1,"%s", sl);
		}
		while ((fin!=-1)&&(final!=-1))
 		{
			sscanf (sl,"%lf", &dato);
			off1 = strlen(sl);
			off= off + off1 +1;
			if (strcasecmp(Oper,"log")==0)
			{
				p1= ((log10(dato))/(log10(max)));
				p2= p1*(EY-20);
			}
			else if (strcasecmp(Oper,"por")==0)
			{	
				p2=(dato/100)*(EY-20);
			}
			else
			{
				p1=(dato/max);
				p2= p1*(EY-20); 
			}
			if (max_col == mul) { mul=2; }
			next = columnes(im, next+3, EY-p2, colors[mul],EY,pyy-1);	
			mul++;
			if (strcasecmp(Oper,"por")==0)
			{
				fin = sscanf (&pctn[off],"%s", sl);
			}
			else
			{
				fin = sscanf (&data[j].d1[off],"%s", sl);
			}
			if (next > FX) 
			{
				im=resize(im,next,TY,100,Dcolor,colors,defcolors,&max_col);
				FX=FX+100;
			}
		}
		if (strcasecmp(OF,"tim")==0)
		{
			floatTotime(tlabel[j].nom);
		}
		write_IM(im, ((firstX+next-pyy)/2), beginy, 1,font, tlabel[j].nom, 
colors[1]);
		gdImageLine(im,next,EY,next,EY+3,colors[1]);
		j++;		
	}
	if (text==1)
	{
		sscanf (data[lines].d1,"%s", sl);
		xl=strlen (sl);
		p1=(xl*pxx)/max;
		p2= p1*(EY-20); 
		write_IM(im, ((firstX+next+pxx+6)/2), EY-5, 1,font,sl,colors[1]);
		write_IM(im, ((firstX+next+pxx+3)/2), beginy, 1,font, 
tlabel[lines].nom, colors[1]);
		next=next+pxx+2;
	}
}


/****************************************************************/
/* Dibuixa grafica de Linies i Multiples linies	acomulatives	*/
/****************************************************************/


//######### Roberto PATCH ##############################

fmin=99999;
fnum=99999;
if ( (strcasecmp(typeG,"N")==0) || (strcasecmp(typeG,"LA")==0) || 
     (strcasecmp(typeG,"L")==0) )
//######################################################
{
   if (RBACK==1)
      gdImageFilledRectangle(im, EX, 20, EX+(espacio)*(lines-1), EY, colors[10]);
   if (acum==1) max=mxf;
   if (espx==0) espax=10;
   if (esp==0)  espacio=10;
   j=0;
   next=EX;
   k=0;
   ret=0;
   while (ret<50)
   {
     xpatt[ret]=EX;
     ypatt[ret]=EY;
     vant[ret]=EY;
     ret=ret+1;
   }
   ret=0;
   old_next=next;
   // printf(" \n lines %d: ",lines);
   // printf(" \n next %d: ",next);
   // printf(" \n max  %lf:",max);
   while (j<lines-1)
   {
      fin = 0;
      off=0;
      mul=3;
      i=2;
      msec=0;
      ret=read_line(data[j].d1);
      while (msec<ret)
      {
	 sscanf (arg[msec].nom,"%lf", &dato);
	 if (msec==0)       vec[msec]=dato;
	 else if (acum==0)  vec[msec]=dato;
	      else          vec[msec]=vec[msec-1]+dato;
         //printf(" \n vec[msec]= %f:",vec[msec]);
  	 p1=(vec[msec]/max);
	 p2= p1*(EY-20);
  	 apoint=(EY)-p2;
	 if (max_col == i) { i=2; }
	 if (nolin==1)
	 {
            if (RPATTERN==0)
            {
               if (RFILL==1)
               {
                  gdImageLine(im,next,vant[msec],next,EY,colors[i]);
                  gdImageLine(im,next,vant[msec],next+espacio,apoint,colors[1]);
               }
               else gdImageLine(im,next,vant[msec],next+espacio,apoint,colors[i]);
            }
            if (RPATTERN==1)
            {
               if (j % PATTERNVALUE ==0)
               {
                  if (apoint!=EY) pattern(next+espacio,apoint,i,3);
                  gdImageLine(im,xpatt[msec],ypatt[msec],next+espacio,apoint,colors[i]);
                  xpatt[msec]=next;
                  ypatt[msec]=apoint;
               }
            }
	 }
	 vant[msec]=apoint;
	 i++;
	 msec++;
      }
      nolin=1;
      j++;
      next=next+espacio;
      if ((next+pxx) > FX)
      {
	 im=resize(im,next,TY,100,Dcolor,colors,defcolors,&max_col);
	 FX=FX+100;
	 next=next-(espacio);
	 j--;
	 nolin=0;
      }
      k++;
      if (RZERO==1)
      {
         fnum=atof(tlabel[j].nom);
         fnum=fabs(fnum);
         if (fnum<fmin)
         {
            //printf(" \n tlabel=  %s:",tlabel[j].nom);
            fmin=fnum;
            old_next=next;
            fpoint=apoint;
            //printf(" \n old_nextl=  %d:",old_next);
         }
      }
      if (k==espax)
      {
	 gdImageLine(im,next,EY,next,EY+5,colors[1]);
	 if (strcasecmp(OF,"tim")==0)
	 {
	    floatTotime(tlabel[j].nom);
	 }
	 write_IM(im,next-5,beginy,1,font,tlabel[j].nom, colors[1]);
	 k=0;
      }
   }
   if (RZERO==1) gdImageDashedLine(im,old_next,20,old_next,EY,colors[1]);
   if (RFILL==1) RobertoFill();
}

//######### Roberto PATCH ##############################

if (strcasecmp(typeG,"I")==0) RobertoIctGraph();
if (strcasecmp(typeG,"R")==0) RobertoNetmeterGraph();
if (strcasecmp(typeG,"X")==0) RobertoNetmeterGraph2();
sprintf(sl,"MIRA");
if (strcasecmp(typeG,"X")==0) sprintf(sl,"NETMETER");
if (strcasecmp(typeG,"N")==0) sprintf(sl,"NETMETER");
if (strcasecmp(typeG,"R")==0) sprintf(sl,"NETMETER");
if (strcasecmp(typeG,"I")==0) sprintf(sl,"ICT");
xl=strlen (sl);
write_IM(im, 10, TY-pyy-10, 0,font, sl, colors[1]);
//################################################################


	
/********************************************************/
/* Alliberar memoria i esborrar ftixers temporals	*/
/********************************************************/
/* if (eje==1)
 {
 	f_im = gdImageCreate(640,480);
 	max_col=def_colors(f_im, Dcolor, colors,defcolors);
 	gdImageCopyResized(f_im,im,0,0,0,0,640,480,next,TY);
	eixos(f_im,colors[1],emax, EY,EX,OF,Oper,fonti,kind);
 	gdImageDestroy(im);
 }*/

 if (eje==1)
 {
	FX=next;
	
im=resize(im,next+pxx,TY,more+pyy+10,Dcolor,colors,defcolors,&max_col);
 }

if (title==1) { 

pontitulo(im,Dtitle,tfont,&EX,&EY,next+pyy+3,colors[1]); }	
if (legend==1){ponleyenda(im,Dlegend,&EX, &EY, next+pyy+3+(mley*pxx),mley,nley,lley,colors,max_col);}
if (eje==1){eixos(im,colors[1],emax, EY,EX,OF,Oper,font,kind);}

guardar (im,Oname,output);
//guardar (f_im,Oname,output);

free(data);
free(tlabel);
system (Drm); 
exit (0);

} 










//#####################################################################
//#####################################################################
//#####################################################################
void RobertoIctGraph( void)
{
  int gap,x,y;
      
  im=resize(im,next,TY,2000,Dcolor,colors,defcolors,&max_col);
	if (acum==1)
	{
		max=mxf;
	}
	if (espx==0)
	{
		espax=10;
	}	
	if (esp==0)
	{
		espacio=10;
	}	
	j=0; next=EX;k=0;ret=0;
	while (ret<50)
	{
		vant[ret]=EY;
		ret=ret+1;
	}
	ret=0;
	while (j<lines-2)
	{
		fin = 0; off=0;mul=3;i=2;
		msec=0;
		ret= read_line(data[j].d1);
		while (msec<ret)
 		{
			sscanf (arg[msec].nom,"%lf", &dato);
			if (msec==0)
			{	
				vec[msec]=dato;
			}
			else if (acum==0)
			{	
				vec[msec]=dato;
			}
			else
			{
				vec[msec]=vec[msec-1]+dato;
			}
			p1=(vec[msec]/max);
			p2= p1*(EY-20);
			apoint=(EY)-p2;
			if (max_col == i) { i=2; }
			if (nolin==1)
			{
                           gap=2;
if (msec==0) gdImageLine(im,next+espacio,EY,next+espacio,apoint-gap*(msec+1),colors[i]);
else         gdImageLine(im,next+espacio,vant[msec-1]-gap*(msec+1)+1,next+espacio,apoint-gap*(msec+1),colors[i]);
gdImageLine(im,next,vant[msec]-gap*(msec+1)+1,next+espacio,apoint-gap*(msec+1)+1,colors[i]);
gdImageLine(im,next,vant[msec]-gap*(msec+1),next+espacio,apoint-gap*(msec+1),colors[1]);
			}
			vant[msec]=apoint;
			i++;
			msec++;
		}
		nolin=1;
		j++;next=next+espacio;
		k++;
		if (k==espax)
		{ 
			gdImageLine(im,next,EY,next,EY+5,colors[1]);
			floatTotime(tlabel[j].nom);
			write_IM(im,next-7,beginy-15,1,font,tlabel[j].nom, colors[1]);
			k=0;
		}	
		
	}
}
	





// #################################################################
// #################################################################
//     Make a Netmeter Graphic  (for GRAPHIC X-Y toolKIT)
// #################################################################
// #################################################################

void RobertoNetmeterGraph(void)
{

// var -----------------

  int x,y,size,x1,x2,y1,y2;
  int GraphSizeX,GraphSizeY;
  FILE *f;
  char fname[300];
  char line[300],line2[300],labelY[300],labelX[300],temps[40];
  //,xx[300],yy[300];
  int count,countx,county,countz;
  float val,val2;
  float delay,Xmin,Xmax,Ymax,Ymin,aux,last;
  float Ygap,Xgap,Xfactor,Yfactor,px,py;
  int   lastX,lastY,lineY;
  char  Xmil,Ymil,Ydec,Xlong,Ylong;
  int   ExtraLines;



  im=resize(im,next,2000,1024,Dcolor,colors,defcolors,&max_col);
// #####################################
//    Start... init local var
// #####################################
   Xmin=0;
   Xmax=0.000001;
   Ymin=0;
   Ymax=0.000001;
   Xlong=0;
   Ylong=0;

   GraphSizeX=GlobalXSIZE;
   GraphSizeY=GlobalYSIZE;
   lineY=GlobalLINES;

// #################################################################
//   Update initial IMAGE AREA of .PNG file
// #################################################################
   EX=0;
   titx=GraphSizeX+EX+30;  // pixel TRUE SIZE
   next=GraphSizeX+EX+30;
   EY=GraphSizeY+30;       // SIZE of the  AREA: Graphic X/Y AREA
   TY=EY+30;               // SIZE of the IMAGE: Graphic X/Y AREA + x_label
   beginy= TY-pyy-10;
   beginx= beginx+20;



// #################################################################
//   Open Data File
// #################################################################
   strcpy(fname,Iname);
   f=fopen(fname,"r");
   if (f==NULL) printf("\n Error .dat file not found ....!!!");


// #################################################################
//   Calculate Xmax, Ymax
// #################################################################
   while(!feof(f))
   {
     fgets(line,256,f);
     if (feof(f))  break;
     for (count=0; count<strlen(line); count++)
     {
        if (line[count]==' ')
        {
           strncpy(line2,&line[count+1],strlen(line)-count);
           line2[strlen(line)-count-3]='\0';
           line[count]='\0';
           if (strcmp(line,"NEW"))
           {
              val=atof(line);
              val2=atof(line2);

	      if (val<Xmin)  Xmin=val;
	      if (val>Xmax)  Xmax=val;

   	      if (val2<Ymin)  Ymin=val2;
	      if (val2>Ymax)  Ymax=val2;
	   }
        }
     }
   }



// #################################################################
//   Debug Watchs 
// #################################################################
   //printf("\n Xmax = %.8f",Xmax);
   //printf("\n Xmin = %.0f",Xmin);
   //printf("\n Ymax = %.8f",Ymax);
   //printf("\n Ymin = %.0f",Ymin);

// #################################################################
//   mSEC data 
// #################################################################
   Xmil=0;
   Ymil=0;
   if (Xmax<1)  Xmil=1;    // looking if the data need to be expressed to msec
   if (Ymax<1)  Ymil=1;    // looking if the data need to be expressed to msec      

   Xgap=Xmax-Xmin;
//OK too large   Xfactor=(GraphSizeX-1)/Xgap;
   Xfactor=(GraphSizeX-1-15)/Xgap;
   Ygap=Ymax-Ymin;
//OK too large   Yfactor=(GraphSizeY-1)/Ygap;
   Yfactor=(GraphSizeY-1-7)/Ygap;

   //printf("\n GraphSizeX = %d",GraphSizeX);
   //printf("\n GraphSizeY = %d",GraphSizeY);
   //printf("\n Xgap = %d",Xgap);
   //printf("\n Ygap = %d",Ygap);
   //printf("\n FactX = %.0f",Xfactor);
   //printf("\n FactY = %.0f",Yfactor);



// #####################################
//   Plot Y label and calculate Ylong
// #####################################

  ExtraLines=0;  // POWERFULL  more DASHED-LINE-VALUES do you want ??
                 // :( do you need to  reduce the X-Yfactor scale

  for (county=0; county<lineY+ExtraLines; county++) 
  {
    
     val=(Ymax/lineY)*(county+1);
     y=val*Yfactor;
    
     x1=-4;
     x2=GraphSizeX+30;
     x1=x1+EX;   // X conversion
     x2=x2+EX;   // X conversion
     y=EY-y;     // Y conversion
    
     if (Ymil==1) val=val*1000;  // msec factor
     sprintf(labelY,"%f",val);
     for (count=0; count<strlen(labelY); count++)    // how many decimal want ?
        if (labelY[count]=='.')
        {
           if (count>=3) labelY[count+3]='\0';    // only 2 decimal
           else          labelY[count+3]='\0';    // only 2 decimal
        }
     for (count=0; count<strlen(labelY); count++)  // if the value is n.0 kill 0
     {
        if (labelY[strlen(labelY)-count-1]=='.')       labelY[strlen(labelY)-count-1]='\0';   
             else if (labelY[strlen(labelY)-count-1]!='0')  break;
     }
     //printf("\n labelY= %s",labelY);
     if (Ymil==1) strcat (labelY, " m");
     if (strlen(labelY)>Ylong) Ylong=strlen(labelY);
     write_IM (im,beginx,y-5,0,font,labelY,colors[1]);
  }



// #################################################################
//   Update graph Size 
// #################################################################
  EX=beginx+Ylong*6+15; // dove inizia l'asse delle ascisse
  titx=GraphSizeX+EX;  // pixel TRUE SIZE
  next=GraphSizeX+EX;

  if (RBACK==1)    
  {
    gdImageFilledRectangle(im, EX, 27, GraphSizeX+EX, EY, colors[10]);
  }


//#####################################
//   Put dashed lines
//#####################################
  for (county=0; county<lineY+ExtraLines; county++) 
  {
    
     val=(Ymax/lineY)*(county+1);
     y=val*Yfactor;
     x1=-4;
     x2=GraphSizeX;
     x1=x1+EX;
     x2=x2+EX; 
     y=EY-y;   
     gdImageDashedLine(im, x1, y, x2, y, colors[1]);
  }




// #####################################
//   calculate Xlong
// #####################################
// Rewind data  ;-)
   fseek(f, 0L, 0);
   while(!feof(f))
   {
     fgets(line,256,f);
     if (feof(f))  break;
     for (count=0; count<strlen(line); count++)
     {
        if (line[count]==' ')
        {
           line[count]='\0';
           if (strcmp(line,"NEW")) 
           {
              val=atof(line);
              if (Xmil==1) val=val*1000;  // msec factor
              sprintf (labelX, "%.2f", val);
              for (countz=0; countz<strlen(labelX); countz++)
              {
                 if (labelX[strlen(labelX)-countz-1]=='.')   labelX[strlen(labelX)-countz-1]='\0';   
                 else if (labelX[strlen(labelX)-countz-1]!='0')  break;
              }
              if (Xmil==1) strcat (labelX, " m");
              if (strlen(labelX)>Xlong) Xlong=strlen(labelX);
	   }
        }
     }
   }


// #################################################################
//   Update graph Size 
// #################################################################
           TY=TY+6*Xlong-2+7;   
   beginy=beginy+6*Xlong-2+7;  


// #################################################################
//   Finally :) start to Plot the GRAPH   
// #################################################################
  lastX=-1;
  lastY=-1;
  i=1;
  // Rewind data  ;-)
  fseek(f, 0L, 0);
  while(!feof(f))
  {
     fgets(line,256,f);
     if (feof(f))  break;
     for (count=0; count<strlen(line); count++)
     {
        if (line[count]==' ')
        {
           strncpy(line2,&line[count+1],strlen(line)-count);
           line2[strlen(line)-count-3]='\0';
           line[count]='\0';
           if (!strcmp(line,"NEW"))
           {
              //printf("\n---New graphic LINE---------");
              i++;
              lastX=-1;
              lastY=-1;
           }
           else
           {
              val2=atof(line2);
              val=atof(line);
              px=val*Xfactor;
              py=val2*Yfactor;

              //printf("\n  PX = %4.1f - PX(value) = %4.1f",px,val);
              //printf("    PY = %4.1f - PY(value) = %4.1f",py,val2);

              size=3;
              x=EX+px;
              y=EY-py;
              if ((lastX!=-1) && (lastY!=-1))
              {
                 gdImageLine(im,x,y,lastX,lastY,colors[i]);
                 pattern(lastX,lastY,i,3);
              }
              pattern(x,y,i,3);
              lastX=x;
              lastY=y;
              // on X small line
              gdImageLine(im,x,EY,x,EY+5,colors[1]);
              // on X data value
              if (Xmil==1) val=val*1000;  // msec factor
              sprintf (labelX, "%lf", val);
              for (countz=0; countz<strlen(labelX); countz++)
              {
                if (labelX[countz]=='.')
                {
                   if (countz>=3) labelX[countz+3]='\0';    // only 2 decimal
                   else           labelX[countz+3]='\0';    // only 2 decimal
                }
               }

               for (countz=0; countz<strlen(labelX); countz++)
               {
                 if (labelX[strlen(labelX)-countz-1]=='.')       labelX[strlen(labelX)-countz-1]='\0';   
                 else if (labelX[strlen(labelX)-countz-1]!='0')  break;
                }
                if (Xmil==1) strcat (labelX, " m");
                write_IM(im,   x-5, beginy-7, 1,font, labelX, colors[1]);
           }
        }
     }
  }
  fclose(f);
/*
    // #################################################################
    //   Put a line in the Picture AREA Defined
    // #################################################################
    
    x1=0;                 // start LINE
    y1=0;
    x1=EX+x1;             // conversion to graphic coords
    y1=EY-y1;
    gdImageFilledRectangle(im, x1-size, y1-size, x1+size,y1+size, colors[7]);
    gdImageRectangle(im, x1-size, y1-size, x1+size,y1+size, colors[1]);

    x2=GraphSizeX-1;        // end LINE
    y2=GraphSizeY-1;
    x2=EX+x2;             // conversion to graphic coords
    y2=EY-y2;
    gdImageFilledRectangle(im, x2-size, y2-size, x2+size,y2+size, colors[7]);
    gdImageRectangle(im, x2-size, y2-size, x2+size,y2+size, colors[1]);
    gdImageLine(im,x1,y1,x2,y2,colors[1]);

    x1=0;                 // start LINE
    y1=GraphSizeY-1;
    x1=EX+x1;             // conversion to graphic coords
    y1=EY-y1;
    gdImageFilledRectangle(im, x1-size, y1-size, x1+size,y1+size, colors[7]);
    gdImageRectangle(im, x1-size, y1-size, x1+size,y1+size, colors[1]);

    x2=GraphSizeX-1;        // end LINE
    y2=0;
    x2=EX+x2;             // conversion to graphic coords
    y2=EY-y2;
    gdImageFilledRectangle(im, x2-size, y2-size, x2+size,y2+size, colors[7]);
    gdImageRectangle(im, x2-size, y2-size, x2+size,y2+size, colors[1]);
    gdImageLine(im,x1,y1,x2,y2,colors[1]);
*/

}

// #################################################################
// #################################################################
//     Make a Netmeter Graphic  (Pixel Distribution for IPDV)
// #################################################################
// #################################################################
void RobertoNetmeterGraph2 (void)
{

// var -----------------

  int x,y,size,x1,x2,y1,y2;
  int GraphSizeX,GraphSizeY;
  FILE *f;
  char fname[300];
  char line[300],line2[300],labelY[300],labelX[300],temps[40];
  //,xx[300],yy[300];
  int count,countx,county,countz;
  float val,val2;
  float delay,Xmin,Xmax,Ymax,Ymin,aux,last;
  float Ygap,Xgap,Xfactor,Yfactor,px,py;
  int   lastX,lastY,lineY;
  char  Xmil,Ymil,Ydec,Xlong,Ylong;
  int   ExtraLines;
  int   ivalue;


  im=resize(im,next,2000,1524,Dcolor,colors,defcolors,&max_col);


// #####################################
//    Start... init local var
// #####################################
   Xmin=9999;
   Xmax=0.000001;
   Ymin=9999;
   Ymax=0.000001;
   Xlong=0;
   Ylong=0;

   GraphSizeX=GlobalXSIZE;
   GraphSizeY=GlobalYSIZE-80;
   lineY=GlobalLINES;

// #################################################################
//   Update initial IMAGE AREA of .PNG file
// #################################################################
   EX=0;
   titx=GraphSizeX+EX+30;  // pixel TRUE SIZE
   next=GraphSizeX+EX+30;
   EY=GraphSizeY+30;       // SIZE of the  AREA: Graphic X/Y AREA
   TY=EY+30;               // SIZE of the IMAGE: Graphic X/Y AREA + x_label
   beginy= TY-pyy-10;
   beginx= beginx+20;



// #################################################################
//   Open Data File
// #################################################################
   strcpy(fname,Iname);
   f=fopen(fname,"r");
   if (f==NULL) printf("\n Error .dat file not found ....!!!");


// #################################################################
//   Calculate Xmax, Ymax
// #################################################################
   while(!feof(f))
   {
     fgets(line,256,f);
     if (feof(f))  break;

   if (strncmp(line,"NEW",3))  
     for (count=0; count<strlen(line); count++)
     {
        if (line[count]==' ')
        {
           strncpy(line2,&line[count+1],strlen(line)-count);
           line2[strlen(line)-count-3]='\0';
           line[count]='\0';
           val=atof(line);
           val2=atof(line2);

           if (val<Xmin)  Xmin=val;
	   if (val>Xmax)  Xmax=val;

   	   if (val2<Ymin)  Ymin=val2;
	   if (val2>Ymax)  Ymax=val2;
	   
        }
     }
   }

// #################################################################
//   Debug Watchs
// #################################################################
   //printf("\n Xmax = %.3f",Xmax);
   //printf("\n Xmin = %.3f",Xmin);
   //printf("\n Ymax = %.3f",Ymax);
   //printf("\n Ymin = %.3f",Ymin);

// #################################################################
//   mSEC data
// #################################################################
   Ymil=0;
   if (Ymax<1)  Ymil=1;    // looking if the data need to be expressed to msec

   Xgap=Xmax-Xmin;
   Xfactor=(GraphSizeX)/Xgap;

   Ygap=Ymax-Ymin;
   Yfactor=(GraphSizeY)/Ygap;

   //printf("\n GraphSizeX = %d",GraphSizeX);
   //printf("\n GraphSizeY = %d",GraphSizeY);
   //printf("\n Ygap = %.3f",Ygap);
   //printf("\n Xgap = %.3f",Xgap);
   //printf("\n FactX = %.3f",Xfactor);
   //printf("\n FactY = %.3f",Yfactor);
  

// #####################################
//   Plot Y label and calculate Ylong
// #####################################

  ExtraLines=0;  // POWERFULL  more DASHED-LINE-VALUES do you want ??
                 // :( do you need to  reduce the X-Yfactor scale



  lineY=5;
  for (county=-lineY+1; county<=lineY; county++)
  {
     if (county>=0) val=(Ymax*county)/lineY;
     else           val=(fabs(Ymin)*county)/lineY;
     y=(val-Ymin)*Yfactor;
/*
  for (county=0; county<lineY+ExtraLines; county++) 
  {
    
     val=(Ygap/lineY)*(county+1)+Ymin;
     y=(val-Ymin)*Yfactor;
     printf("\n val  = %.3f",val);
*/    

     x1=-4;
     x2=GraphSizeX+30;
     x1=x1+EX;   // X conversion
     x2=x2+EX;   // X conversion
     y=EY-y;     // Y conversion
     if (Ymil==1) val=val*1000;  // msec factor
     sprintf(labelY,"%f",val);
     for (count=0; count<strlen(labelY); count++)    // how many decimal want ?
        if (labelY[count]=='.')
        {
           if (count>=3) labelY[count+3]='\0';    // only 2 decimal
           else          labelY[count+3]='\0';    // only 2 decimal
        }
     for (count=0; count<strlen(labelY); count++)  // if the value is n.0 kill 0
     {
        if (labelY[strlen(labelY)-count-1]=='.')       labelY[strlen(labelY)-count-1]='\0';
             else if (labelY[strlen(labelY)-count-1]!='0')  break;
     }
     if (Ymil==1) strcat (labelY, " m");
     if (strlen(labelY)>Ylong) Ylong=strlen(labelY);
     write_IM (im,beginx,y-5,0,font,labelY,colors[1]);
  }


// #################################################################
//   Update graph Size
// #################################################################
  EX=beginx+Ylong*6+15; // dove inizia l'asse delle ascisse
  titx=GraphSizeX+EX;  // pixel TRUE SIZE
  next=GraphSizeX+EX;

  if (RBACK==1)    
    gdImageFilledRectangle(im, EX, 20, GraphSizeX+EX, EY, colors[10]);



//#####################################
//   Put dashed lines
//#####################################

  
  for (county=-lineY+1; county<=lineY; county++)
  {
     if (county>=0) val=(Ymax*county)/lineY;
     else           val=(fabs(Ymin)*county)/lineY;
     y=(val-Ymin)*Yfactor;
     x1=-4;
     x2=GraphSizeX+30;
     x1=x1+EX;
     x2=x2+EX;
     y=EY-y;
     gdImageDashedLine(im, x1, y, GraphSizeX+EX, y, colors[1]);
  }




// #####################################
//   calculate Xlong
// #####################################
// Rewind data  ;-)
   fseek(f, 0L, 0);
   while(!feof(f))
   {
     fgets(line,256,f);
     if (feof(f))  break;


   if (strncmp(line,"NEW",3))  
     for (count=0; count<strlen(line); count++)
     {
        if (line[count]==' ')
        {
           line[count]='\0';
           val=atof(line);
           if (Xmil==1) val=val*1000;  // msec factor
           sprintf (labelX, "%.2f", val);
           for (countz=0; countz<strlen(labelX); countz++)
           {
                 if (labelX[strlen(labelX)-countz-1]=='.')   labelX[strlen(labelX)-countz-1]='\0';   
                 else if (labelX[strlen(labelX)-countz-1]!='0')  break;
           }
           if (Xmil==1) strcat (labelX, " m");
           if (strlen(labelX)>Xlong) Xlong=strlen(labelX);
        }
     }
   }


// #################################################################
//   Update graph Size 
// #################################################################
           TY=TY+6*Xlong-2+7;   
   beginy=beginy+6*Xlong-2+7;  

//#####################################
//   Put X - label
//#####################################
  for (countx=0; countx<=(GraphSizeX-10-1); countx++)
  {
     x=EX+countx;
     ivalue=countx/Xfactor+Xmin;
     //printf("\n ivalue = %d",ivalue);
     if (countx % espax == 0)
     {
        gdImageLine(im,x,EY,x,EY+5,colors[1]);
        if (Xmil==1) val=val*1000;  // msec factor
        sprintf (labelX, "%d", ivalue);
        for (countz=0; countz<strlen(labelX); countz++)
        {
                   if (labelX[countz]=='.')
                   {
                      if (countz>=3) labelX[countz+3]='\0';    // only 2 decimal
                      else           labelX[countz+3]='\0';    // only 2 decimal
                   }
        }
        for (countz=0; countz<strlen(labelX); countz++)
        {
                    if (labelX[strlen(labelX)-countz-1]=='.')       labelX[strlen(labelX)-countz-1]='\0';
                    else if (labelX[strlen(labelX)-countz-1]!='0')  break;
        }
        if (Xmil==1) strcat (labelX, " m");
        write_IM(im,   x-5, beginy-7, 1,font, labelX, colors[1]);
      }
  }


  countx=0;
  i=2;
  // Rewind data  ;-)
  fseek(f, 0L, 0);
  while(!feof(f))
  {
    /*
      countx++;
      if (countx>2000) break;
    */
      fgets(line,256,f);
      if (feof(f))  break;
      if (!strncmp(line,"NEW",3))  
      {
         i++;
      }
      else
      for (count=0; count<strlen(line); count++)
      {
        if (line[count]==' ')
        {
           strncpy(line2,&line[count+1],strlen(line)-count);
           line2[strlen(line)-count-3]='\0';
           line[count]='\0';
           val2=atof(line2);
           val=atof(line);
           px=val*Xfactor;
           py=(val2-Ymin)*Yfactor;
           x=EX+px;
           y=EY-py;
           gdImageSetPixel(im,x,y,colors[i]);
           //printf("\n  PX = %4.1f - PX(value) = %4.1f",px,val);
           //printf("    PY = %4.1f - PY(value) = %4.1f",py,val2);
        }
     }
  }
  fclose(f);
}

void RobertoFill (void)
{

	if (acum==1) max=mxf;
	if (espx==0) espax=10;
	if (esp==0)  espacio=10;
	j=0; 
	next=EX;
	k=0;
	ret=0;
	while (ret<50)
	{
	  vant[ret]=EY;
	  ret=ret+1;
	}
	ret=0;
        old_next=next;
	while (j<lines-1)
	{
	   fin = 0; 
	   off=0;
	   mul=3;
	   i=2;
	   msec=0;
  	   ret= read_line(data[j].d1);
	   while (msec<ret)
 	   {
		   sscanf (arg[msec].nom,"%lf", &dato);
		   if (msec==0)       vec[msec]=dato;
		   else if (acum==0)  vec[msec]=dato;
			else          vec[msec]=vec[msec-1]+dato;
                   //printf(" \n vec[msec]= %f:",vec[msec]);
  	           p1=(vec[msec]/max);
		   p2= p1*(EY-20);
  	  	   apoint=(EY)-p2;
	  	   if (max_col == i) { i=2; }
		   if (nolin==1)
		   {
                  //  gdImageSetPixel(im,next,vant[msec]    ,colors[1]);
                  //  gdImageSetPixel(im,next+espacio,apoint,colors[1]);
                      gdImageLine(im,next,vant[msec],next+espacio,apoint,colors[1]);
	 	   }
                   if (j==lines-2) 
                     gdImageLine(im,next+espacio,apoint,next+espacio,EY,colors[i]);
		   vant[msec]=apoint;
		   i++;
		   msec++;
		}
		nolin=1;
		j++;
		next=next+espacio;
		k++;
		
	}

}

