/* ####################################################
   # Copyright 2002, 2003 Ren Serral,                #
   #                                                  #
   # sequence.h - Flow Management.                    #
   #       v2.0 (04-2002)                             #
   #       v2.01(02-2003)                             #
   ####################################################

   This file is part of NetMeter.

   NetMeter is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   NetMeter is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with NetMeter; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */

#include <sys/socket.h>
#include <netinet/in.h>

#include "flows.h"
#include "common.h"

#ifndef __SEQUENCE_H__
#define __SEQUENCE_H__

struct t_seq_list {
	int packets;
	p_flow first, last;
	struct t_seq_list *next, *prev;
};
typedef struct t_seq_list hole, *p_hole;

typedef struct t_seq_list_head {
	char         sequence[MAX_PKT];
	int          flow_id;
	int          elements;
	p_flist_head the_flow;
	p_hole       head, tail, actual;
} slist_head, *p_slist_head;

p_slist_head new_slist(p_flist_head list, int flow);
int           del_slist(p_slist_head list);

int           do_holes(p_slist_head list);
int           add_hole(p_slist_head list, int begin_, int end_);
static p_hole next_hole(p_slist_head list);
int           make_hole_list(p_slist_head list);

p_hole       go_sfirst(p_slist_head list);
p_hole       go_slast(p_slist_head list);
p_hole       go_snext(p_slist_head list);
p_hole       go_sprev(p_slist_head list);
int          hole_duration(p_hole myHole, struct timeval *myTime);
#endif
