/* ###############################################
   # Copyright 2002, 2003 Roberto Borgione       #
   #                                             #
   # scan.c - Scanner                            #
   #       v2.0 (03-2002)                        #
   ###############################################

   This file is part of NetMeter.

   NetMeter is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   NetMeter is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with NetMeter; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>


#define MAX_PACKETS 20000    // max packets for Input File
#define MAX_FLOWS   10       // max flows   for Input File


// var ----------------------------

  char  file_index[MAX_FLOWS][MAX_PACKETS];
  int  countp,countf,count,countx,county,countk,temp,count_seek,countz,countABS;
  int  n1,old_n1,number;
  int  size;
  int  max_countf;
  int  offset;
  char line[300],line1[300],line2[300],f3_name[300];
  char rx_time[20],tx_time[20],mgen_time[300],mgen_sec[300];
  int  fd;
  unsigned int num;
  FILE *f=NULL,*f1=NULL,*f2=NULL,*f3=NULL;
  FILE *o=NULL;
  char ch;
  char  d1[3], d2[3], d3[3], d4[3];
  unsigned long XNUM;
  float XNUM2;
  time_t t;






void WRITE_MGEN_BROADBAND_INPUT_DLY(void)
{

// #######    FILE 3    ######################################################
              //reading MGEN Time-Stamp
              // HH:MM:SS.


              if (n1==old_n1)      //need to simulate a out of sequency ?
                number=countABS;
              else
                number=1977;       // Magic Number ;-)
              old_n1=n1;


              offset=25+12;
              ch=line1[offset+0+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
              ch=line1[offset+0];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
              XNUM=n1;
              ch=line1[offset+3+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
              ch=line1[offset+3];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
              XNUM=XNUM*256+n1;
              ch=line1[offset+6+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
              ch=line1[offset+6];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
              XNUM=XNUM*256+n1;
              ch=line1[offset+9+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
              ch=line1[offset+9];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
              XNUM=XNUM*256+n1;
              t=XNUM;
              strcpy(mgen_sec,ctime(&t));
              countz=0;
              for (count=0; count<strlen(mgen_sec); count++)
                if (mgen_sec[count]==' ')
                {
                   countz++;
                   if (countz==3) break;
                }
              strncpy(mgen_time,&mgen_sec[count+1],8);
              mgen_time[8]='\0';
              strcat(mgen_time,".");
              // HH:MM:SS. + microsec.
              offset=25+12+12;
              ch=line1[offset+3+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
              ch=line1[offset+3];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
              XNUM=n1;
              ch=line1[offset+6+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
              ch=line1[offset+6];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
              XNUM=XNUM*256+n1;
              ch=line1[offset+9+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
              ch=line1[offset+9];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
              XNUM=XNUM*256+n1;
              XNUM2=XNUM;
              sprintf(mgen_sec,"%.0f",XNUM2);
              strcat(mgen_time,mgen_sec);
              strcat(mgen_time,"000000");
              mgen_time[15]='\0';
              strcpy(tx_time,mgen_time);
              strcpy(rx_time,line);
              fprintf(f3,"Flow>%.4d Seq>%.6d Src> 0.0.0.0/0503  Dest> 1.1.1.1/0503 TxTime>%s RxTime>%s Size>%.4d\n",1,number,tx_time,rx_time,size);
              countABS++;
// #######    FILE 3     ###################################################
}






// ------------------------------------------------------------------------
//                       M     A       I       N
// ------------------------------------------------------------------------
int main (int argc, char *argv[])
{

   printf("\n HpBroadband - SCANNER");
   printf("\n\n list of parameters:");
   printf("\n - Broadband input  file (output flow) = %s\n",argv[1]);
   printf("\n - Broadband output file = in.txt out.txt \n");
//   strcpy(argv[1],"h:/work/test");
//   argc=2;
   if (argc!=2)
   {
      printf("\n HpBroadband - Mgen file converter\n\nUsage: SCAN HPfile.txt \n");
      exit (-1);
   }
   f1=fopen(argv[1],"r");
   if (f1==NULL)
   {
      printf("\n\n ERROR...!!! Input file1 not found.\n");
      exit (-1);
   }
   // -------------------------------------------------------------------


   f=fopen("in.txt","w");
   if (f==NULL)
   {
      printf("\n\n ERROR...!!! Can't create output file 1\n");
      exit (-1);
   }
   o=fopen("out.txt","w");
   if (f==NULL)
   {
      printf("\n\n ERROR...!!! Can't create output file 2\n");
      exit (-1);
   }

   strcpy(f3_name,argv[1]);
   //strcpy(f3_name,"X");
   strcat(f3_name,"_IN.dly");
   f3=fopen(f3_name,"w");
   if (f3==NULL)
   {
      printf("\n\n ERROR...!!! Can't create output file 3\n");
      exit (-1);
   }
   countp=0;
   county=0;
   countx=0;
   fseek(f1, 0L, 0);
   fgets(line,256,f1);

   for (count=0; count<MAX_PACKETS; count++)
    for (countx=0; countx<MAX_FLOWS; countx++)
      file_index[countx][count]=0;

   countx=0;
   old_n1=1;
   while(!feof(f1))
   {
      fgets(line,256,f1);
      //printf("\n line = %s ",line);

      if (feof(f1))  break;
      if (line[0]!='\n')
      if (strncmp(line,"    ",3))
      {
         //new packet found
         fgets(line1,256,f1);
  
         //reading IP packet size  
         offset=43;
         ch=line1[offset+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
         ch=line1[offset];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
         num=n1;
         ch=line1[offset+3+1]; if (ch<65) n1=(ch-48);      else  n1=ch-55;
         ch=line1[offset+3];   if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
         num=n1+num*256;
         size=num-28;            //  IP + UDP header = 28 ;-)
         if (size>10000)
         {
           printf("\n error flow %d Illegal packet size: %u \n",countf,size);
           exit(-1);
         }

         fgets(line2,256,f1);

         //reading destination PORT NUMBER

         offset=49;
         strncpy(d1, &line2[offset],   2);
         strncpy(d2, &line2[offset+3], 2);
         d1[2]='\0';
         d2[2]='\0';
         // 0016 = port 22 of SSH
         //printf("\n d1=%s d2=%s",d1,d2);
         //printf("\n dline= %s",line2);
         if ( !strcmp(d1,"00") && !strcmp(d2,"16") )
         {
//            printf("- SSH flow detect\n");
         }
         else
         {
            countp++;
            //printf("%s ",line);
            //getchar();

            fgets(line1,256,f1);

            //reading sequence number < 0x0FFFF
            offset=25;
            ch=line1[offset+6+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
            ch=line1[offset+6];     if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
            num=n1;
            ch=line1[offset+9+1];   if (ch<65) n1=(ch-48);      else  n1=ch-55;
            ch=line1[offset+9]; if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;
            num=n1+num*256;
            if (num>MAX_PACKETS)
            {
              printf("\n error flow %d too many packets: %u \n",countf,num);
              exit(-1);
            }
            else
            {
              fgets(line2,256,f1);
              offset=13;
              ch=line2[offset+9+1]; if (ch<65) n1=(ch-48);      else  n1=ch-55;
              ch=line2[offset+9];   if (ch<65) n1+=(ch-48)*16;  else  n1+=(ch-55)*16;

              if (n1>MAX_FLOWS)
              {
                 printf("\n\nToo many flows..!! \n",n1);
                 printf("on line: %s \n",line2);
                 exit(-1);
              }
              line[15]='\0';             // Broadband timestamp truncate
//              printf("- Broadband flow %02d seq n. %05d total. %05d\n",n1,num,countABS);
              if (file_index[n1-1][num]==0)
              {
                 fprintf(f,"%s\n",line);
                 fprintf(f,"%d\n", num);
                 fprintf(f,"%d\n", n1);
                 fprintf(f,"%d\n",size);
                 file_index[n1-1][num]=1;
                 WRITE_MGEN_BROADBAND_INPUT_DLY();
                 countx++;
              }
              else
              {
                 fprintf(o,"%s\n",line);
                 fprintf(o,"%d\n", num);
                 fprintf(o,"%d\n", n1);
                 fprintf(o,"%d\n",size);
                 county++;
              }


            }
         }
      }
   }

   printf("\n\n - Total Paquets: %d",countp);
   printf("\n - input  flow Paquets: %d",countx);
   printf("\n - output flow Paquets: %d\n",county);

   fclose(f);
   fclose(o);
   fclose(f1);
   fclose(f3);


   strcpy(f3_name,argv[1]);
   strcat(f3_name,"_IN.mcl");
   f3=fopen(f3_name,"w");
   if (f3==NULL)
   {
      printf("\n\n ERROR...!!! Can't create output file 4\n");
      exit (-1);
   }
   fprintf(f3,"Mgen measure\n");
   fprintf(f3,"Flow name: Flow BroadBand-Mgen+Source:Mgen+Destination:Broadband\n");
   fprintf(f3,"\n");
   fprintf(f3,"Flow IPv4 ID 1\n");
   fprintf(f3,"Pattern  PERIODIC\n");
   fprintf(f3,"Nr. of MODs   0\n");
   fprintf(f3,"Mgen Absolute START   NOW\n");
   fprintf(f3,"Flow Source        MgenSender:0\n");
   fprintf(f3,"Flow Destination   BroadbandIN:1\n");
   fclose(f3);
}


