###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                      Roberto Borgione       #
#                                             #
# delayu4a.tcl - Unicast   Delay IPv4 Manager #
#       v2.0 (04-2002)                        #
#       v2.01(10-2002)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

###################################################################
#------------------------------------------------------------------
#             Delay:Du4      (Unicast Ipv4 case)
#------------------------------------------------------------------
###################################################################
proc Delay:Du4 {} \
{

   global uni4
   global dly 		;#dly array to hold data
   global flow		;#flow array to hold flows data
   global flowLB	;#flows listbox
   global userLB	;#custom params listbox
   global logDelayLB	;#status console
   global runB		;#run test button
   global mod

   global paramU4 pU4 countPU4
   global sender receiver host
   global mcalcpath4
   global decodepath4
   global xflowview

   global scriptLB

   set xflowview 1977

   #up frame for mgen and drec options plus
   #script listbox
   frame $uni4.up
   pack $uni4.up -pady 3 -fill x

   #up-left frame (options)
   frame $uni4.up.left -bd 2 -relief groove
   pack $uni4.up.left -pady 3 -fill x -side left -anchor n

   #up-right frame (script listboxes)
   frame $uni4.up.right -bd 2 -relief groove
   pack $uni4.up.right -pady 3 -padx 3 -fill both -side right \
   -expand true -anchor n

   ##############################################################
   ##############################################################
   ## define widgets for mgen and drec OPTIONS
   ##############################################################
   label $uni4.up.left.titleL -text "IPv4 - Mgen and Drec Options" -relief raised
   pack  $uni4.up.left.titleL  -anchor c  -fill x -padx 3 -pady 3

   frame $uni4.up.left.title
   pack  $uni4.up.left.title -pady 2 -fill x
   label $uni4.up.left.title.l -text "Title measure"
   pack  $uni4.up.left.title.l -side left -padx 3
   entry $uni4.up.left.title.e -textvariable dly(title,ipv4) -width 28
   pack  $uni4.up.left.title.e -side right -padx 3


   #############################################################
   #### start ##################################################
   #############################################################

   frame $uni4.up.left.start
   pack $uni4.up.left.start -pady 3 -fill x
   checkbutton $uni4.up.left.start.cB -variable dly(startBool) \
     -text "Start (hh:mm:ss)" -command {
      if $dly(startBool) {
          #enable entry
          $uni4.up.left.start.e config -state normal -fg black
      } else {
          #disable entry
          $uni4.up.left.start.e config -state disabled -fg gray
      }
   }
   pack $uni4.up.left.start.cB -padx 3 -side left
   if $dly(startBool) {
      entry $uni4.up.left.start.e -textvariable dly(start) -state normal
   } else {
      entry $uni4.up.left.start.e -textvariable dly(start) -state disabled -fg gray
   }
   pack $uni4.up.left.start.e -padx 3 -side right
   frame $uni4.up.left.srcPort
   pack $uni4.up.left.srcPort -pady 3 -fill x
   checkbutton $uni4.up.left.srcPort.cB -variable dly(srcPortBool) \
      -text "Source Port" -command {
      if $dly(srcPortBool) {
         #enable entry
         $uni4.up.left.srcPort.e config -state normal -fg black
      } else {
         #disable entry
         $uni4.up.left.srcPort.e config -state disabled -fg gray
      }
   }
   if $dly(srcPortBool) {
      #enable entry
      entry $uni4.up.left.srcPort.e -textvariable dly(srcPort) \
      -state normal
   } else {
      #disable entry
      entry $uni4.up.left.srcPort.e -textvariable dly(srcPort) \
      -state disabled -fg gray
   }
   pack $uni4.up.left.srcPort.cB -padx 3 -side left
   pack $uni4.up.left.srcPort.e -padx 3 -side right

   #####################################################
   # flows list
   #####################################################
   #frame for flow list:
   frame  $uni4.up.left.flowl -bd 2 -relief groove
   pack $uni4.up.left.flowl -fill x -pady 5
   #a label
   label $uni4.up.left.flowl.label -text "Flows List" -relief sunken
   pack $uni4.up.left.flowl.label -side top -fill x  -padx 3
   #listbox for displaying currently defined
   #flows and their properties
   set flowLB [listbox $uni4.up.left.flowl.flowlist -height 7]
   set fsy [scrollbar $uni4.up.left.flowl.flowsy -orient vertical \
      -command "$flowLB yview"]
   $flowLB config -yscrollcommand "$fsy set"
   pack $fsy -side right -fill y -pady 3
   pack $flowLB -side left -fill both  -expand true -pady 3
   bind $uni4.up.left.flowl.flowlist <Double-1> {
     Viewflow4
   }

   #####################################################
   #frame for flow operations: add, delete, and MODify
   #####################################################
   frame  $uni4.up.left.flow
   pack   $uni4.up.left.flow -pady 5 -fill x
   button $uni4.up.left.flow.addB -text "Add\nnew Flow" \
      -command { AddFlow 0 } -bd 2 -relief groove -width 7

   button $uni4.up.left.flow.editB -text "Edit\nFlow" \
      -command { EditFlow 0 } -bd 2 -relief groove -width 4

   button $uni4.up.left.flow.delB -text "Delete\nlast Flow" \
      -command DeleteFlow -bd 2 -relief groove -width 7

   button $uni4.up.left.flow.modB -text "Add changes\nto Flow" \
      -command MODifyFlow -bd 2 -relief groove -width 9

   pack  $uni4.up.left.flow.editB  $uni4.up.left.flow.addB $uni4.up.left.flow.modB \
      $uni4.up.left.flow.delB -padx 3 -anchor c -side left

   #############################################################
   ## Listbox View selected Flow
   #############################################################

   frame $uni4.up.right.custom -bd 2 -relief groove
   pack  $uni4.up.right.custom -fill x

   frame  $uni4.up.right.custom.b
   pack   $uni4.up.right.custom.b -expand true -side bottom
   label  $uni4.up.right.custom.b.l -text "Parameters"
   pack   $uni4.up.right.custom.b.l -side left
   button $uni4.up.right.custom.b.b1 -text "Add" \
      -command AddParameterU4  -relief groove -width 2
   button $uni4.up.right.custom.b.b2 -text "Edit" \
      -command EditParameterU4 -relief groove -width 2
   button $uni4.up.right.custom.b.b3 -text "Del" \
      -command RemoveParameterU4 -bd 2 -relief groove -width 2

   set x "(parameters)"
   set paramU4($x) "0"
   eval tk_optionMenu $uni4.up.right.custom.b.bx pU4 [lsort [array names paramU4 ]]
   $uni4.up.right.custom.b.bx configure -width 20

   pack $uni4.up.right.custom.b.b1 $uni4.up.right.custom.b.b3\
   $uni4.up.right.custom.b.b2 $uni4.up.right.custom.b.bx -side left

   label $uni4.up.right.custom.l -text "flow parameters (to select double click on flow list)"
   pack $uni4.up.right.custom.l -padx 2 -anchor c
   #frame for listbox and scrollbars:
   frame $uni4.up.right.custom.lb
   pack $uni4.up.right.custom.lb -pady 2 -fill both -expand true
   set userLB [listbox $uni4.up.right.custom.lb.customLB -height 6]
   set usy [scrollbar $uni4.up.right.custom.lb.sY -orient vertical\
      -command "$userLB yview"]
    set usx [scrollbar $uni4.up.right.custom.lb.sX -orient horizontal\
      -command "$userLB xview"]
   $userLB config -yscrollcommand "$usy set" -xscrollcommand "$usx set"

   pack $usy -side right -fill y -pady 2
   pack $usx -side bottom -fill x -padx 2
   pack $userLB -fill both -padx 2 -pady 2 -side left -expand true

   #############################################################
   ## frame for path settings and features :)
   #############################################################
   #frame for path settings:
   frame $uni4.up.right.path
   pack $uni4.up.right.path -fill x -pady 3 \
      -expand true -padx 3

   frame $uni4.up.right.path.mgenPath
   pack $uni4.up.right.path.mgenPath -pady 2 -fill x
   label $uni4.up.right.path.mgenPath.l -text "(SRC) Set Mgen Path"
   pack $uni4.up.right.path.mgenPath.l -side left -padx 3
   entry $uni4.up.right.path.mgenPath.e -textvariable dly(mgenPath,ipv4) \
      -width 24

   pack $uni4.up.right.path.mgenPath.e -side right -padx 3

   frame $uni4.up.right.path.drecPath
   pack $uni4.up.right.path.drecPath -pady 2 -fill x
   label $uni4.up.right.path.drecPath.l -text "(DST) Set Drec Path"
   pack $uni4.up.right.path.drecPath.l -side left -padx 3
   entry $uni4.up.right.path.drecPath.e -textvariable dly(drecPath,ipv4) \
      -width 24
   pack $uni4.up.right.path.drecPath.e -side right -padx 3

   frame $uni4.up.right.path.decodepath
   pack $uni4.up.right.path.decodepath -pady 2 -fill x
   label $uni4.up.right.path.decodepath.l -text "(DST)Set Decode Path"
   pack $uni4.up.right.path.decodepath.l -side left -padx 3
   entry $uni4.up.right.path.decodepath.e -textvariable decodepath4      \
      -width 24
   pack $uni4.up.right.path.decodepath.e -side right -padx 3

   frame $uni4.up.right.path.mcalc
   pack $uni4.up.right.path.mcalc -pady 2 -fill x
   label $uni4.up.right.path.mcalc.l -text "(LOC) Set Mcalc path"
   pack $uni4.up.right.path.mcalc.l -side left -padx 3
   entry $uni4.up.right.path.mcalc.e -textvariable  mcalcpath4 \
      -width 24
   pack $uni4.up.right.path.mcalc.e -side right -padx 3

   frame $uni4.up.right.path.delaySave
   pack $uni4.up.right.path.delaySave -pady 2 -fill x
   label $uni4.up.right.path.delaySave.l -text "(LOC) Save Results File"
   pack $uni4.up.right.path.delaySave.l -side left -padx 3
   entry $uni4.up.right.path.delaySave.e -textvariable dly(resultsFile,ipv4)\
      -width 24
   pack $uni4.up.right.path.delaySave.e -side right -padx 3

   #down frame
   frame $uni4.down
   pack $uni4.down -fill x

   #frame for action buttons:
   frame $uni4.down.action -bd 2 -relief groove
   pack $uni4.down.action -padx 3 -side left

   #and the buttons
   set runB [button $uni4.down.action.rB -text "Run Test" \
      -command RunDelayTest  -width 16]
   button $uni4.down.action.resgB -text "Graphic Results" \
      -command "NetGRAPH mcl" -width 16
   button $uni4.down.action.resdB -text "Graphic Distributions" \
      -command Distribution -width 16

   pack $uni4.down.action.rB $uni4.down.action.resgB \
      $uni4.down.action.resdB -anchor n

   #console frame,listbox and scrollbar:
   frame $uni4.down.consoleF
   pack $uni4.down.consoleF -pady 2 -side left \
      -fill x -anchor n -expand true

   set logDelayLB [listbox $uni4.down.consoleF.consoleLB \
      -height 5 -font default]
   set csy [scrollbar $uni4.down.consoleF.sY -orient vertical \
      -command "$logDelayLB yview"]
   $logDelayLB config -yscrollcommand "$csy set"
   pack $csy -fill y -side right
   pack $logDelayLB -fill both -side left -expand true

   # Frame for scripting List
   frame $uni4.scriptInfo
   pack $uni4.scriptInfo \
      -fill both -anchor n -expand true

   set scriptLB [listbox $uni4.scriptInfo.scrDownLB \
      -height 5 -font default]
   set scrollScr [scrollbar $uni4.scriptInfo.sY -orient vertical \
      -command "$scriptLB yview"]
   $scriptLB config -yscrollcommand "$scrollScr set"
   pack $scrollScr -fill y -side right
   pack $scriptLB -fill both -side left -expand true

   #frame for scripting buttons:
   frame $uni4.scripting
   pack $uni4.scripting -fill x

   frame $uni4.scripting.scriptB
   pack $uni4.scripting.scriptB -side left
   button $uni4.scripting.scrRun -text "Run Script" \
      -command RunScript4  -width 10
   button $uni4.scripting.scrAdd -text "Add To Script" \
      -command AddToScript4  -width 10
#   button $uni4.scripting.scrDel -text "Delete Entry" \
#      -command DeleteFromScript4  -width 10
#   button $uni4.scripting.scrLoad -text "Load Script" \
#      -command LoadScript4  -width 10
#   button $uni4.scripting.scrSave -text "Save Script" \
#      -command SaveScript4  -width 10
#   pack $uni4.scripting.scrRun $uni4.scripting.scrAdd $uni4.scripting.scrDel $uni4.scripting.scrLoad $uni4.scripting.scrSave -side left
   pack $uni4.scripting.scrRun $uni4.scripting.scrAdd -side left -fill x -anchor n -expand true

   frame $uni4.scripting.quitF
   pack $uni4.scripting.quitF -side left \
      -fill x -anchor n -expand true

   button $uni4.scripting.quitF.quitB -text "Quit" \
      -command Quit -width 16
   pack $uni4.scripting.quitF.quitB -side left -fill x -expand true

   # Flow Loading
   $flowLB delete 0 end
   $flowLB see end
   for {set countFL 1} {$countFL <= $flow(number)} {incr countFL}  \
   {
     $flowLB insert end [format "Flow  %02d   -   Mods  %02d  -  %s" \
       $countFL $mod(number,$countFL) $flow(name,$countFL) ]
   }
   $flowLB see end
};

###################################################################
#------------------------------------------------------------------
#             ADDFLOW
#------------------------------------------------------------------
###################################################################
proc AddFlow { action } \
{
   global flow	;# flow data
   global flowLB	;# flow list(box)

   global mod	;# flow modifier data
   global done	;# ok or cancel ?

   #deal with data

   if { $action == 0 } \
   {
      incr flow(number)
      # VERY usefull when write sequency flows ;)
      if { $flow(number) > 1 } \
      {
         set flow(name,$flow(number))    $flow(name,[expr $flow(number) - 1])
         set flow(start,$flow(number))   $flow(start,[expr $flow(number) - 1])
         set flow(stop,$flow(number))    $flow(stop,[expr $flow(number) - 1])
         set flow(port,$flow(number))    [expr $flow(port,[expr $flow(number) - 1]) +1 ]
         set flow(pattern,$flow(number)) $flow(pattern,[expr $flow(number) - 1])
         set flow(rate,$flow(number))    $flow(rate,[expr $flow(number) - 1])
         set flow(size,$flow(number))    $flow(size,[expr $flow(number) - 1])
      } else {
         set flow(name,$flow(number))  {}
         set flow(start,$flow(number)) {}
         set flow(stop,$flow(number))  {}
         set flow(port,$flow(number))  {}
         set flow(pattern,$flow(number)) PERIODIC
         set flow(rate,$flow(number))  {}
         set flow(size,$flow(number))  {}
      }
      set flow(tosBool,$flow(number)) 0
      set flow(tos,$flow(number)) {}
      set flow(rsvpBool,$flow(number)) 0
      set flow(rsvp,$flow(number)) {}
      set flow(resv,$flow(number)) {}
      set flow(style,$flow(number)) WF
      set mod(number,$flow(number)) 0
   }

   set done not_yet
   #make a dialog window

   toplevel .dialog
   wm title .dialog "Add new Flow No. $flow(number)"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:

   #frames for standard params, optional
   #params and ok-cancel buttons
   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
      -anchor n -expand true

   #standard params
   frame .dialog.fr1.name -bd 2 -relief groove
   pack  .dialog.fr1.name -pady 3 -padx 3 -fill x
   label .dialog.fr1.name.l -text "Flow Name"
   pack  .dialog.fr1.name.l -side top -padx 3
   entry .dialog.fr1.name.e -textvariable flow(name,$flow(number)) -width 30
   pack  .dialog.fr1.name.e -side bottom -padx 3

   frame .dialog.fr1.fstart
   pack  .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Flow Start (ms)"
   pack  .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable flow(start,$flow(number)) -width 10
   pack .dialog.fr1.fstart.e -side right -padx 3

   #(relative) flow stop time
   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Flow Stop (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable flow(stop,$flow(number))  -width 10
   pack .dialog.fr1.fstop.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #port number. This will be verified at last
   #to have only flows with unique port numbers
   frame .dialog.fr1.fport
   pack .dialog.fr1.fport -pady 3 -fill x
   label .dialog.fr1.fport.l -text "Destination Port"
   pack .dialog.fr1.fport.l -side left -padx 3
   entry .dialog.fr1.fport.e -textvariable flow(port,$flow(number)) -width 10
   pack .dialog.fr1.fport.e -side right -padx 3

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
      -variable flow(pattern,$flow(number)) -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
      -variable flow(pattern,$flow(number)) -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
      -padx 2 -pady 2 -anchor w

   #rate:
   giveBandwidth "ipv4" $flow(rate,$flow(number)) $flow(size,$flow(number)) bandwidth
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable flow(rate,$flow(number)) -width 10 \
      -validate focusout -vcmd {
	giveBandwidth "ipv4" $flow(rate,$flow(number)) $flow(size,$flow(number)) bandwidth
	return 1
      }
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable flow(size,$flow(number)) \
      -width 10 -validate focusout -vcmd {
	giveBandwidth "ipv4" $flow(rate,$flow(number)) $flow(size,$flow(number)) bandwidth
	return 1
      }
   pack .dialog.fr1.fsize.e -side right -padx 3

   frame .dialog.fr1.frateshow
   pack .dialog.fr1.frateshow -pady 3 -fill x
   label .dialog.fr1.frateshow.l -text "Bandwidth ATM (Kbps)"
   pack .dialog.fr1.frateshow.l -side left -padx 3
   label .dialog.fr1.frateshow.l2 -textvariable bandwidth(atm)
   pack .dialog.fr1.frateshow.l2 -side right -padx 3
   
   frame .dialog.fr1.fratesheth
   pack .dialog.fr1.fratesheth -pady 3 -fill x
   label .dialog.fr1.fratesheth.l -text "Bandwidth Ethernet (Kbps)"
   pack .dialog.fr1.fratesheth.l -side left -padx 3
   label .dialog.fr1.fratesheth.l2 -textvariable bandwidth(eth)
   pack .dialog.fr1.fratesheth.l2 -side right -padx 3
   
   #frame 2: optional params

   #tos field:
   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Type-of-Service" \
       -variable flow(tosBool,$flow(number)) -command {
   if $flow(tosBool,$flow(number)) {
       .dialog.fr2.tosF.e config -state normal -fg black
       } else {
       .dialog.fr2.tosF.e config -state disabled -fg gray
       }
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable flow(tos,$flow(number)) \
        -width 10 -fg gray
   if $flow(tosBool,$flow(number)) {
	.dialog.fr2.tosF.e config -state normal -fg black
   } else {
	.dialog.fr2.tosF.e config -state disabled -fg gray
   }
   pack .dialog.fr2.tosF.e -side right -padx 3

   #RSVP:
   frame .dialog.fr2.rsvp
   pack .dialog.fr2.rsvp -pady 3 -fill x -anchor n
   checkbutton .dialog.fr2.rsvp.cb -text "Use RSVP" \
      -variable flow(rsvpBool,$flow(number)) -command {
   if $flow(rsvpBool,$flow(number)) {
       pack .dialog.fr2.rsvp.params -anchor n -fill x \
          -pady 3 -padx 3
       } else {
       pack forget .dialog.fr2.rsvp.params
       }
   }
   pack .dialog.fr2.rsvp.cb -padx 3 -anchor w

   frame .dialog.fr2.rsvp.params -bd 2 -relief groove
   #no need to pack it :-)

   label .dialog.fr2.rsvp.params.l -text "RSVP Parameters"
   pack .dialog.fr2.rsvp.params.l -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.e -textvariable flow(rsvp,$flow(number))
   pack .dialog.fr2.rsvp.params.e -fill x -padx 3 -pady 3

   frame .dialog.fr2.rsvp.params.style
   pack .dialog.fr2.rsvp.params.style -fill x
   label .dialog.fr2.rsvp.params.style.l -text "RESV Style"
   pack .dialog.fr2.rsvp.params.style.l -side left -padx 3

   frame .dialog.fr2.rsvp.params.style.rbF -bd 2 -relief groove
   pack .dialog.fr2.rsvp.params.style.rbF -padx 3 -pady 3

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb1 \
      -text "WF (Wildcard)" -variable flow(style,$flow(number)) -value WF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb2 \
      -text "FF (Fixed-Filter)" -variable flow(style,$flow(number)) -value FF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb3 \
      -text "SE (Shared-Explicit)" -variable flow(style,$flow(number)) -value SE

   pack .dialog.fr2.rsvp.params.style.rbF.rb1 \
   .dialog.fr2.rsvp.params.style.rbF.rb2 \
   .dialog.fr2.rsvp.params.style.rbF.rb3 -pady 3 -padx 3 -anchor w

   label .dialog.fr2.rsvp.params.lr -text "RESV Parameters"
   pack .dialog.fr2.rsvp.params.lr -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.er -textvariable flow(resv,$flow(number))
   pack .dialog.fr2.rsvp.params.er -fill x -padx 3 -pady 3

   #ok-cancel buttons on 3rd frame

   button .dialog.fr3.ok -text OK -command {
    set done ok
    destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
    set done cancel
    destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
     -padx 3 -pady 3

   grab .dialog
   tkwait window .dialog

   if ![string compare $done cancel] {
     #cancel was pressed
     #unset data and decrement number of flows
     foreach elem {start stop port rate pattern size tosBool tos rsvpBool rsvp resv style} \
     {
        unset flow($elem,$flow(number))
     }
     unset mod(number,$flow(number))
     incr flow(number) -1
     return
   }

   #ok was pressed:
   #first verify that standard parameters are filled
   foreach elem {start stop port rate size} \
   {
      if ![string compare $flow($elem,$flow(number)) ""] \
      {
         tk_messageBox -message "Missing Flow parameteres...!!"
         AddFlow 1
         return
      }
   }

   #check port; must be unique for each flow
   for {set i 1} {$i < $flow(number)} {incr i} \
   {
      if { $flow(port,$flow(number)) == $flow(port,$i) }  \
      {
         tk_messageBox -message "Port value already used on flow $i"
         AddFlow 1
         return
      }
   }

   #data is ok, update listbox:
   $flowLB insert end [format "Flow  %02d   -   Mods  %02d  -  %s" \
      $flow(number) $mod(number,$flow(number)) $flow(name,$flow(number)) ]
}

###################################################################
#------------------------------------------------------------------
#             MODifyFlow
#------------------------------------------------------------------
###################################################################
proc MODifyFlow {} \
{

   global flow mod flowLB done flowNr

   #get the line index
   set flowNr [$flowLB curselection]

   if {$flowNr == ""} {
   #nothing selected
   return
   }
   #else
   incr flowNr
   #deal with data
   incr mod(number,$flowNr)
   set mod(start,$mod(number,$flowNr),$flowNr) $flow(start,$flowNr)

   #no port choice; is better that one flow
   #has just one port - else user may be
   #confused - if a MOD command change the port
   #so that this new port is already used by
   #another flow, apckets are dropped
   #So, it is better not to allow the user to
   #change port in a MOD command
   #set mod(port,$mod(number,$flowNr),$flowNr) $flow(port,$flowNr)
   set mod(pattern,$mod(number,$flowNr),$flowNr) $flow(pattern,$flowNr)
   set mod(rate,$mod(number,$flowNr),$flowNr) $flow(rate,$flowNr)
   set mod(size,$mod(number,$flowNr),$flowNr) $flow(size,$flowNr)
   set mod(tosBool,$mod(number,$flowNr),$flowNr) $flow(tosBool,$flowNr)
   set mod(tos,$mod(number,$flowNr),$flowNr) $flow(tos,$flowNr)
   set mod(rsvpBool,$mod(number,$flowNr),$flowNr) $flow(rsvpBool,$flowNr)
   set mod(rsvp,$mod(number,$flowNr),$flowNr) $flow(rsvp,$flowNr)
   set mod(resv,$mod(number,$flowNr),$flowNr) $flow(resv,$flowNr)
   set mod(style,$mod(number,$flowNr),$flowNr) $flow(style,$flowNr)
   set done not_yet

   #make a dialog window
   toplevel .dialog
   wm title .dialog "MODify Flow $flowNr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:

   #frames for standard params, optional
   #params and ok-cancel buttons

   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
       -anchor n -expand true
   #standard params
   #(relative) flow start time:
   frame .dialog.fr1.fstart
   pack .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "MODify Flow Start (ms)"
   pack .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable mod(start,$mod(number,$flowNr),$flowNr) \
   -width 10
   pack .dialog.fr1.fstart.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
   -variable mod(pattern,$mod(number,$flowNr),$flowNr)  -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
   -variable mod(pattern,$mod(number,$flowNr),$flowNr)  -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
   -padx 2 -pady 2 -anchor w

   #rate:
   giveBandwidth "ipv4" $mod(rate,$mod(number,$flowNr),$flowNr) $mod(size,$mod(number,$flowNr),$flowNr) bandwidth
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable mod(rate,$mod(number,$flowNr),$flowNr) \
       -width 10 -validate focusout -vcmd {
	giveBandwidth "ipv4" $mod(rate,$mod(number,$flowNr),$flowNr) $mod(size,$mod(number,$flowNr),$flowNr) bandwidth
	return 1
      }
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable mod(size,$mod(number,$flowNr),$flowNr) \
       -width 10 -validate focusout -vcmd {
	giveBandwidth "ipv4" $mod(rate,$mod(number,$flowNr),$flowNr) $mod(size,$mod(number,$flowNr),$flowNr) bandwidth
	return 1
      }
   pack .dialog.fr1.fsize.e -side right -padx 3

   frame .dialog.fr1.frateshow
   pack .dialog.fr1.frateshow -pady 3 -fill x
   label .dialog.fr1.frateshow.l -text "Bandwidth ATM (Kbps)"
   pack .dialog.fr1.frateshow.l -side left -padx 3
   label .dialog.fr1.frateshow.l2 -textvariable bandwidth(atm)
   pack .dialog.fr1.frateshow.l2 -side right -padx 3
   
   frame .dialog.fr1.fratesheth
   pack .dialog.fr1.fratesheth -pady 3 -fill x
   label .dialog.fr1.fratesheth.l -text "Bandwidth Ethernet (Kbps)"
   pack .dialog.fr1.fratesheth.l -side left -padx 3
   label .dialog.fr1.fratesheth.l2 -textvariable bandwidth(eth)
   pack .dialog.fr1.fratesheth.l2 -side right -padx 3

   #frame 2: optional params

   #tos field:

   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Type-of-Service" \
     -variable mod(tosBool,$mod(number,$flowNr),$flowNr)  -command {
	if $mod(tosBool,$mod(number,${flowNr}),${flowNr})  {
	.dialog.fr2.tosF.e config -state normal -fg black
	} else {
	.dialog.fr2.tosF.e config -state disabled -fg gray
	}
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable mod(tos,$mod(number,$flowNr),$flowNr) \
      -state disabled -width 10 -fg gray
   pack .dialog.fr2.tosF.e -side right -padx 3


   #RSVP:

   frame .dialog.fr2.rsvp
   pack .dialog.fr2.rsvp -pady 3 -fill x -anchor n
   checkbutton .dialog.fr2.rsvp.cb -text "Use RSVP" \
   -variable mod(rsvpBool,$mod(number,$flowNr),$flowNr) -command {
   if $mod(rsvpBool,$mod(number,${flowNr}),${flowNr}) {
       pack .dialog.fr2.rsvp.params -anchor n -fill x \
       -pady 3 -padx 3
       } else {
       pack forget .dialog.fr2.rsvp.params
       }
   }
   pack .dialog.fr2.rsvp.cb -padx 3 -anchor w

   frame .dialog.fr2.rsvp.params -bd 2 -relief groove
   #no need to pack it :-)

   label .dialog.fr2.rsvp.params.l -text "RSVP Parameters"
   pack .dialog.fr2.rsvp.params.l -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.e -textvariable mod(rsvp,$mod(number,$flowNr),$flowNr)
   pack .dialog.fr2.rsvp.params.e -fill x -padx 3 -pady 3

   frame .dialog.fr2.rsvp.params.style
   pack .dialog.fr2.rsvp.params.style -fill x
   label .dialog.fr2.rsvp.params.style.l -text "RESV Style"
   pack .dialog.fr2.rsvp.params.style.l -side left -padx 3

   frame .dialog.fr2.rsvp.params.style.rbF -bd 2 -relief groove
   pack .dialog.fr2.rsvp.params.style.rbF -padx 3 -pady 3

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb1 \
   -text "WF (Wildcard)" -variable mod(style,$mod(number,$flowNr),$flowNr) -value WF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb2 \
   -text "FF (Fixed-Filter)" -variable mod(style,$mod(number,$flowNr),$flowNr) -value FF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb3 \
   -text "SE (Shared-Explicit)" -variable mod(style,$mod(number,$flowNr),$flowNr) -value SE

   pack .dialog.fr2.rsvp.params.style.rbF.rb1 \
   .dialog.fr2.rsvp.params.style.rbF.rb2 \
   .dialog.fr2.rsvp.params.style.rbF.rb3 -pady 3 -padx 3 -anchor w


   label .dialog.fr2.rsvp.params.lr -text "RESV Parameters"
   pack .dialog.fr2.rsvp.params.lr -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.er -textvariable mod(resv,$mod(number,$flowNr),$flowNr)
   pack .dialog.fr2.rsvp.params.er -fill x -padx 3 -pady 3

   #ok-cancel buttons on 3rd frame

   button .dialog.fr3.ok -text OK -command {
   set done ok
   destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3

   #to synchronize widgets states:

   if $mod(tosBool,$mod(number,${flowNr}),${flowNr})  {
       .dialog.fr2.tosF.e config -state normal -fg black
       } else {
       .dialog.fr2.tosF.e config -state disabled -fg gray
       }
   if $mod(rsvpBool,$mod(number,${flowNr}),${flowNr}) {
       pack .dialog.fr2.rsvp.params -anchor n -fill x \
       -pady 3 -padx 3
       } else {
       pack forget .dialog.fr2.rsvp.params
       }

   grab .dialog
   tkwait window .dialog

   if ![string compare $done cancel] {
   #cancel was pressed

   #unset data and decrement number of flows
   foreach elem {start rate pattern size tosBool tos rsvpBool rsvp resv style} {
      unset mod($elem,$mod(number,$flowNr),$flowNr)
   }
   incr mod(number,$flowNr) -1
   return
   }

   #ok was pressed:

   #first verify that standard parameters are filled

   foreach elem {start rate size} {
   if ![string compare $mod($elem,$mod(number,$flowNr),$flowNr) ""] {

   tk_messageBox -message "Flow MOD not added"
   #unset data and decrement number of flows
   foreach elem {start rate pattern size tosBool tos rsvpBool rsvp resv style} {
   unset mod($elem,$mod(number,$flowNr),$flowNr)
   }

   incr mod(number,$flowNr) -1
   return

   };#end if
   };#end foreach

   #in this point, data is ok
   #even if tos or rsvp are selected, but not filled,
   #this options can be canceled
   #update listbox:

   $flowLB delete [expr $flowNr - 1]
   $flowLB insert [expr $flowNr - 1]  \
   [format "Flow  %02d   -   Mods  %02d  -  %s" \
   $flowNr $mod(number,$flowNr) $flow(name,$flowNr) ]
};



###################################################################
#------------------------------------------------------------------
#             DELETEFLOW
#------------------------------------------------------------------
###################################################################
proc DeleteFlow {} \
{
   #delete last flow

   global flow mod flowLB
   global xflowview
   global userLB
   global uni4
   
   #check number of flows:
   if !$flow(number) {
      return
   }

   #tk_messageBox -message "x = $xflowview"  
   #tk_messageBox -message "n = $flow(number)"  
   if  { $xflowview == $flow(number) } \
   {
      $userLB delete 0 end
   }
  
   #first, delete all the mod data associated
   #with the flow:

   for {set i 1} {$i <= $mod(number,$flow(number))} {incr i} {

   foreach elem {start rate pattern size tosBool tos \
      rsvpBool rsvp resv style} {
      unset mod($elem,$i,$flow(number))
   };# end foreach


   };#end for
   #unset mod counter:
   unset mod(number,$flow(number))

   #then, delete the flow (last flow)

   foreach elem {start stop port rate pattern size \
          tosBool tos rsvpBool rsvp resv style } {
      unset flow($elem,$flow(number))
   };#end foreach

   #decrement flow number
   incr flow(number) -1

   #update listbox
   $flowLB delete end end
}

###################################################################
#------------------------------------------------------------------
#             Viewflow4
#------------------------------------------------------------------
###################################################################
proc Viewflow4 {} \
{
   global userLB
   global flow mod flowLB
   global xflowview

   set flowNr [$flowLB curselection]
   #tk_messageBox -message "fnr = $flowNr"  
   if {$flowNr == ""} {
     #nothing selected
     return
   }
   incr flowNr
   set xflowview $flowNr
   $userLB delete 0 end
   $userLB insert end "Flow number (ID): $flowNr"
   $userLB insert end "Flow name: $flow(name,$flowNr)"
   $userLB insert end "Start time (ON): $flow(start,$flowNr)"
   $userLB insert end "Stop time (OFF): $flow(stop,$flowNr)"
   $userLB insert end "Destination port number: $flow(port,$flowNr)"
   $userLB insert end "Rate (packets/sec): $flow(rate,$flowNr)"
   $userLB insert end "Pattern: $flow(pattern,$flowNr)"
   $userLB insert end "UDP packet payload size: $flow(size,$flowNr)"

   if $flow(tosBool,$flowNr) {
      $userLB insert end "-------------------------------------------------------"
      $userLB insert end "IP TOS value: $flow(tos,$flowNr)"
   }
   if $flow(rsvpBool,$flowNr) {
      $userLB insert end "-------------------------------------------------------"
      $userLB insert end "RSVP parameters: $flow(rsvp,$flowNr)"
      $userLB insert end "Reservation style: $flow(style,$flowNr)"
      $userLB insert end "RESV parameters: $flow(resv,$flowNr)"
   }

   #mod data:
   for {set i 1} {$i <= $mod(number,$flowNr)} {incr i} {
      $userLB insert end "-------------------------------------------------------"
      $userLB insert end "Modify flow n. $i"
      $userLB insert end "Start time: $mod(start,$i,$flowNr)"
      $userLB insert end "Rate:  $mod(rate,$i,$flowNr)"
      $userLB insert end "Pattern  $mod(pattern,$i,$flowNr)"
      $userLB insert end "UDP packet payload size:  $mod(size,$i,$flowNr)"
   };
   $userLB see end
}







###################################################################
#------------------------------------------------------------------
#             AddParmaeter4
#------------------------------------------------------------------
###################################################################
   proc AddParameterU4 {} \
   {
      global done paramName paramValue
      global paramU4 pU4 countPU4
      global uni4

      set paramName  ""
      set paramValue ""

      toplevel .addpu4
      wm title .addpu4 "Add Parameter"
      wm resizable .addpu4 0 0
      wm protocol  .addpu4 WM_DELETE_WINDOW {;#do nothing}
      frame .addpu4.nameF
      frame .addpu4.valueF
      frame .addpu4.buttonsF
      pack  .addpu4.nameF .addpu4.valueF .addpu4.buttonsF -pady 3

      #name
      label .addpu4.nameF.nameL -text "Name"
      entry .addpu4.nameF.nameE -textvariable paramName -width 45
      pack  .addpu4.nameF.nameL -side left -padx 2
      pack  .addpu4.nameF.nameE -side right -padx 2

      #value
      label .addpu4.valueF.valueL -text "Value"
      entry .addpu4.valueF.valueE -textvariable paramValue -width 45
      pack  .addpu4.valueF.valueL -side left -padx 2
      pack  .addpu4.valueF.valueE -side right -padx 2

      #buttons
      button .addpu4.buttonsF.okB -text OK -command {set done ok}
      button .addpu4.buttonsF.cancelB -text Cancel -command {set done cancel}
      pack  .addpu4.buttonsF.okB .addpu4.buttonsF.cancelB  -side left -anchor c -expand true

      set done not_yet
      grab .addpu4
      tkwait variable done
      grab release .addpu4
      destroy .addpu4

      #OK or Cancel pressed, at this point
      if {![string compare $done ok]} \
      {
          if {![string compare "" [string trim $paramName]]} \
          {
	      #nothing eligible was specified
	      return
	  }
          incr countPU4
          set tmp "$paramName: $paramValue"
          set paramU4($tmp) $countPU4
          set pU4 "$tmp"

          destroy  $uni4.up.right.custom.b.bx
          eval tk_optionMenu $uni4.up.right.custom.b.bx pU4 [lsort [array names paramU4 ]]
          $uni4.up.right.custom.b.bx configure -width 20
          pack    $uni4.up.right.custom.b.bx  -side left
      }
  }

###################################################################
#------------------------------------------------------------------
#             Remove Parameter U4
#------------------------------------------------------------------
###################################################################
   proc RemoveParameterU4 {} \
   {
      global paramU4 pU4 countPU4
      global uni4

      if ![string compare $pU4 "(parameters)"] \
      {
         return
         #nothing selected
      }
      unset paramU4($pU4)
      set pU4 "(parameters)"
      destroy  $uni4.up.right.custom.b.bx
      eval tk_optionMenu $uni4.up.right.custom.b.bx pU4 [lsort [array names paramU4 ]]
      $uni4.up.right.custom.b.bx configure -width 20
      pack     $uni4.up.right.custom.b.bx  -side left
      incr countPU4 -1
   }


###################################################################
#------------------------------------------------------------------
#             Edit Parameter U4
#------------------------------------------------------------------
###################################################################

   proc EditParameterU4 {} \
   {
      global done paramName paramValue
      global paramU4 pU4 countPU4
      global uni4


      if ![string compare $pU4 "(parameters)"] \
      {
         return
         #nothing selected
      }

      set line $pU4
      set lindex     [string first : $line 0]
      set paramName  [string range   $line 0 [expr $lindex]]
      set paramValue [string range   $line   [expr $lindex +2]  [string length $line]]

      toplevel .dialog
      wm title .dialog "Edit Parameter"
      wm resizable .dialog 0 0
      wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

      label .dialog.titleL -text "Insert New Value"
      frame .dialog.paramF
      frame .dialog.buttonsF
      pack .dialog.titleL .dialog.paramF .dialog.buttonsF -pady 3
      label .dialog.paramF.numeL -text "$paramName"
   
      entry .dialog.paramF.valueE -textvariable paramValue -width 45
      pack .dialog.paramF.numeL -side left -padx 2
      pack .dialog.paramF.valueE -side right -padx 2
      button .dialog.buttonsF.okB -text OK -command {set done ok}
      button .dialog.buttonsF.cancelB -text Cancel -command {set done cancel}
      pack .dialog.buttonsF.okB .dialog.buttonsF.cancelB -side left \
      -anchor c -padx 5
      set done not_yet
      grab .dialog
      tkwait variable done
      grab release .dialog
      destroy .dialog

      if {![string compare $done ok]} \
      {
          unset paramU4($pU4)
          set tmp "$paramName $paramValue"
          set paramU4($tmp) $countPU4
          set pU4 "$tmp"

          destroy  $uni4.up.right.custom.b.bx
          eval tk_optionMenu $uni4.up.right.custom.b.bx pU4 [lsort [array names paramU4 ]]
          $uni4.up.right.custom.b.bx configure -width 20
          pack    $uni4.up.right.custom.b.bx  -side left
      }
   }

###################################################################
#------------------------------------------------------------------
#             EditFlow
#------------------------------------------------------------------
###################################################################
proc EditFlow { action } \
{
   global flow	  ;# flow data
   global flowLB  ;# flow list(box)
   global mod	  ;# flow modifier data
   global done	  ;# ok or cancel ?

   global flowNr


   if { $action == 0 } \
   {
      set flowNr [$flowLB curselection]
      if {$flowNr == ""} \
      {
        tk_messageBox -message "Select Flow...!!"
        #nothing selected
        return
      }
      incr flowNr
   } else { 
      set flowNr $action
   }
   set done not_yet

   toplevel .dialog
   wm title .dialog "Edit Flow No. $flowNr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true


   #standard params
   #(relative) flow start time:
   frame .dialog.fr1.name -bd 2 -relief groove
   pack  .dialog.fr1.name -pady 3 -padx 3 -fill x
   label .dialog.fr1.name.l -text "Flow Name"
   pack  .dialog.fr1.name.l -side top -padx 3
   entry .dialog.fr1.name.e -textvariable flow(name,$flowNr) -width 30
   pack  .dialog.fr1.name.e -side bottom -padx 3


   frame .dialog.fr1.fstart
   pack  .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Flow Start (ms)"
   pack  .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable flow(start,$flowNr)  -width 10
   pack .dialog.fr1.fstart.e -side right -padx 3

   #(relative) flow stop time
   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Flow Stop (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable flow(stop,$flowNr) \
   -width 10
   pack .dialog.fr1.fstop.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #port number. This will be verified at last
   #to have only flows with unique port numbers

   frame .dialog.fr1.fport
   pack .dialog.fr1.fport -pady 3 -fill x
   label .dialog.fr1.fport.l -text "Destination Port"
   pack .dialog.fr1.fport.l -side left -padx 3
   entry .dialog.fr1.fport.e -textvariable flow(port,$flowNr) \
   -width 10
   pack .dialog.fr1.fport.e -side right -padx 3

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
   -variable flow(pattern,$flowNr) -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
   -variable flow(pattern,$flowNr) -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
   -padx 2 -pady 2 -anchor w

   #rate:
   giveBandwidth "ipv4" $flow(rate,$flowNr) $flow(size,$flowNr) bandwidth
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable flow(rate,$flowNr) \
   -width 10 -validate focusout -vcmd {
	giveBandwidth "ipv4" $flow(rate,$flowNr) $flow(size,$flowNr) bandwidth
	return 1
      }
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable flow(size,$flowNr) \
   -width 10 -validate focusout -vcmd {
	giveBandwidth "ipv4" $flow(rate,$flowNr) $flow(size,$flowNr) bandwidth
	return 1
      }
   pack .dialog.fr1.fsize.e -side right -padx 3

   frame .dialog.fr1.frateshow
   pack .dialog.fr1.frateshow -pady 3 -fill x
   label .dialog.fr1.frateshow.l -text "Bandwidth ATM (Kbps)"
   pack .dialog.fr1.frateshow.l -side left -padx 3
   label .dialog.fr1.frateshow.l2 -textvariable bandwidth(atm)
   pack .dialog.fr1.frateshow.l2 -side right -padx 3
   
   frame .dialog.fr1.fratesheth
   pack .dialog.fr1.fratesheth -pady 3 -fill x
   label .dialog.fr1.fratesheth.l -text "Bandwidth Ethernet (Kbps)"
   pack .dialog.fr1.fratesheth.l -side left -padx 3
   label .dialog.fr1.fratesheth.l2 -textvariable bandwidth(eth)
   pack .dialog.fr1.fratesheth.l2 -side right -padx 3
   
   #frame 2: optional params
   #tos field:

   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Type-of-Service" \
   -variable flow(tosBool,$flowNr) -command {
   if $flow(tosBool,$flowNr) {
       .dialog.fr2.tosF.e config -state normal -fg black
       } else {
       .dialog.fr2.tosF.e config -state disabled -fg gray
       }
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable flow(tos,$flowNr) \
   -state disabled -width 10 -fg gray
   pack .dialog.fr2.tosF.e -side right -padx 3

   #RSVP:
   frame .dialog.fr2.rsvp
   pack .dialog.fr2.rsvp -pady 3 -fill x -anchor n
   checkbutton .dialog.fr2.rsvp.cb -text "Use RSVP" \
   -variable flow(rsvpBool,$flowNr) -command {
   if $flow(rsvpBool,$flowNr) {
       pack .dialog.fr2.rsvp.params -anchor n -fill x \
       -pady 3 -padx 3
       } else {
       pack forget .dialog.fr2.rsvp.params
       }
   }
   pack .dialog.fr2.rsvp.cb -padx 3 -anchor w

   frame .dialog.fr2.rsvp.params -bd 2 -relief groove
   #no need to pack it :-)

   label .dialog.fr2.rsvp.params.l -text "RSVP Parameters"
   pack .dialog.fr2.rsvp.params.l -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.e -textvariable flow(rsvp,$flowNr)
   pack .dialog.fr2.rsvp.params.e -fill x -padx 3 -pady 3

   frame .dialog.fr2.rsvp.params.style
   pack .dialog.fr2.rsvp.params.style -fill x
   label .dialog.fr2.rsvp.params.style.l -text "RESV Style"
   pack .dialog.fr2.rsvp.params.style.l -side left -padx 3

   frame .dialog.fr2.rsvp.params.style.rbF -bd 2 -relief groove
   pack .dialog.fr2.rsvp.params.style.rbF -padx 3 -pady 3

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb1 \
   -text "WF (Wildcard)" -variable flow(style,$flowNr) -value WF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb2 \
   -text "FF (Fixed-Filter)" -variable flow(style,$flowNr) -value FF

   radiobutton .dialog.fr2.rsvp.params.style.rbF.rb3 \
   -text "SE (Shared-Explicit)" -variable flow(style,$flowNr) -value SE

   pack .dialog.fr2.rsvp.params.style.rbF.rb1 \
   .dialog.fr2.rsvp.params.style.rbF.rb2 \
   .dialog.fr2.rsvp.params.style.rbF.rb3 -pady 3 -padx 3 -anchor w


   label .dialog.fr2.rsvp.params.lr -text "RESV Parameters"
   pack .dialog.fr2.rsvp.params.lr -padx 3 -pady 3 -anchor c
   entry .dialog.fr2.rsvp.params.er -textvariable flow(resv,$flowNr)
   pack .dialog.fr2.rsvp.params.er -fill x -padx 3 -pady 3

   #ok-cancel buttons on 3rd frame

   button .dialog.fr3.ok -text OK -command {
   set done ok
   destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3

   grab .dialog
   tkwait window .dialog

   #cancel was pressed
   if ![string compare $done cancel] { return  }

   #ok was pressed:
   #first verify that standard parameters are filled
   foreach elem {start stop port rate size} \
   {
      if ![string compare $flow($elem,$flowNr) ""] \
      {
         tk_messageBox -message "Missing Flow parameteres...!!"
         EditFlow $flowNr
         return
      }
   }

   #check port; must be unique for each flow
   for {set i 1} {$i <= $flow(number)} {incr i} \
   {
      if { $flow(port,$flowNr) == $flow(port,$i)  && $flowNr != $i }  \
      {
         tk_messageBox -message "Port value already used on flow $i"
         EditFlow $flowNr
         return
      }
   }
   $flowLB delete [expr $flowNr - 1]
   $flowLB insert [expr $flowNr - 1]  \
   [format "Flow  %02d   -   Mods  %02d  -  %s" \
   $flowNr $mod(number,$flowNr) $flow(name,$flowNr) ]
}

######################################################
#### Scripting Functions for IPv4
######################################################
proc RunScript4 {} {
   global debug
   global scriptLB

   global mod
   global mcalcpath4
   global decodepath4
   global host scenarioDir dly 
   global flow         ;#flow array to hold flows data
   global sender receiver
   global scriptElem   ;# Points to the next free element!
   global scrArray scripted4
   global logDelayLB   ;#status console

   if $debug {
      puts stderr "RunScript: BEGIN"
   }
   if ![info exists scriptElem] {
   	tk_messageBox -message "Must add at least one Step for saving"
        if $debug {
           puts stderr "RunScript: END"
        }
   	return
   }

   for {set i 0} {$i < $scriptElem} {incr i} {
      foreach index [array names receiver] {
         if [info exists scrArray($i,receiver,$index)] {
            set receiver($index) $scrArray($i,receiver,$index)
	    if $debug {
	        puts stderr "                   receiver($index): $scrArray($i,receiver,$index)"
	    }
	 } else {
		unset receiver($index)
         }
      }
      foreach index [array names sender] {
         if [info exists scrArray($i,sender,$index)] {
            set sender($index) $scrArray($i,sender,$index)
	    if $debug {
	       puts stderr "                   sender($index): $scrArray($i,sender,$index)"
	    }
	 } else {
            unset sender($index)
	 }
      }
      set mcalcpath4 $scrArray($i,mcalcpath4)
      set decodepath4 $scrArray($i,decodepath4)
      foreach index [array names dly] {
         if [info exists scrArray($i,dly,$index)] {
            set dly($index) $scrArray($i,dly,$index)
	    if $debug {
	       puts stderr "                   dly($index): $scrArray($i,dly,$index)"
	    }
	 } else {
            unset dly($index)
	 }
      }
      foreach index [array names host] {
         if [info exists scrArray($i,host,$index)] {
	    set host($index) $scrArray($i,host,$index)
	    if $debug {
	       puts stderr "                   host($index): $scrArray($i,host,$index)"
	    }
	 } else {
            unset host($index)
	 }	    
      }
      foreach index [array names scenarioDir] {
         if [info exists scrArray($i,scenarioDir,$index)] {
	    set scenarioDir($index) $scrArray($i,scenarioDir,$index)
	    if $debug {
	       puts stderr "                   scenarioDir($index): $scrArray($i,scenarioDir,$index)"
	    }
	 } else {
            unset scenarioDir($index)
	 }
      }
      foreach index [array names mod] {
         if [info exists scrArray($i,mod,$index)] {
	    set mod($index) $scrArray($i,mod,$index)
	    if $debug {
	       puts stderr "                   mod($index): $scrArray($i,mod,$index)"
	    }
	 } else {
            unset mod($index)
	 }
      }
      foreach index [array names flow] {
         if  [info exists scrArray($i,flow,$index)] {
	    set flow($index) $scrArray($i,flow,$index)
	    if $debug {
	       puts stderr "                   flow($index): $scrArray($i,flow,$index)"
	    }
	 } else {
            unset flow($index)
	 }
      }
      set scripted4 1
      $logDelayLB insert end "Running Scripted version step $i."
      update idletasks
      RunDelayTest
      $logDelayLB insert end "Finished step $i."
      update idletasks
   }
   set scripted4 0
   if $debug {
      puts stderr "RunScript6: END"
   }
}

proc SaveScript4 {} {
   global scriptElem
   global scrArray

   set TempFile "temp/script-file"

   if ![info exists scriptElem] {
   	tk_messageBox -message "Must add at least one Step for saving"
   	return
   }

   #Try to Save with New File NAME
   if [catch {open $TempFile w} idfile] {
   	tk_messageBox -message  "Failed saving configuration file"
   	return
   }
   set line ""
   set line "###############################################"
   puts $idfile $line
   set line "#  SCRIPT CONFIGURATION FILE FOR NETMETER     #"
   puts $idfile $line
   set line "###############################################"
   puts $idfile $line
   for {set outer_for 0} {$outer_for < $scriptElem} {incr outer_for} {
	set line "###START"
	puts $idfile $line

	set line "#sender:  address-interface-login-local for Unicast IPv4"
	puts $idfile $line
	set line "#sender"
	puts $idfile $line
	foreach i {address interface login local} {
		set line $scrArray($outer_for,sender,$i,ipv4,unicast)
		puts $idfile $line
	}
	set line "#receiver:  address-interface-login-local for U4"
	puts $idfile $line
	set line "#receiver"
	puts $idfile $line
	set line $scrArray($outer_for,receiver,address,ipv4,unicast)
	puts $idfile $line
	foreach i {interface login local} {
		set line $scrArray($outer_for,receiver,$i,ipv4)
		puts $idfile $line
	}
	set line "#host --> Unicast IPv4 address-interface"
	puts $idfile $line
	foreach i {address interface} {
		set line $scrArray($outer_for,host,$i,ipv4,unicast)
		puts $idfile $line
	}
	set line "#MainDirectory"
	puts $idfile $line
	set  line $scrArray($outer_for,scenarioDir,ipv4,unicast)
	puts $idfile $line

	if ($scrArray($outer_for,dly,startBool)) {
		set line "#StarTime"
		puts $idfile $line
		set  line $scrArray($outer_for,dly,start)
		puts $idfile $line
	}
	if ($scrArray($outer_for,dly,srcPortBool)) {
		set line "#SourcePort"
		puts $idfile $line
		set  line $scrArray($outer_for,dly,srcPort)
		puts $idfile $line
	}
	set line "#MgenDefs"
	puts $idfile $line
	set  line $scrArray($outer_for,dly,mgenPath,ipv4)
	puts $idfile $line
	set  line $scrArray($outer_for,dly,drecPath,ipv4)
	puts $idfile $line
	set  line $scrArray($outer_for,dly,resultsFile,ipv4)
	puts $idfile $line
	set  line $scrArray($outer_for,dly,title,ipv4)
	puts $idfile $line

	set line "#Decodepath"
	puts $idfile $line
	set  line $scrArray($outer_for,decodepath4)
	puts $idfile $line

	set line "#Mcalcpath"
	puts $idfile $line
	set  line $scrArray($outer_for,mcalcpath4)
	puts $idfile $line

	###########################################
	#SAVE ALL THE INFORMATION FOR ALL FLOW IPv4
	###########################################
	for {set countFL 1} {$countFL <= $scrArray($outer_for,flow,number)} {incr countFL}  \
	{
		set line "#FLOW4"
		puts $idfile $line

		#Standard parameters
		set line $countFL
		puts $idfile $line
		set line $scrArray($outer_for,flow,start,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,stop,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,port,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,pattern,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,rate,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,size,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,tosBool,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,tos,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,rsvpBool,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,rsvp,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,resv,$countFL)
		puts $idfile $line
		set line $scrArray($outer_for,flow,style,$countFL)
		puts $idfile $line

		#Modifications
		set line $scrArray($outer_for,mod,number,$countFL)
		puts $idfile $line
		for {set countFLm 1} {$countFLm <= $scrArray($outer_for,mod,number,$countFL)} {incr countFLm}  \
		{
			set line $scrArray($outer_for,mod,start,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,pattern,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,rate,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,size,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,tosBool,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,tos,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,rsvpBool,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,rsvp,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,resv,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray($outer_for,mod,style,$countFLm,$countFL)
			puts $idfile $line
		}
		set line $scrArray($outer_for,flow,name,$countFL)
		puts $idfile $line
	}
   } ;# End outer for (scriptElem)
   catch {close $idfile}
}

proc DeleteFromScript4 {} {

}

proc LoadScript4 {} {

}

proc AddToScript4 {} {
   global debug
   global scriptLB

   global mod
   global mcalcpath4
   global decodepath4
   global dly host scenarioDir
   global flow		;#flow array to hold flows data
   global sender receiver
   global scriptElem	;# Points to the next free element!
   global scrArray

   if ![info exists scriptElem] {
      set scriptElem 0
   }

   if $debug {
   	puts stderr "AddToScript4: BEGIN"
   	puts stderr "                   Copying Data at position $scriptElem"
   }
   for {set i 0} {$i < $scriptElem} {incr i} {
      if ![string compare $dly(resultsFile,ipv4) $scrArray($i,dly,resultsFile,ipv4)] {
         tk_messageBox -message "Sorry repeated Save Results file name with step $i"
         return
      }
   }
   foreach index [array names sender] {
     set scrArray($scriptElem,sender,$index) $sender($index)
     if $debug {
     	puts stderr "                   sender($index):   $scrArray($scriptElem,sender,$index)"
     }
   }
   foreach index [array names receiver] {
     set scrArray($scriptElem,receiver,$index) $receiver($index)
     if $debug {
     	puts stderr "                   receiver($index): $scrArray($scriptElem,receiver,$index)"
     }
   }
   foreach index [array names host] {
     set scrArray($scriptElem,host,$index) $host($index)
     if $debug {
     	puts stderr "                   host($index):     $scrArray($scriptElem,host,$index)"
     }
   }
   foreach index [array names scenarioDir] {
     set scrArray($scriptElem,scenarioDir,$index) $scenarioDir($index)
     if $debug {
     	puts stderr "                   scenarioDir($index):     $scrArray($scriptElem,scenarioDir,$index)"
     }
   }
   # Let's Copy all the dly data
   foreach index [array names dly] {
     set scrArray($scriptElem,dly,$index) $dly($index)
     if $debug {
     	puts stderr "                   dly($index):      $scrArray($scriptElem,dly,$index)"
     }
   }
   set scrArray($scriptElem,mcalcpath4) $mcalcpath4
   set scrArray($scriptElem,decodepath4) $decodepath4

   # Let's Copy all the flow array
   foreach index [array names flow] {
     set scrArray($scriptElem,flow,$index) $flow($index)
     if $debug {
     	puts stderr "                   flow($index):     $scrArray($scriptElem,flow,$index)"
     }
   }
   # Let's Copy all the mod array
   foreach index [array names mod] {
     set scrArray($scriptElem,mod,$index) $mod($index)
     if $debug {
     	puts stderr "                   mod($index):     $scrArray($scriptElem,mod,$index)"
     }
   }
   if $debug {
   	puts stderr "                   End Copying Data"
   	puts stderr "                   Begin update Script Listbox"
   }
   if {$scrArray($scriptElem,sender,local,ipv4,unicast)} {
      $scriptLB insert end [format "Step %02d - From Local - To %s - Filename %s" $scriptElem \
	     $scrArray($scriptElem,receiver,address,ipv4,unicast) $scrArray($scriptElem,dly,resultsFile,ipv4)]
   } elseif {$scrArray($scriptElem,receiver,local,ipv4)} {
      $scriptLB insert end [format "Step %02d - From %s - To Local - Filename %s" $scriptElem \
	     $scrArray($scriptElem,sender,address,ipv4,unicast) $scrArray($scriptElem,dly,resultsFile,ipv4)]
   } else {
      $scriptLB insert end [format "Step %02d - From %s - To %s - Filename %s" $scriptElem \
             $scrArray($scriptElem,sender,address,ipv4,unicast) \
	     $scrArray($scriptElem,receiver,address,ipv4,unicast) $scrArray($scriptElem,dly,resultsFile,ipv4)]
   }
   update idletasks

   incr scriptElem
   if $debug {
   	puts stderr "AddToScript4: END"
   }
}

