###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                      Roberto Borgione       #
#                                             #
# delayu6a.tcl - Unicast   Delay IPv6 Manager #
#       v2.0 (04-2002)                        #
#       v2.01(10-2002)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

###################################################################
#------------------------------------------------------------------
#             Delay:Du6      (Unicast Ipv6 case)
#------------------------------------------------------------------
###################################################################
proc Delay:Du6 {}\
{
   #variable ipversion indipendent
   global sender receiver host
   global dly
   global uni6
   global head6
   global decodepath
   global mcalcpath
   global userLB6

   #variable ipversion dipendent
   global flow6		;#flow array to hold flows data
   global flow6LB	;#flows listbox
   global mod6

   global logDelayLB6	;#status console
   global customEndD6
   global runB6		;#run test button
   global xflowview6

   global KeySocket
   global socksize
   global KeySource
   global ipv6SourceAddress
   global paramU6 pU6 countPU6
   global uni6

   global scriptLB6
   
   set xflowview6 1977

   set customEndD 0
   #script listbox
   frame $uni6.up
   pack $uni6.up -pady 3 -fill x

   #up-left frame (options)
   frame $uni6.up.left -bd 2 -relief groove
   pack $uni6.up.left -pady 3 -fill x -side left -anchor n

   #up-right frame (script listboxes)
   frame $uni6.up.right -bd 2 -relief groove
   pack $uni6.up.right -pady 3 -padx 3 -fill both -side right \
   -expand true -anchor n

   ##############################################################
   ## define widgets for mgen and drec options
   ##############################################################
   label $uni6.up.left.titleL -text "IPv6 - Mgen6 and Drec6 Options" -relief raised
   pack $uni6.up.left.titleL  -anchor c  -fill x -padx 3 -pady 3

   frame $uni6.up.left.title
   pack $uni6.up.left.title -pady 2 -fill x
   label $uni6.up.left.title.l -text "Title measure"
   pack $uni6.up.left.title.l -side left -padx 3
   entry $uni6.up.left.title.e -textvariable dly(title,ipv6) -width 28
   pack $uni6.up.left.title.e -side right -padx 3

   #### Start time
   frame $uni6.up.left.start
   pack $uni6.up.left.start -pady 3 -fill x
   checkbutton $uni6.up.left.start.cB -variable dly(startBool6) \
     -text "Start (hh:mm:ss)" -command {
      if $dly(startBool6) {
          #enable entry
          $uni6.up.left.start.e config -state normal -fg black
      } else {
          #disable entry
          $uni6.up.left.start.e config -state disabled -fg gray
      }
   }
   if $dly(startBool6) {
      entry $uni6.up.left.start.e -textvariable dly(start6) -state normal
   } else {
      entry $uni6.up.left.start.e -textvariable dly(start6) -state disabled -fg gray
   }
   pack $uni6.up.left.start.cB -padx 3 -side left
   pack $uni6.up.left.start.e  -padx 3 -side right

   ###################################################### 
   #### Source port ##################################### 
   ###################################################### 

   frame $uni6.up.left.srcPort
   pack  $uni6.up.left.srcPort -pady 3 -fill x
   checkbutton $uni6.up.left.srcPort.cB -variable dly(srcPortBool6) \
   -text "Source Port" -command {
      if $dly(srcPortBool6) {
         #enable entry
         $uni6.up.left.srcPort.e config -state normal -fg black
      } else {
         #disable entry
         $uni6.up.left.srcPort.e config -state disabled -fg gray
      }
   }
   if $dly(srcPortBool6) {
      #enable entry
      entry $uni6.up.left.srcPort.e -textvariable dly(srcPort6) -state normal  
   } else {
      #disable entry
      entry $uni6.up.left.srcPort.e -textvariable dly(srcPort6) -state disabled -fg gray  
   }
   pack $uni6.up.left.srcPort.cB -padx 3 -side left
   pack $uni6.up.left.srcPort.e -padx 3 -side right

   ###################################################### 
   #### Source Address ##################################
   ###################################################### 
   frame $uni6.up.left.addrPort
   checkbutton $uni6.up.left.addrPort.cB -variable KeySource \
   -text "Source Address" -command {
      if $KeySource {
         #enable entry
         $uni6.up.left.addrPort.e config -state normal -fg black
      } else {
         #disable entry
         $uni6.up.left.addrPort.e config -state disabled -fg gray
      }
   }
   if $KeySource {
      #enable entry
      entry $uni6.up.left.addrPort.e -textvariable ipv6SourceAddress -state normal  
   } else {
      #disable entry
      entry $uni6.up.left.addrPort.e -textvariable ipv6SourceAddress -state disabled -fg gray  
   }

   ###################################################### 
   #### Socket size ##################################### 
   ###################################################### 
   frame       $uni6.up.left.socket
   checkbutton $uni6.up.left.socket.check -variable KeySocket -text "Socket buffer size" -command {
      if $KeySocket {
          #enable entry
          $uni6.up.left.socket.entry config -state normal -fg black
      } else {
          #disable entry
          $uni6.up.left.socket.entry config -state disabled -fg gray
      }
   }
   if $KeySocket {
      entry $uni6.up.left.socket.entry -textvariable socksize -state normal  
   } else {
      entry $uni6.up.left.socket.entry -textvariable socksize -state disabled -fg gray  
   }

   ######################################################### 
   # flows list
   ######################################################### 
   frame  $uni6.up.left.flowl -bd 2 -relief groove
   pack $uni6.up.left.flowl -fill x -pady 5

   #a label
   label $uni6.up.left.flowl.label -text "Flows List - (type IPv6)" -relief sunken 
   pack $uni6.up.left.flowl.label -side top -fill x -pady 3

   #listbox for displaying currently defined
   #flows and their properties
   set flow6LB [listbox $uni6.up.left.flowl.flowlist -height 7]
   set fsy [scrollbar $uni6.up.left.flowl.flowsy -orient vertical \
   -command "$flow6LB yview"]
   $flow6LB config -yscrollcommand "$fsy set"

   bind $uni6.up.left.flowl.flowlist <Double-1> {
     Viewflow6
   }

   pack $fsy -side right -fill y -pady 3
   pack $flow6LB -side left -fill both  -expand true

   #############################################################
   ## frame for flow operations: add, delete, and MODify
   #############################################################
   frame $uni6.up.left.flow
   pack $uni6.up.left.flow 
   button $uni6.up.left.flow.editB -text "Edit\nFlow\n" \
   -command { Editflow6 0 } -bd 2 -relief groove -width 2
   button $uni6.up.left.flow.addB -text "Add\nnew\nFlow" \
   -command { Addflow6 0 } -bd 2 -relief groove -width 4
   button $uni6.up.left.flow.delB -text "Delete\nlast\nFlow" \
   -command Deleteflow6 -bd 2 -relief groove   -width 4
   button $uni6.up.left.flow.modB -text "Add\nchanges\nto Flow" \
   -command Modifyflow6 -bd 2 -relief groove   -width 6
   button $uni6.up.left.flow.addHB -text "Add\nextension\nheader" \
   -command AddHeader6 -bd 2 -relief groove    -width 6

   pack $uni6.up.left.flow.editB $uni6.up.left.flow.addB $uni6.up.left.flow.modB \
   $uni6.up.left.flow.addHB $uni6.up.left.flow.delB -padx 3 -anchor c -side left
   #$uni6.up.left.flow.viewB     \
   $uni6.up.left.flow.delB -padx 1 -anchor c -side left

   #############################################################
   ## Listbox View selected Flow
   #############################################################
   frame $uni6.up.right.custom -bd 2 -relief groove
   pack  $uni6.up.right.custom -fill x

   frame  $uni6.up.right.custom.b
   pack   $uni6.up.right.custom.b  -side bottom -expand true
   label  $uni6.up.right.custom.b.l -text "Parameters"
   pack   $uni6.up.right.custom.b.l -side left
   button $uni6.up.right.custom.b.b1 -text "Add" \
      -command AddParameterU6 -bd 2 -relief groove -width 2
   button $uni6.up.right.custom.b.b2 -text "Edit" \
      -command EditParameterU6 -bd 2 -relief groove -width 2
   button $uni6.up.right.custom.b.b3 -text "Del" \
      -command RemoveParameterU6 -bd 2 -relief groove -width 2

   set x "(parameters)"
   set paramU6($x) "0"
   eval tk_optionMenu $uni6.up.right.custom.b.bx pU6 [lsort [array names paramU6 ]]
   $uni6.up.right.custom.b.bx configure -width 20

   pack $uni6.up.right.custom.b.b1 $uni6.up.right.custom.b.b3\
   $uni6.up.right.custom.b.b2 $uni6.up.right.custom.b.bx -side left
   label $uni6.up.right.custom.l -text "flow parameters (to select double click on flow list)"
   pack  $uni6.up.right.custom.l -padx 3 -anchor c
   frame $uni6.up.right.custom.lb
   pack $uni6.up.right.custom.lb -pady 3 -fill both -expand true
   set userLB6 [listbox $uni6.up.right.custom.lb.customLB -height 6]
   set usy [scrollbar $uni6.up.right.custom.lb.sY -orient vertical\
      -command "$userLB6 yview"]
    set usx [scrollbar $uni6.up.right.custom.lb.sX -orient horizontal\
      -command "$userLB6 xview"]
   $userLB6 config -yscrollcommand "$usy set" -xscrollcommand "$usx set"

   pack $usy -side right -fill y -pady 2
   pack $usx -side bottom -fill x -padx 2
   pack $userLB6 -fill both -padx 2 -pady 2 -side left -expand true

   #############################################################
   ## frame for path settings and features :)
   #############################################################
   frame $uni6.up.right.path
   pack $uni6.up.right.path -fill x -pady 3 \
      -expand true -padx 3


   #and settings
   frame $uni6.up.right.path.mgenPath
   pack $uni6.up.right.path.mgenPath -pady 2 -fill x
   label $uni6.up.right.path.mgenPath.l -text "(SRC)Set Mgen Path"
   pack $uni6.up.right.path.mgenPath.l -side left -padx 3
   entry $uni6.up.right.path.mgenPath.e -textvariable dly(mgenPath,ipv6) -width 24  
   pack $uni6.up.right.path.mgenPath.e -side right -padx 3
 
   frame $uni6.up.right.path.drecPath
   pack $uni6.up.right.path.drecPath -pady 2 -fill x
   label $uni6.up.right.path.drecPath.l -text "(DST)Set Drec Path"
   pack $uni6.up.right.path.drecPath.l -side left -padx 3
   entry $uni6.up.right.path.drecPath.e -textvariable dly(drecPath,ipv6) -width 24  
   pack $uni6.up.right.path.drecPath.e -side right -padx 3

   frame $uni6.up.right.path.decodepath
   pack $uni6.up.right.path.decodepath -pady 2 -fill x
   label $uni6.up.right.path.decodepath.l -text "(DST)Set Decode Path"
   pack $uni6.up.right.path.decodepath.l -side left -padx 3 
   entry $uni6.up.right.path.decodepath.e -textvariable decodepath  -width 24  
   pack $uni6.up.right.path.decodepath.e -side right -padx 3 

   frame $uni6.up.right.path.mcalcpath
   pack $uni6.up.right.path.mcalcpath -pady 2 -fill x 
   label $uni6.up.right.path.mcalcpath.l -text "(LOC)Set Mcalc Path"
   pack $uni6.up.right.path.mcalcpath.l -side left -padx 3 
   entry $uni6.up.right.path.mcalcpath.e -textvariable mcalcpath -width 24  
   pack $uni6.up.right.path.mcalcpath.e -side right -padx 3 


   frame $uni6.up.right.path.delaySave
   pack $uni6.up.right.path.delaySave -pady 2 -fill x
   label $uni6.up.right.path.delaySave.l -text "(LOC)Save Results File"
   pack $uni6.up.right.path.delaySave.l -side left -padx 3
   entry $uni6.up.right.path.delaySave.e -textvariable dly(resultsFile,ipv6) -width 24  
   pack $uni6.up.right.path.delaySave.e -side right -padx 3

   #down frame
   frame $uni6.down
   pack $uni6.down -fill x

   #frame for action buttons:
   frame $uni6.down.action -bd 2 -relief groove
   pack $uni6.down.action -padx 3 -padx 3 -side left

   #and the buttons
   set runB6 [button $uni6.down.action.rB -text "Run Test" \
      -command RunDelayTest6  -width 16]

   button $uni6.down.action.resg -text "Graphic Resuls" \
   -command "NetGRAPH mcl" -width 16
   button $uni6.down.action.resdB -text "Graphic Distributions" \
      -command Distribution -width 16

   pack $uni6.down.action.rB  $uni6.down.action.resg $uni6.down.action.resdB -anchor n

   #console frame,listbox and scrollbar:
   frame $uni6.down.consoleF
   pack $uni6.down.consoleF -pady 2 -side left -fill x -anchor n -expand true
   set logDelayLB6 [listbox $uni6.down.consoleF.consoleLB -height 5 -font default]

   set csy [scrollbar $uni6.down.consoleF.sY -orient vertical -command "$logDelayLB6 yview"]
   $logDelayLB6 config -yscrollcommand "$csy set"
   pack $csy -fill y -side right
   pack $logDelayLB6 -fill both -side left -expand true

    # Frame for scripting List
   frame $uni6.scriptInfo
   pack $uni6.scriptInfo -fill both -anchor n -expand true

   set scriptLB6 [listbox $uni6.scriptInfo.scrDownLB -height 5 -font default]
   set scrollScr6 [scrollbar $uni6.scriptInfo.sY -orient vertical -command "$scriptLB6 yview"]
   $scriptLB6 config -yscrollcommand "$scrollScr6 set"
   pack $scrollScr6 -fill y -side right
   pack $scriptLB6 -fill both -side left -expand true
  
   #frame for scripting buttons:
   frame $uni6.scripting
   pack $uni6.scripting -fill x

   frame $uni6.scripting.scriptB
   pack $uni6.scripting.scriptB -side left
   button $uni6.scripting.scrRun -text "Run Script" -command RunScript6  -width 10
   button $uni6.scripting.scrAdd -text "Add To Script" -command AddToScript6  -width 10
#   button $uni6.scripting.scrDel -text "Delete Entry" \
#      -command DeleteFromScript6  -width 10
#   button $uni6.scripting.scrLoad -text "Load Script" \
#      -command LoadScript6  -width 10
#   button $uni6.scripting.scrSave -text "Save Script" \
#      -command SaveScript6  -width 10
#   pack $uni6.scripting.scrRun $uni6.scripting.scrAdd $uni6.scripting.scrDel $uni6.scripting.scrLoad $uni6.scripting.scrSave -side left
   pack $uni6.scripting.scrRun $uni6.scripting.scrAdd -side left -fill x -anchor n -expand true

   frame $uni6.scripting.quitF
   pack $uni6.scripting.quitF -side left -fill x -anchor n -expand true

   button $uni6.scripting.quitF.quitB -text "Quit" -command Quit -width 16
   pack $uni6.scripting.quitF.quitB -side left -fill x -expand true
   
  # Flow Loading   
   $flow6LB delete 0 end
   $flow6LB see end
   for {set countFL 1} {$countFL <= $flow6(number)} {incr countFL}  \
   { 
     $flow6LB insert end [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
     $countFL $mod6(number,$countFL) $head6(number,$flow6(number)) $flow6(name,$countFL) ]
   }
   $flow6LB see end

};

###################################################################
#------------------------------------------------------------------
#             ADDflow6
#------------------------------------------------------------------
###################################################################
proc Addflow6 { action } \
{
   global flow6	    ;# flow data
   global flow6LB   ;# flow list(box)
   global mod6	    ;# flow modifier data
   global head6	    ;# flow modifier data
   global done6	    ;# ok or cancel ?


   if { $action == 0 } \
   {
      incr flow6(number)
      # VERY usefull when write sequency flows ;)
      if { $flow6(number) > 1 } \
      {

         set flow6(name,$flow6(number))    $flow6(name,[expr $flow6(number) - 1]) 
         set flow6(start,$flow6(number))   $flow6(stop,[expr $flow6(number) - 1]) 
         set flow6(stop,$flow6(number))    $flow6(stop,[expr $flow6(number) - 1]) 
         set flow6(port,$flow6(number))    [expr $flow6(port,[expr $flow6(number) - 1]) +1 ]
         set flow6(pattern,$flow6(number)) $flow6(pattern,[expr $flow6(number) - 1])
         set flow6(rate,$flow6(number))    $flow6(rate,[expr $flow6(number) - 1]) 
         set flow6(size,$flow6(number))    $flow6(size,[expr $flow6(number) - 1])  
      } else {
         set    flow6(start,$flow6(number)) {}
         set    flow6(stop,$flow6(number)) {}
         set    flow6(port,$flow6(number)) {}
         set    flow6(pattern,$flow6(number)) PERIODIC
         set    flow6(rate,$flow6(number)) {}
         set    flow6(size,$flow6(number)) {}
      }
      set  flow6(tosBool,$flow6(number)) 0
      set  flow6(tos,$flow6(number)) {}
      set  mod6(number,$flow6(number)) 0
      set  head6(number,$flow6(number)) 0
   }

   set done6 not_yet

   #make a dialog window
   toplevel .dialog
   wm title .dialog "IPv6 - Flow No. $flow6(number)"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:
   #frames for standard params, optional
   #params and ok-cancel buttons
   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
     -anchor n -expand true

   #standard params
   #(relative) flow start time:
   frame .dialog.fr1.name -bd 2 -relief groove
   pack  .dialog.fr1.name -pady 3 -padx 3 -fill x
   label .dialog.fr1.name.l -text "Flow Name"
   pack  .dialog.fr1.name.l -side top -padx 3
   entry .dialog.fr1.name.e -textvariable flow6(name,$flow6(number)) -width 36  
   pack  .dialog.fr1.name.e -side bottom -padx 3

   frame .dialog.fr1.fstart
   pack  .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Flow Start (ms)"
   pack  .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable flow6(start,$flow6(number)) -width 20  
   pack .dialog.fr1.fstart.e -side right -padx 3

   #(relative) flow stop time
   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Flow Stop (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable flow6(stop,$flow6(number)) -width 20  
   pack .dialog.fr1.fstop.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #port number. This will be verified at last
   #to have only flows with unique port numbers

   frame .dialog.fr1.fport
   pack .dialog.fr1.fport -pady 3 -fill x
   label .dialog.fr1.fport.l -text "Destination Port"
   pack .dialog.fr1.fport.l -side left -padx 3
   entry .dialog.fr1.fport.e -textvariable flow6(port,$flow6(number)) -width 15  
   pack .dialog.fr1.fport.e -side right -padx 3

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
      -variable flow6(pattern,$flow6(number)) -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
      -variable flow6(pattern,$flow6(number)) -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
      -padx 2 -pady 2 -anchor w

   #rate:
   giveBandwidth "ipv6" $flow6(rate,$flow6(number)) $flow6(size,$flow6(number)) bandwidth
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable flow6(rate,$flow6(number)) -width 15   \
	-validate focusout -vcmd {
	giveBandwidth "ipv6" $flow6(rate,$flow6(number)) $flow6(size,$flow6(number)) bandwidth
	return 1
      }
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable flow6(size,$flow6(number))   \
      -width 15 -validate focusout -vcmd {
	giveBandwidth "ipv6" $flow6(rate,$flow6(number)) $flow6(size,$flow6(number)) bandwidth
	return 1
      }
   pack .dialog.fr1.fsize.e -side right -padx 3

   frame .dialog.fr1.frateshow
   pack .dialog.fr1.frateshow -pady 3 -fill x
   label .dialog.fr1.frateshow.l -text "Bandwidth ATM (Kbps)"
   pack .dialog.fr1.frateshow.l -side left -padx 3
   label .dialog.fr1.frateshow.l2 -textvariable bandwidth(atm)
   pack .dialog.fr1.frateshow.l2 -side right -padx 3
   
   frame .dialog.fr1.fratesheth
   pack .dialog.fr1.fratesheth -pady 3 -fill x
   label .dialog.fr1.fratesheth.l -text "Bandwidth Ethernet (Kbps)"
   pack .dialog.fr1.fratesheth.l -side left -padx 3
   label .dialog.fr1.fratesheth.l2 -textvariable bandwidth(eth)
   pack .dialog.fr1.fratesheth.l2 -side right -padx 3
   
   #frame 2: optional params

   #tos field:
   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Traffic Class" \
      -variable flow6(tosBool,$flow6(number)) -command {
	if $flow6(tosBool,$flow6(number)) {
		.dialog.fr2.tosF.e config -state normal -fg black
	} else {
		.dialog.fr2.tosF.e config -state disabled -fg gray
	}
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable flow6(tos,$flow6(number))   \
     -state disabled -width 10 -fg gray
   pack .dialog.fr2.tosF.e -side right -padx 3
   
   #ok-cancel buttons on 3rd frame
   button .dialog.fr3.ok -text OK -command {
      set done6 ok
      destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
	set done6 cancel
	destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left -padx 3 -pady 3

   grab .dialog
   tkwait window .dialog

   if ![string compare $done6 cancel] {
	#cancel was pressed
	#unset data and decrement number of flows
	foreach elem {start stop port rate pattern size tosBool tos} {
		unset flow6($elem,$flow6(number))
	}
	unset mod6(number,$flow6(number))
	unset head6(number,$flow6(number))

	incr flow6(number) -1
	return
   }

   #ok was pressed:
   #first verify that standard parameters are filled

   foreach elem {start stop port rate size} {
     if ![string compare $flow6($elem,$flow6(number)) ""] {
         tk_messageBox -message "Missing Flow parameteres...!!"
         Addflow6 1 
         return
     }
   }

   if $flow6(tosBool,$flow6(number)) {
   	set toDel $flow6(tos,$flow6(number))
	if {[catch {incr toDel}] } {
		tk_messageBox -message "Traffic Class has to be integer (MGEN restriction)"
		Addflow6 1
		return
	}
	incr toDel -1
	set flow6(tos,$flow6(number)) $toDel
   }
   
   #check port; must be unique for each flow
   for {set i 1} {$i < $flow6(number)} {incr i} {
     if {$flow6(port,$flow6(number)) == $flow6(port,$i)} {
         tk_messageBox -message "Port value already used on flow $i"
         Addflow6 1 
         return
     }
   }

   #data is ok, update listbox:
   $flow6LB insert end [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
        $flow6(number) $mod6(number,$flow6(number)) $head6(number,$flow6(number)) $flow6(name,$flow6(number)) ] 
};

###################################################################
#------------------------------------------------------------------
#             MODifyFlow6
#------------------------------------------------------------------
###################################################################
proc Modifyflow6 {} \
{

   global flow6 mod6 head6 flow6LB done6 flow6Nr

   #get the line index
   set flow6Nr [$flow6LB curselection]

   if {$flow6Nr == ""} {
	#nothing selected
	return
   }
   #else
   incr flow6Nr
   #deal with data
   incr mod6(number,$flow6Nr)
   set  mod6(start,$mod6(number,$flow6Nr),$flow6Nr)   $flow6(start,$flow6Nr)
   set  mod6(pattern,$mod6(number,$flow6Nr),$flow6Nr) $flow6(pattern,$flow6Nr)
   set  mod6(rate,$mod6(number,$flow6Nr),$flow6Nr)    $flow6(rate,$flow6Nr)
   set  mod6(size,$mod6(number,$flow6Nr),$flow6Nr)    $flow6(size,$flow6Nr)
   set  mod6(tosBool,$mod6(number,$flow6Nr),$flow6Nr) $flow6(tosBool,$flow6Nr)
   set  mod6(tos,$mod6(number,$flow6Nr),$flow6Nr)     $flow6(tos,$flow6Nr)
   
   set  done6 not_yet

   #make a dialog window
   toplevel .dialog
   wm title .dialog "IPv6 - MODify Flow $flow6Nr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:

   #frames for standard params, optional
   #params and ok-cancel buttons

   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true
   #standard params
   #(relative) flow start time:

   frame .dialog.fr1.fstart
   pack  .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "MODify Flow Start (ms)"
   pack  .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable mod6(start,$mod6(number,$flow6Nr),$flow6Nr) -width 10  
   pack .dialog.fr1.fstart.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
      -variable mod6(pattern,$mod6(number,$flow6Nr),$flow6Nr)  -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
      -variable mod6(pattern,$mod6(number,$flow6Nr),$flow6Nr)  -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
      -padx 2 -pady 2 -anchor w

   #rate:
   giveBandwidth "ipv6" $mod6(rate,$mod6(number,$flow6Nr),$flow6Nr) $mod6(size,$mod6(number,$flow6Nr),$flow6Nr) bandwidth
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable mod6(rate,$mod6(number,$flow6Nr),$flow6Nr)   \
      -width 10 -validate focusout -vcmd {
      	giveBandwidth "ipv6" $mod6(rate,$mod6(number,$flow6Nr),$flow6Nr) $mod6(size,$mod6(number,$flow6Nr),$flow6Nr) bandwidth
	return 1
   }
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable mod6(size,$mod6(number,$flow6Nr),$flow6Nr)   \
      -width 10 -validate focusout -vcmd {
      	giveBandwidth "ipv6" $mod6(rate,$mod6(number,$flow6Nr),$flow6Nr) $mod6(size,$mod6(number,$flow6Nr),$flow6Nr) bandwidth
	return 1
   }
   pack .dialog.fr1.fsize.e -side right -padx 3

   frame .dialog.fr1.frateshow
   pack .dialog.fr1.frateshow -pady 3 -fill x
   label .dialog.fr1.frateshow.l -text "Bandwidth ATM (Kbps)"
   pack .dialog.fr1.frateshow.l -side left -padx 3
   label .dialog.fr1.frateshow.l2 -textvariable bandwidth(atm)
   pack .dialog.fr1.frateshow.l2 -side right -padx 3
   
   frame .dialog.fr1.fratesheth
   pack .dialog.fr1.fratesheth -pady 3 -fill x
   label .dialog.fr1.fratesheth.l -text "Bandwidth Ethernet (Kbps)"
   pack .dialog.fr1.fratesheth.l -side left -padx 3
   label .dialog.fr1.fratesheth.l2 -textvariable bandwidth(eth)
   pack .dialog.fr1.fratesheth.l2 -side right -padx 3
   
   #tos field:
   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Traffic Class" \
      -variable mod6(tosBool,$mod6(number,$flow6Nr),$flow6Nr)  -command {
	if $mod6(tosBool,$mod6(number,$flow6Nr),$flow6Nr)  {
		.dialog.fr2.tosF.e config -state normal -fg black
	} else {
		.dialog.fr2.tosF.e config -state disabled -fg gray
	}
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable mod6(tos,$mod6(number,$flow6Nr),$flow6Nr)   \
     -state disabled -width 10 -fg gray
   pack .dialog.fr2.tosF.e -side right -padx 3

   #ok-cancel buttons on 3rd frame
   button .dialog.fr3.ok -text OK -command {
      set done6 ok
      destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
	set done6 cancel
	destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
      -padx 3 -pady 3

   if $mod6(tosBool,$mod6(number,$flow6Nr),$flow6Nr)  {
	.dialog.fr2.tosF.e config -state normal -fg black
   } else {
   	.dialog.fr2.tosF.e config -state disabled -fg gray
   }

   grab .dialog
   tkwait window .dialog

   if ![string compare $done6 cancel] {
	#cancel was pressed

	#unset data and decrement number of flows
	foreach elem {start rate pattern size tosBool tos} {
		unset mod6($elem,$mod6(number,$flow6Nr),$flow6Nr)
	}
	incr mod6(number,$flow6Nr) -1
	return
   }

   #ok was pressed:
   #first verify that standard parameters are filled

   foreach elem {start rate size} {
	if ![string compare $mod6($elem,$mod6(number,$flow6Nr),$flow6Nr) ""] {
		tk_messageBox -message "Flow MOD not added"
		#unset data and decrement number of flows
		foreach elem {start rate pattern size tosBool tos} {
			unset mod6($elem,$mod6(number,$flow6Nr),$flow6Nr)
		}
		incr mod6(number,$flow6Nr) -1
		return
	};#end if
   };#end foreach

   #in this point, data is ok
   #update listbox:

   $flow6LB delete [expr $flow6Nr - 1]
   $flow6LB insert [expr $flow6Nr - 1] [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
      $flow6Nr $mod6(number,$flow6Nr) $head6(number,$flow6Nr) $flow6(name,$flow6Nr) ] 
};

###################################################################
#------------------------------------------------------------------
#                      DELETE LAST FLOW
#------------------------------------------------------------------
###################################################################
proc Deleteflow6 {} \
{
   global flow6 mod6 flow6LB head6
   global xflowview6
   global userLB6


   #check number of flows:
   if !$flow6(number) {
      return
   }
   if  { $xflowview6 == $flow6(number) } \
   {
      $userLB6 delete 0 end
   }



   #first, delete all the mod data associated with the flow:
   for {set i 1} {$i <= $mod6(number,$flow6(number))} {incr i} {
      foreach elem {start rate pattern size tosBool tos} \
      {
         unset mod6($elem,$i,$flow6(number))
      };
   };
   #unset mod6 counter:
   unset mod6(number,$flow6(number))

   #second, delete all the extension header associated with the flow:
   for {set i 1} {$i <= $head6(number,$flow6(number))} {incr i} {
      #tk_messageBox -message "option =  $head6(option,$i,$flow6(number))"
      #tk_messageBox -message "data  =   $head6(data,$i,$flow6(number))"
      foreach elem {  start stop data option } \
      {
         unset head6($elem,$i,$flow6(number))
      }
   };
   #unset head6 counter:
   unset head6(number,$flow6(number))

   #then, delete the flow (last flow)
   foreach elem {start stop port rate pattern size tosBool tos} {
      unset flow6($elem,$flow6(number))
   };
   #decrement flow number
   incr flow6(number) -1

   #update listbox
   $flow6LB delete end end
};

###################################################################
#------------------------------------------------------------------
#         sub-procedure in ADDHeader IPv6
#------------------------------------------------------------------
###################################################################
proc update_header_option {} \
{
   global  opt  .dialog

   pack forget .dialog.fr1.update
   pack forget .dialog.fr1.jumbo
   pack forget .dialog.fr1.req
   pack forget .dialog.fr1.ack
   pack forget .dialog.fr1.home
   pack forget .dialog.fr1.routing
   pack forget .dialog.fr1.alert

   switch $opt \
   {
      BINDING_UPDATE { pack .dialog.fr1.update -anchor n -fill x -pady 3 -padx 3 }
      BINDING_ACK    { pack .dialog.fr1.ack -anchor n -fill x -pady 3    -padx 3 }
      BINDING_REQ    { pack .dialog.fr1.req -anchor n -fill x -pady 3   -padx 3  }
      ROUTING_HEADER { pack .dialog.fr1.routing -anchor n -fill x -pady 3 -padx 3}
      HOME_ADDRESS_OPTION  { pack .dialog.fr1.home -anchor n -fill x -pady 3  -padx 3  }
      ROUTER_ALERT_OPTION  { pack .dialog.fr1.alert -anchor n -fill x -pady 3 -padx 3  }
      JUMBO_PAYLOAD_OPTION { pack .dialog.fr1.jumbo -anchor n -fill x -pady 3 -padx 3  }
   }
}



###################################################################
#------------------------------------------------------------------
#          Add options for extensions headers (mobile ipv6)
#------------------------------------------------------------------
###################################################################
proc AddHeader6 {} \
{
   #(mobile ipv6)
   global flow6 head6 flow6LB done6 flow6Nr
   global opt mod6

   #get the line index
   set flow6Nr [$flow6LB curselection]

   if {$flow6Nr == ""} {
      #nothing selected
      return
   }
   #else
   incr flow6Nr
   #deal with data

   incr head6(number,$flow6Nr)

   #no port choice; is better that one flow has just one port
   set  head6(start,$head6(number,$flow6Nr),$flow6Nr) $flow6(start,$flow6Nr)
   set  head6(stop,$head6(number,$flow6Nr),$flow6Nr)  $flow6(stop,$flow6Nr)
   set  head6(option,$head6(number,$flow6Nr),$flow6Nr) ""
   set  head6(data,$head6(number,$flow6Nr),$flow6Nr) ""

   set done6 not_yet
   #make a dialog window
   toplevel .dialog
   wm title .dialog "IPv6 - Add option: Flow $flow6Nr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:
   #frames for standard params, optional
   #params and ok-cancel buttons
   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3

   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
   -anchor n -expand true

   #standard params
   #(relative) flow start time:
   frame .dialog.fr1.fstart
   pack .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Option start time (ms)"
   pack .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable head6(start,$head6(number,$flow6Nr),$flow6Nr)   -width 20
   pack .dialog.fr1.fstart.e -side right -padx 3

   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Option stop time (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable head6(stop,$head6(number,$flow6Nr),$flow6Nr) -width 20  
   pack .dialog.fr1.fstop.e -side right -padx 3


   frame .dialog.fr1.head
   pack .dialog.fr1.head -pady 3 -fill x
   label .dialog.fr1.head.l -text "Select the\n option header"
   pack .dialog.fr1.head.l -side left -padx 3 -fill x
   frame .dialog.fr1.head.rbF -bd 2 -relief groove
   pack .dialog.fr1.head.rbF -padx 3 -pady 3 -side right

   set  opt "BINDING_UPDATE"
   radiobutton .dialog.fr1.head.rbF.rb0 -text "Binding update" \
      -variable opt  -value "BINDING_UPDATE" -command { update_header_option }
   radiobutton .dialog.fr1.head.rbF.rb1 -text "Binding ack" \
      -variable opt  -value "BINDING_ACK" -command { update_header_option }
   radiobutton .dialog.fr1.head.rbF.rb2 -text "Binding request" \
      -variable opt  -value "BINDING_REQ" -command { update_header_option }
   radiobutton .dialog.fr1.head.rbF.rb3 -text "Routing header" \
      -variable opt  -value "ROUTING_HEADER" -command { update_header_option }
   radiobutton .dialog.fr1.head.rbF.rb4 -text "Home Address" \
      -variable opt  -value "HOME_ADDRESS_OPTION" -command { update_header_option }
   radiobutton .dialog.fr1.head.rbF.rb5 -text "Router alert" \
      -variable opt  -value "ROUTER_ALERT_OPTION" -command { update_header_option }
   radiobutton .dialog.fr1.head.rbF.rb6 -text "Jumbo payload" \
      -variable opt  -value "JUMBO_PAYLOAD_OPTION" -command { update_header_option }

   pack .dialog.fr1.head.rbF.rb0  \
        .dialog.fr1.head.rbF.rb1  .dialog.fr1.head.rbF.rb2 \
        .dialog.fr1.head.rbF.rb3  .dialog.fr1.head.rbF.rb4 \
        .dialog.fr1.head.rbF.rb3  .dialog.fr1.head.rbF.rb4 \
        .dialog.fr1.head.rbF.rb5  .dialog.fr1.head.rbF.rb6 \
   -padx 2 -pady 2 -anchor w

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.jumbo
   label .dialog.fr1.jumbo.l -text "Jumbo payload (bytes)"
   pack  .dialog.fr1.jumbo.l -side left -padx 3
   entry .dialog.fr1.jumbo.e -textvariable head6(data,$head6(number,$flow6Nr),$flow6Nr) -width 15  
   pack  .dialog.fr1.jumbo.e -side right -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.alert
   label .dialog.fr1.alert.l -text "Router Alert "
   pack  .dialog.fr1.alert.l -side left -padx 3
   #no need to pack it, see radiobutton command
   frame .dialog.fr1.req
   label .dialog.fr1.req.l -text "Binding Request"
   pack  .dialog.fr1.req.l -side left -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.ack
   label .dialog.fr1.ack.l -text "(status lifetime refresh)"
   pack  .dialog.fr1.ack.l -side left -padx 3
   entry .dialog.fr1.ack.e -textvariable head6(data,$head6(number,$flow6Nr),$flow6Nr) -width 17  
   pack  .dialog.fr1.ack.e -side right -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.update
   label .dialog.fr1.update.l -text "(prefix lifetime COA)"
   pack  .dialog.fr1.update.l -side left -padx 3
   entry .dialog.fr1.update.e -textvariable head6(data,$head6(number,$flow6Nr),$flow6Nr) -width 17  
   pack  .dialog.fr1.update.e -side right -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.home
   label .dialog.fr1.home.l -text "home address"
   pack  .dialog.fr1.home.l -side left -padx 3
   entry .dialog.fr1.home.e -textvariable head6(data,$head6(number,$flow6Nr),$flow6Nr) -width 20  
   pack  .dialog.fr1.home.e -side right -padx 3

   #no need to pack it, see radiobutton command
   frame .dialog.fr1.routing
   label .dialog.fr1.routing.l -text "routing header"
   pack  .dialog.fr1.routing.l -side left -padx 3
   entry .dialog.fr1.routing.e -textvariable head6(data,$head6(number,$flow6Nr),$flow6Nr) -width 20  
   pack  .dialog.fr1.routing.e -side right -padx 3

   #update window with the current entry by value of $opt
   update_header_option

   #ok-cancel buttons on 3rd frame
   button .dialog.fr3.ok -text OK -command \
   {
      set done6 ok
      destroy .dialog
   } -width 6
   button .dialog.fr3.cancel -text Cancel -command \
   {
      set done6 cancel
      destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3
   grab .dialog
   tkwait window .dialog

   set  head6(option,$head6(number,$flow6Nr),$flow6Nr) $opt

   #test
   #tk_messageBox -message "option =  $head6(option,$head6(number,$flow6Nr),$flow6Nr)"
   #tk_messageBox -message "data   =  $head6(data,$head6(number,$flow6Nr),$flow6Nr)"

   if ![string compare $done6 cancel] \
   {
      #cancel was pressed
      #unset data and decrement number of flows
      foreach elem {  start stop data option } \
      {
           unset head6($elem,$head6(number,$flow6Nr),$flow6Nr)
      }
      incr head6(number,$flow6Nr) -1
      return
   }
   #ok was pressed:
   #first verify that standard parameters are filled
   foreach elem {start stop} \
   {
      if ![string compare $head6($elem,$head6(number,$flow6Nr),$flow6Nr) ""] \
      {
         tk_messageBox -message "Option not added"
         #unset data and decrement number of flows
         foreach elem {  start stop data option } \
         {
              unset head6($elem,$head6(number,$flow6Nr),$flow6Nr)
         }
         incr head6(number,$flow6Nr) -1
         return
      }
   }
   #update listbox:
   $flow6LB delete [expr $flow6Nr - 1]
   $flow6LB insert [expr $flow6Nr - 1] [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
      $flow6Nr $mod6(number,$flow6Nr) $head6(number,$flow6Nr) $flow6(name,$flow6Nr) ] 

}



###################################################################
#------------------------------------------------------------------
#             Viewflow6
#------------------------------------------------------------------
###################################################################
proc Viewflow6 {} \
{
   global userLB6 head6
   global flow6 mod6 flow6LB
   global xflowview6

   set flow6Nr [$flow6LB curselection]
   #tk_messageBox -message "fnr = $flow6Nr"  
   if {$flow6Nr == ""} {
	#nothing selected
	return
   }
   incr flow6Nr
   set  xflowview6 $flow6Nr

   $userLB6 delete 0 end
   $userLB6 insert end "Flow number (ID): $flow6Nr"
   $userLB6 insert end "Flow name: $flow6(name,$flow6Nr)"
   $userLB6 insert end "Start time (ON): $flow6(start,$flow6Nr)"
   $userLB6 insert end "Stop time (OFF): $flow6(stop,$flow6Nr)"
   $userLB6 insert end "Destination port number: $flow6(port,$flow6Nr)"
   $userLB6 insert end "Rate (packets/sec): $flow6(rate,$flow6Nr)"
   $userLB6 insert end "Pattern: $flow6(pattern,$flow6Nr)"
   $userLB6 insert end "UDP packet payload size: $flow6(size,$flow6Nr)"

   if $flow6(tosBool,$flow6Nr) {
	$userLB6 insert end "-------------------------------------------------------"
	$userLB6 insert end "IP TCLASS value: $flow6(tos,$flow6Nr)"
   }
   #mod6 data:
   for {set i 1} {$i <= $mod6(number,$flow6Nr)} {incr i} {
      $userLB6 insert end "-------------------------------------------------------"
      $userLB6 insert end "Modify flow n. $i"
      $userLB6 insert end "Start time: $mod6(start,$i,$flow6Nr)"
      $userLB6 insert end "Rate:  $mod6(rate,$i,$flow6Nr)"
      $userLB6 insert end "Pattern  $mod6(pattern,$i,$flow6Nr)"
      $userLB6 insert end "UDP packet payload size:  $mod6(size,$i,$flow6Nr)"
   };
   #head6 data:
   for {set i 1} {$i <= $head6(number,$flow6Nr)} {incr i} {
      $userLB6 insert end "-------------------------------------------------------"
      $userLB6 insert end "Extension header n. $i"
      $userLB6 insert end "Start time: $head6(start,$i,$flow6Nr)"
      $userLB6 insert end "Stop  time: $head6(stop,$i,$flow6Nr)"
      $userLB6 insert end "IPv6 option: $head6(option,$i,$flow6Nr)"
      $userLB6 insert end "value (if need): $head6(data,$i,$flow6Nr)"
   };
   $userLB6 see end
}


###################################################################
#------------------------------------------------------------------
#             AddParmaeter6
#------------------------------------------------------------------
###################################################################
   proc AddParameterU6 {} \
   {
      global done paramName paramValue
      global paramU6 pU6 countPU6
      global uni6

      set paramName  ""
      set paramValue ""

      toplevel .addpu6
      wm title .addpu6 "Add Parameter"
      wm resizable .addpu6 0 0
      wm protocol  .addpu6 WM_DELETE_WINDOW {;#do nothing}
      frame .addpu6.nameF
      frame .addpu6.valueF
      frame .addpu6.buttonsF
      pack  .addpu6.nameF .addpu6.valueF .addpu6.buttonsF -pady 3

      #name
      label .addpu6.nameF.nameL -text "Name"
      entry .addpu6.nameF.nameE -textvariable paramName  -width 45  
      pack  .addpu6.nameF.nameL -side left -padx 2
      pack  .addpu6.nameF.nameE -side right -padx 2

      #value
      label .addpu6.valueF.valueL -text "Value"
      entry .addpu6.valueF.valueE -textvariable paramValue  -width 45  
      pack  .addpu6.valueF.valueL -side left -padx 2
      pack  .addpu6.valueF.valueE -side right -padx 2

      #buttons
      button .addpu6.buttonsF.okB -text OK -command {set done ok}
      button .addpu6.buttonsF.cancelB -text Cancel -command {set done cancel}
      pack  .addpu6.buttonsF.okB .addpu6.buttonsF.cancelB  -side left -anchor c -expand true

      set done not_yet
      grab .addpu6
      tkwait variable done
      grab release .addpu6
      destroy .addpu6

      #OK or Cancel pressed, at this point
      if {![string compare $done ok]} \
      {
          if {![string compare "" [string trim $paramName]]} \
          {
	      #nothing eligible was specified
	      return
	  }
          incr countPU6
          set tmp "$paramName: $paramValue"
          set paramU6($tmp) $countPU6
          set pU6 "$tmp"

          destroy  $uni6.up.right.custom.b.bx
          eval tk_optionMenu $uni6.up.right.custom.b.bx pU6 [lsort [array names paramU6 ]]
          $uni6.up.right.custom.b.bx configure -width 20
          pack    $uni6.up.right.custom.b.bx  -side left
      }
  }

###################################################################
#------------------------------------------------------------------
#             Remove Parameter U6
#------------------------------------------------------------------
###################################################################
   proc RemoveParameterU6 {} \
   {
      global paramU6 pU6 countPU6
      global uni6

      if ![string compare $pU6 "(parameters)"] \
      {
         return
         #nothing selected
      }
      unset paramU6($pU6)
      set pU6 "(parameters)"
      destroy  $uni6.up.right.custom.b.bx
      eval tk_optionMenu $uni6.up.right.custom.b.bx pU6 [lsort [array names paramU6 ]]
      $uni6.up.right.custom.b.bx configure -width 20
      pack     $uni6.up.right.custom.b.bx  -side left
      incr countPU6 -1
   }

###################################################################
#------------------------------------------------------------------
#             Edit Parameter U6
#------------------------------------------------------------------
###################################################################

   proc EditParameterU6 {} \
   {
      global done paramName paramValue
      global paramU6 pU6 countPU6
      global uni6


      if ![string compare $pU6 "(parameters)"] \
      {
         return
         #nothing selected
      }

      set line $pU6
      set lindex     [string first : $line 0]
      set paramName  [string range   $line 0 [expr $lindex]]
      set paramValue [string range   $line   [expr $lindex +2]  [string length $line]]

      toplevel .dialog
      wm title .dialog "Edit Parameter"
      wm resizable .dialog 0 0
      wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

      label .dialog.titleL -text "Insert New Value"
      frame .dialog.paramF
      frame .dialog.buttonsF
      pack .dialog.titleL .dialog.paramF .dialog.buttonsF -pady 3
      label .dialog.paramF.numeL -text "$paramName"
   
      entry .dialog.paramF.valueE -textvariable paramValue -width 45  
      pack .dialog.paramF.numeL -side left -padx 2
      pack .dialog.paramF.valueE -side right -padx 2
      button .dialog.buttonsF.okB -text OK -command {set done ok}
      button .dialog.buttonsF.cancelB -text Cancel -command {set done cancel}
      pack .dialog.buttonsF.okB .dialog.buttonsF.cancelB -side left \
      -anchor c -padx 5
      set done not_yet
      grab .dialog
      tkwait variable done
      grab release .dialog
      destroy .dialog

      if {![string compare $done ok]} \
      {
          unset paramU6($pU6)
          set tmp "$paramName $paramValue"
          set paramU6($tmp) $countPU6
          set pU6 "$tmp"

          destroy  $uni6.up.right.custom.b.bx
          eval tk_optionMenu $uni6.up.right.custom.b.bx pU6 [lsort [array names paramU6 ]]
          $uni6.up.right.custom.b.bx configure -width 20
          pack    $uni6.up.right.custom.b.bx  -side left
      }
   }


###################################################################
#------------------------------------------------------------------
#             EditFlow 6
#------------------------------------------------------------------
###################################################################
proc Editflow6 { action } \
{
   global flow6	    ;# flow data
   global flow6LB   ;# flow list(box)
   global mod6	    ;# flow modifier data
   global head6	    ;# flow modifier data

   global flow6Nr

   if { $action == 0 } \
   {
      set flow6Nr [$flow6LB curselection]
      if {$flow6Nr == ""} {
        tk_messageBox -message "Select Flow...!!"
        #nothing selected
        return
      }
      incr flow6Nr
   } else { 
      set flow6Nr $action
   }
   set done6 not_yet

   #make a dialog window
   toplevel .dialog
   wm title .dialog "IPv6 - Edit Flow No. $flow6Nr"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   #define widgets:
   #frames for standard params, optional
   #params and ok-cancel buttons
   frame .dialog.fr1 -bd 2 -relief groove
   frame .dialog.fr2 -bd 2 -relief groove
   frame .dialog.fr3
   pack .dialog.fr3 -pady 3 -padx 3 -side bottom -anchor c
   pack .dialog.fr1 .dialog.fr2 -fill x -pady 3 -padx 3 -side left \
     -anchor n -expand true

   #standard params
   #(relative) flow start time:

   frame .dialog.fr1.name -bd 2 -relief groove
   pack  .dialog.fr1.name -pady 3 -padx 3 -fill x
   label .dialog.fr1.name.l -text "Flow Name"
   pack  .dialog.fr1.name.l -side top -padx 3
   entry .dialog.fr1.name.e -textvariable flow6(name,$flow6Nr) -width 36  
   pack  .dialog.fr1.name.e -side bottom -padx 3

   frame .dialog.fr1.fstart
   pack .dialog.fr1.fstart -pady 3 -fill x
   label .dialog.fr1.fstart.l -text "Flow Start (ms)"
   pack .dialog.fr1.fstart.l -side left -padx 3
   entry .dialog.fr1.fstart.e -textvariable flow6(start,$flow6Nr) -width 20  
   pack .dialog.fr1.fstart.e -side right -padx 3

   #(relative) flow stop time
   frame .dialog.fr1.fstop
   pack .dialog.fr1.fstop -pady 3 -fill x
   label .dialog.fr1.fstop.l -text "Flow Stop (ms)"
   pack .dialog.fr1.fstop.l -side left -padx 3
   entry .dialog.fr1.fstop.e -textvariable flow6(stop,$flow6Nr) -width 20  
   pack .dialog.fr1.fstop.e -side right -padx 3

   #an explanation:
   label .dialog.fr1.exp -text "(Relative to test start)"
   pack .dialog.fr1.exp -padx 3 -pady 2

   #port number. This will be verified at last
   #to have only flows with unique port numbers

   frame .dialog.fr1.fport
   pack .dialog.fr1.fport -pady 3 -fill x
   label .dialog.fr1.fport.l -text "Destination Port"
   pack .dialog.fr1.fport.l -side left -padx 3
   entry .dialog.fr1.fport.e -textvariable flow6(port,$flow6Nr) -width 15  
   pack .dialog.fr1.fport.e -side right -padx 3

   #pattern type frame, label and radiobuttons
   frame .dialog.fr1.fpattern
   pack .dialog.fr1.fpattern -pady 3 -fill x
   label .dialog.fr1.fpattern.l -text "Pattern"
   pack .dialog.fr1.fpattern.l -side left -padx 3 -fill x
   frame .dialog.fr1.fpattern.rbF -bd 2 -relief groove
   pack .dialog.fr1.fpattern.rbF -padx 3 -pady 3 -side right
   radiobutton .dialog.fr1.fpattern.rbF.rb1 -text PERIODIC \
     -variable flow6(pattern,$flow6Nr) -value PERIODIC
   radiobutton .dialog.fr1.fpattern.rbF.rb2 -text POISSON \
     -variable flow6(pattern,$flow6Nr) -value POISSON
   pack .dialog.fr1.fpattern.rbF.rb1 .dialog.fr1.fpattern.rbF.rb2 \
     -padx 2 -pady 2 -anchor w

   #rate:
   giveBandwidth "ipv6" $flow6(rate,$flow6Nr) $flow6(size,$flow6Nr) bandwidth
   frame .dialog.fr1.frate
   pack .dialog.fr1.frate -pady 3 -fill x
   label .dialog.fr1.frate.l -text "Rate (packets/sec)"
   pack .dialog.fr1.frate.l -side left -padx 3
   entry .dialog.fr1.frate.e -textvariable flow6(rate,$flow6Nr) -width 15    \
	-validate focusout -vcmd {
	giveBandwidth "ipv6" $flow6(rate,$flow6Nr) $flow6(size,$flow6Nr) bandwidth
	return 1
      }
   pack .dialog.fr1.frate.e -side right -padx 3

   #UDP packet payload size
   frame .dialog.fr1.fsize
   pack .dialog.fr1.fsize -pady 3 -fill x
   label .dialog.fr1.fsize.l -text "Packet Size (bytes)"
   pack .dialog.fr1.fsize.l -side left -padx 3
   entry .dialog.fr1.fsize.e -textvariable flow6(size,$flow6Nr)   \
     -width 15 -validate focusout -vcmd {
	giveBandwidth "ipv6" $flow6(rate,$flow6Nr) $flow6(size,$flow6Nr) bandwidth
	return 1
      }
   pack .dialog.fr1.fsize.e -side right -padx 3

   frame .dialog.fr1.frateshow
   pack .dialog.fr1.frateshow -pady 3 -fill x
   label .dialog.fr1.frateshow.l -text "Bandwidth ATM (Kbps)"
   pack .dialog.fr1.frateshow.l -side left -padx 3
   label .dialog.fr1.frateshow.l2 -textvariable bandwidth(atm)
   pack .dialog.fr1.frateshow.l2 -side right -padx 3
   
   frame .dialog.fr1.fratesheth
   pack .dialog.fr1.fratesheth -pady 3 -fill x
   label .dialog.fr1.fratesheth.l -text "Bandwidth Ethernet (Kbps)"
   pack .dialog.fr1.fratesheth.l -side left -padx 3
   label .dialog.fr1.fratesheth.l2 -textvariable bandwidth(eth)
   pack .dialog.fr1.fratesheth.l2 -side right -padx 3
   
   #frame 2: optional params
   #tos field:
   frame .dialog.fr2.tosF
   pack .dialog.fr2.tosF -pady 3 -fill x -anchor n

   checkbutton .dialog.fr2.tosF.cb -text "Traffic Class" \
      -variable flow6(tosBool,$flow6Nr) -command {
	if $flow6(tosBool,$flow6Nr) {
		.dialog.fr2.tosF.e config -state normal -fg black
	} else {
		.dialog.fr2.tosF.e config -state disabled -fg gray
	}
   }
   pack .dialog.fr2.tosF.cb -side left -padx 3
   entry .dialog.fr2.tosF.e -textvariable flow6(tos,$flow6Nr)   -width 10 -fg gray
   if $flow6(tosBool,$flow6Nr) {
	.dialog.fr2.tosF.e config -state normal -fg black
   } else {
	.dialog.fr2.tosF.e config -state disabled -fg gray
   }
   pack .dialog.fr2.tosF.e -side right -padx 3

   #ok-cancel buttons on 3rd frame
   button .dialog.fr3.ok -text OK -command {
     set done6 ok
     destroy .dialog
   } -width 6

   button .dialog.fr3.cancel -text Cancel -command {
   set done6 cancel
   destroy .dialog
   } -width 6
   pack .dialog.fr3.ok .dialog.fr3.cancel -side left \
   -padx 3 -pady 3

   grab .dialog
   tkwait window .dialog

   #cancel was pressed
   if ![string compare $done6 cancel] { return  }

   #ok was pressed:
   #first verify that standard parameters are filled

   foreach elem {start stop port rate size} {
     if ![string compare $flow6($elem,$flow6Nr) ""] {
         tk_messageBox -message "Missing Flow parameteres...!!"
         Editflow6 1 
         return
     }
   }

   #check port; must be unique for each flow
   for {set i 1} {$i < $flow6(number)} {incr i} {
     if {$flow6(port,$flow6Nr) == $flow6(port,$i)  && $flow6Nr != $i } {
         tk_messageBox -message "Port value already used on flow $i"
         Editflow6 1 
         return
     }
   }
   $flow6LB delete [expr $flow6Nr - 1]
   $flow6LB insert [expr $flow6Nr - 1] [format "Flow  %02d  -  Mods  %02d  -  Heads  %02d  -  %s"  \
   $flow6Nr $mod6(number,$flow6Nr) $head6(number,$flow6Nr) $flow6(name,$flow6Nr) ] 
}

######################################################
#### Scripting Functions for IPv6
######################################################
proc RunScript6 {} {
   global debug
   global scriptLB6

   global mod6
   global mcalcpath
   global decodepath
   global host scenarioDir dly 
   global flow6         ;#flow array to hold flows data
   global sender receiver
   global scriptElem6    ;# Points to the next free element!
   global scrArray6 scripted
   global logDelayLB6   ;#status console

   if $debug {
      puts stderr "RunScript6: BEGIN"
   }
   if ![info exists scriptElem6] {
   	tk_messageBox -message "Must add at least one Step for saving"
        if $debug {
           puts stderr "RunScript6: END"
        }
   	return
   }

   for {set i 0} {$i < $scriptElem6} {incr i} {
      foreach index [array names receiver] {
         if [info exists scrArray6($i,receiver,$index)] {
            set receiver($index) $scrArray6($i,receiver,$index)
	    if $debug {
	        puts stderr "                   receiver($index): $scrArray6($i,receiver,$index)"
	    }
	 } else {
	    unset receiver($index)
	 }
      }
      foreach index [array names sender] {
         if [info exists scrArray6($i,sender,$index)] {
            set sender($index) $scrArray6($i,sender,$index)
	    if $debug {
	       puts stderr "                   sender($index): $scrArray6($i,sender,$index)"
	    }
	 } else {
	     unset sender($index)
	 }
      }
      set mcalcpath $scrArray6($i,mcalcpath)
      set decodepath $scrArray6($i,decodepath)
      foreach index [array names dly] {
         if [info exists scrArray6($i,dly,$index)] {
            set dly($index) $scrArray6($i,dly,$index)
	    if $debug {
	       puts stderr "                   dly($index): $scrArray6($i,dly,$index)"
	    }
	 } else {
	    unset dly($index)
	 }
      }
      foreach index [array names host] {
         if [info exists scrArray6($i,host,$index)] {
            set host($index) $scrArray6($i,host,$index)
	    if $debug {
	       puts stderr "                   host($index): $scrArray6($i,host,$index)"
	    }
	 } else {
	    unset host($index)
	 }
      }
      foreach index [array names scenarioDir] {
         if [info exists scrArray6($i,scenarioDir,$index)] {
            set scenarioDir($index) $scrArray6($i,scenarioDir,$index)
	    if $debug {
	       puts stderr "                   scenarioDir($index): $scrArray6($i,scenarioDir,$index)"
	    }
	 } else {
	    unset scenarioDir($index)
	 }
      }
      foreach index [array names mod6] {
         if [info exists scrArray6($i,mod6,$index)] {
            set mod6($index) $scrArray6($i,mod6,$index)
	    if $debug {
	       puts stderr "                   mod6($index): $scrArray6($i,mod6,$index)"
	    }
	 } else {
	    unset mod6($index)
	 }
      }
      foreach index [array names flow6] {
         if  [info exists scrArray6($i,flow6,$index)] {
		set flow6($index) $scrArray6($i,flow6,$index)
		if $debug {
			puts stderr "                   flow6($index): $scrArray6($i,flow6,$index)"
		}
	 } else {
	    unset flow6($index)
	 }
     }
     set scripted 1
     $logDelayLB6 insert end "Running Scripted version step $i."
     update idletasks
     RunDelayTest6
     $logDelayLB6 insert end "Finished step $i."
     update idletasks
   }
   set scripted 0
   if $debug {
      puts stderr "RunScript6: END"
   }
}

proc SaveScript6 {} {
   global scriptElem6
   global scrArray6

   set TempFile "temp/script-file"

   if ![info exists scriptElem6] {
   	tk_messageBox -message "Must add at least one Step for saving"
   	return
   }

   #Try to Save with New File NAME
   if [catch {open $TempFile w} idfile] {
   	tk_messageBox -message  "Failed saving configuration file"
   	return
   }
   set line ""
   set line "###############################################"
   puts $idfile $line
   set line "#  SCRIPT CONFIGURATION FILE FOR NETMETER     #"
   puts $idfile $line
   set line "###############################################"
   puts $idfile $line
   for {set outer_for 0} {$outer_for < $scriptElem6} {incr outer_for} {
	set line "###START"
	puts $idfile $line

	set line "#sender:  address-interface-login-local for Unicast IPv6"
	puts $idfile $line
	set line "#sender"
	puts $idfile $line
	foreach i {address interface login local} {
		set line $scrArray6($outer_for,sender,$i,ipv6,unicast)
		puts $idfile $line
	}
	set line "#receiver:  address-interface-login-local for U4"
	puts $idfile $line
	set line "#receiver"
	puts $idfile $line
	set line $scrArray6($outer_for,receiver,address,ipv6,unicast)
	puts $idfile $line
	foreach i {interface login local} {
		set line $scrArray6($outer_for,receiver,$i,ipv6)
		puts $idfile $line
	}
	set line "#host --> Unicast IPv6 address-interface"
	puts $idfile $line
	foreach i {address interface} {
		set line $scrArray6($outer_for,host,$i,ipv6,unicast)
		puts $idfile $line
	}
	set line "#MainDirectory"
	puts $idfile $line
	set  line $scrArray6($outer_for,scenarioDir,ipv6,unicast)
	puts $idfile $line

	if ($scrArray6($outer_for,dly,startBool)) {
		set line "#StarTime"
		puts $idfile $line
		set  line $scrArray6($outer_for,dly,start)
		puts $idfile $line
	}
	if ($scrArray6($outer_for,dly,srcPortBool)) {
		set line "#SourcePort"
		puts $idfile $line
		set  line $scrArray6($outer_for,dly,srcPort)
		puts $idfile $line
	}
	set line "#MgenDefs"
	puts $idfile $line
	set  line $scrArray6($outer_for,dly,mgenPath,ipv6)
	puts $idfile $line
	set  line $scrArray6($outer_for,dly,drecPath,ipv6)
	puts $idfile $line
	set  line $scrArray6($outer_for,dly,resultsFile,ipv6)
	puts $idfile $line
	set  line $scrArray6($outer_for,dly,title,ipv6)
	puts $idfile $line

	set line "#Decodepath"
	puts $idfile $line
	set  line $scrArray6($outer_for,decodepath)
	puts $idfile $line

	set line "#Mcalcpath"
	puts $idfile $line
	set  line $scrArray6($outer_for,mcalcpath)
	puts $idfile $line

	###########################################
	#SAVE ALL THE INFORMATION FOR ALL FLOW IPv6
	###########################################
	for {set countFL 1} {$countFL <= $scrArray6($outer_for,flow6,number)} {incr countFL}  \
	{
		set line "#FLOW6"
		puts $idfile $line

		#Standard parameters
		set line $countFL
		puts $idfile $line
		set line $scrArray6($outer_for,flow6,start,$countFL)
		puts $idfile $line
		set line $scrArray6($outer_for,flow6,stop,$countFL)
		puts $idfile $line
		set line $scrArray6($outer_for,flow6,port,$countFL)
		puts $idfile $line
		set line $scrArray6($outer_for,flow6,pattern,$countFL)
		puts $idfile $line
		set line $scrArray6($outer_for,flow6,rate,$countFL)
		puts $idfile $line
		set line $scrArray6($outer_for,flow6,size,$countFL)
		puts $idfile $line
		set line $scrArray6($outer_for,flow6,tosBool,$countFL)
		puts $idfile $line
		set line $scrArray6($outer_for,flow6,tos,$countFL)
		puts $idfile $line

		#Modifications
		set line $scrArray6($outer_for,mod6,number,$countFL)
		puts $idfile $line
		for {set countFLm 1} {$countFLm <= $scrArray6($outer_for,mod6,number,$countFL)} {incr countFLm}  \
		{
			set line $scrArray6($outer_for,mod6,start,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray6($outer_for,mod6,pattern,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray6($outer_for,mod6,rate,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray6($outer_for,mod6,size,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray6($outer_for,mod6,tosBool,$countFLm,$countFL)
			puts $idfile $line
			set line $scrArray6($outer_for,mod6,tos,$countFLm,$countFL)
			puts $idfile $line
		}
		set line $scrArray6($outer_for,flow6,name,$countFL)
		puts $idfile $line
	}
   } ;# End outer for (scriptElem6)
   catch {close $idfile}
}

proc DeleteFromScript6 {} {

}

proc LoadScript6 {} {
   global scriptElem6
   global scrArray6
   global debug

   set TempFile "temp/script-file"

   if [info exists scrArray6] {
	unset scrArray6
   }

   #Try to Save with New File NAME
   if [catch {open $TempFile r} idfile] {
   	tk_messageBox -message  "Failed loading configuration file"
   	return
   }

   set error 0
   gets $idfile line
   if [string compare "###############################################"  $line] { set error 1}
   gets $idfile line
   if [string compare "#  SCRIPT CONFIGURATION FILE FOR NETMETER     #"  $line] { set error 1}
   gets $idfile line
   if [string compare "###############################################"  $line] { set error 1}
   if { $error == 1 } {
	tk_messageBox -message "Error in configuration file."
	catch {close $idfile}
	return
   }

   #start to read the configuration file
   set wait_label 1
   set line ""
   set i -1
   while ![eof $idfile] {
      if {$wait_label==1} {
        gets $idfile line
        set opt 0
        if ![string compare "###START"  $line] {
 		set countFL6 1
		incr i
	}
        if ![string compare "###END"    $line]       { return }

        #page 1 data
        if ![string compare "#sender"   $line]       { set opt 1;  }
        if ![string compare "#receiver" $line]       { set opt 2;  }
        if ![string compare "#host" $line]           { set opt 3;  }
        if ![string compare "#MainDirectory" $line]  { set opt 4;  }
        #page 3 data
        if ![string compare "#StarTime"   $line]     { set opt 6;  }
        if ![string compare "#SourcePort" $line]     { set opt 7;  }
        if ![string compare "#MgenDefs"   $line]     { set opt 8;  }
        if ![string compare "#Decodepath" $line]     { set opt 9;  }
        if ![string compare "#Mcalcpath"  $line]     { set opt 10; }

        if ![string compare "#FLOW6"       $line]     { set opt 600; }
        if ![string compare "#NEXT"        $line]     { incr i; }

        if {$opt != 0} {
           set wait_label 0
        }
      } else {
        if ($opt==10) {
           gets $idfile line
           set scrArray6($i,mcalcpath) $line
        }
        if ($opt==9) {
           gets $idfile line
           set decodepath $line
        }
        if {$opt == 8} {
           gets $idfile line
           set scrArray6($i,dly,mgenPath,ipv6) $line
           gets $idfile line
           set scrArray6($i,dly,drecPath,ipv6) $line
           gets $idfile line
           set scrArray6($i,dly,resultsFile,ipv6) $line
           gets $idfile line
           set scrArray6($i,dly,title,ipv6) $line
        }
        if {$opt==7} {
            set scrArray6($i,dly,srcPortBool) 1
            gets $idfile line
            set scrArray6($i,dly,srcPort) $line
        }
        if {$opt == 6} {
            set scrArray6($i,dly,startBool) 1
            gets $idfile line
            set scrArray6($i,dly,start) $line
            #tk_messageBox -message "$dly(startBool)   \n$line"
        }
        #sender
        if {$opt == 1} {
           foreach k {address interface login local} {
              gets $idfile line
              set scrArray6($i,sender,$k,ipv6,unicast) $line
           }
        }
	#receiver
	if {$opt == 2} {
		gets $idfile line
		set receiver($i,address,ipv6,unicast) $line
		foreach k {interface login local} {
				gets $idfile line
				set scrArray6($i,receiver,$k,ipv6) $line
		}
	}
	if {$opt == 3} {
		foreach k {address interface} {
			gets $idfile line
			set scrArray6($i,host,$k,ipv6,unicast) $line
		}
	}
	if {$opt == 4} {
		gets $idfile line
		set  scrArray6($i,scenarioDir,ipv6,unicast) $line
	}
	##########################
	####LOAD IPV6 FLOWS#######
	##########################
	if {$opt == 600} {
		if $debug {
			puts stderr "              Loading Flow $countFL6"
		}
		set scrArray6($i,flow6,number) $countFL6
		#Standard parameters
		gets $idfile line
		set Findex     $line 
		gets $idfile line
		set scrArray6($i,flow6,start,$Findex)    $line 
		if $debug {
			puts stderr "               scrArray6($i,flow6,start,$Findex) $line"
		}
		gets $idfile line
		set scrArray6($i,flow6,stop,$Findex)     $line 
		if $debug {
			puts stderr "               scrArray6($i,flow6,stop,$Findex) $line"
		}
		gets $idfile line
		set scrArray6($i,flow6,port,$Findex)     $line 
		if $debug {
			puts stderr "               scrArray6($i,flow6,port,$Findex) $line"
		}
		gets $idfile line
		set scrArray6($i,flow6,pattern,$Findex)  $line
		if $debug {
			puts stderr "               scrArray6($i,flow6,pattern,$Findex) $line"
		}
		gets $idfile line
		set scrArray6($i,flow6,rate,$Findex)     $line
		if $debug {
			puts stderr "               scrArray6($i,flow6,rate,$Findex) $line"
		}
		gets $idfile line
		set scrArray6($i,flow6,size,$Findex)     $line
		if $debug {
			puts stderr "               scrArray6($i,flow6,size,$Findex) $line"
		}
		gets $idfile line
		set scrArray6($i,flow6,tosBool,$Findex)  $line
		if $debug {
			puts stderr "               scrArray6($i,flow6,tosBool,$Findex) $line"
		}
		gets $idfile line
		set scrArray6($i,flow6,tos,$Findex)      $line
		if $debug {
			puts stderr "               scrArray6($i,flow6,tos,$Findex) $line"
		}
		gets $idfile line
		set scrArray6($i,mod6,number,$Findex)    $line
		if $debug {
			puts stderr "               scrArray6($i,mod6,number,$Findex) $line"
		}

		###################################
		##  HEADER NOT SAVED !!!!!!
		###################################
		set  scrArray6($i,head6,number,$scrArray6($i,flow6,number)) 0
		###################################
		###################################
		for {set countFL6m 1} {$countFL6m <= $scrArray6($i,mod6,number,$countFL6)} {incr countFL6m} {
			if $debug {
				puts stderr "               Loading flow modifier $countFL6m"
			}
			gets $idfile line
			set scrArray6($i,mod6,start,$countFL6m,$countFL6)    $line 
			if $debug {
				puts stderr "               scrArray6($i,mod6,start,$countFL6m,$countFL6) $line"
			}
			gets $idfile line
			set scrArray6($i,mod6,pattern,$countFL6m,$countFL6)  $line
			if $debug {
				puts stderr "               scrArray6($i,mod6,pattern,$countFL6m,$countFL6) $line"
			}
			gets $idfile line
			set scrArray6($i,mod6,rate,$countFL6m,$countFL6)     $line
			if $debug {
				puts stderr "               scrArray6($i,mod6,rate,$countFL6m,$countFL6) $line"
			}
			gets $idfile line
			set scrArray6($i,mod6,size,$countFL6m,$countFL6)     $line
			if $debug {
				puts stderr "               scrArray6($i,mod6,size,$countFL6m,$countFL6) $line"
			}
			gets $idfile line
			set scrArray6($i,mod6,tosBool,$countFL6m,$countFL6)    $line
			if $debug {
				puts stderr "               scrArray6($i,mod6,tosBool,$countFL6m,$countFL6) $line"
			}
			gets $idfile line
			set scrArray6($i,mod6,tos,$countFL6m,$countFL6)        $line
			if $debug {
				puts stderr "               scrArray6($i,mod6,tos,$countFL6m,$countFL6) $line"
			}
		}
		gets $idfile line
		set scrArray6($i,flow6,name,$Findex)    $line
		if $debug {
			puts stderr "               scrArray6($i,flow6,name,$countFL6m,$countFL6) $line"
		}
	}
        set wait_label 1
        incr countFL6
      }
   }
   catch {close $idfile}
}

proc AddToScript6 {} {
   global debug
   global scriptLB6

   global mod6
   global mcalcpath
   global decodepath
   global host scenarioDir dly 
   global flow6		;#flow array to hold flows data
   global sender receiver
   global scriptElem6	;# Points to the next free element!
   global scrArray6

   if ![info exists scriptElem6] {
      set scriptElem6 0
   }

   if $debug {
   	puts stderr "AddToScript6: BEGIN"
   	puts stderr "                   Copying Data at position $scriptElem6"
   }
   for {set i 0} {$i < $scriptElem6} {incr i} {
	if ![string compare $dly(resultsFile,ipv6) $scrArray6($i,dly,resultsFile,ipv6)] {
		tk_messageBox -message "Sorry repeated Save Results file name with step $i"
		return
	}
   }
   foreach index [array names sender] {
     set scrArray6($scriptElem6,sender,$index) $sender($index)
     if $debug {
     	puts stderr "                   sender($index):   $scrArray6($scriptElem6,sender,$index)"
     }
   }
   foreach index [array names receiver] {
     set scrArray6($scriptElem6,receiver,$index) $receiver($index)
     if $debug {
     	puts stderr "                   receiver($index): $scrArray6($scriptElem6,receiver,$index)"
     }
   }
   foreach index [array names host] {
     set scrArray6($scriptElem6,host,$index) $host($index)
     if $debug {
     	puts stderr "                   host($index):     $scrArray6($scriptElem6,host,$index)"
     }
   }
   foreach index [array names scenarioDir] {
     set scrArray6($scriptElem6,scenarioDir,$index) $scenarioDir($index)
     if $debug {
     	puts stderr "                   scenarioDir($index):     $scrArray6($scriptElem6,scenarioDir,$index)"
     }
   }
   # Let's Copy all the dly data
   foreach index [array names dly] {
     set scrArray6($scriptElem6,dly,$index) $dly($index)
     if $debug {
     	puts stderr "                   dly($index):      $scrArray6($scriptElem6,dly,$index)"
     }
   }
   set scrArray6($scriptElem6,mcalcpath) $mcalcpath
   set scrArray6($scriptElem6,decodepath) $decodepath

   # Let's Copy all the flow array
   foreach index [array names flow6] {
     set scrArray6($scriptElem6,flow6,$index) $flow6($index)
     if $debug {
     	puts stderr "                   flow6($index):     $scrArray6($scriptElem6,flow6,$index)"
     }
   }
   # Let's Copy all the mod6 array
   foreach index [array names mod6] {
     set scrArray6($scriptElem6,mod6,$index) $mod6($index)
     if $debug {
     	puts stderr "                   mod6($index):     $scrArray6($scriptElem6,mod6,$index)"
     }
   }
   if $debug {
   	puts stderr "                   End Copying Data"
   	puts stderr "                   Begin update Script Listbox"
   }
   if {$scrArray6($scriptElem6,sender,local,ipv6,unicast)} {
      $scriptLB6 insert end [format "Step %02d - %s - From Local - To %s - Filename %s" $scriptElem6 $scrArray6($scriptElem6,dly,title,ipv6) \
	     $scrArray6($scriptElem6,receiver,address,ipv6,unicast)  $scrArray6($scriptElem6,dly,resultsFile,ipv6)]
   } elseif {$scrArray6($scriptElem6,receiver,local,ipv6)} {
      $scriptLB6 insert end [format "Step %02d - %s - From %s - To Local - Filename %s" $scriptElem6 $scrArray6($scriptElem6,dly,title,ipv6) \
	     $scrArray6($scriptElem6,sender,address,ipv6,unicast) $scrArray6($scriptElem6,dly,resultsFile,ipv6)]
   } else {
      $scriptLB6 insert end [format "Step %02d - %s - From %s - To %s - Filename %s" $scriptElem6 $scrArray6($scriptElem6,dly,title,ipv6) \
             $scrArray6($scriptElem6,sender,address,ipv6,unicast) \
	     $scrArray6($scriptElem6,receiver,address,ipv6,unicast) $scrArray6($scriptElem6,dly,resultsFile,ipv6)]
   }
   update idletasks

   incr scriptElem6
   if $debug {
   	puts stderr "AddToScript6: END"
   }
}

