###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                      Roberto Borgione       #
#                                             #
# distribution.tcl - Graphics Distribution    #
#       v2.0 (04-2002)                        #
#       v2.01(10-2002)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

###################################################################
#------------------------------------------------------------------
#      GRAFIC-DISTRIBUTIONS
#------------------------------------------------------------------
###################################################################
proc Distribution {} \
{
   global countF
   global dgr
   global outputfile
   
   global calcCorrel

   global zoom_tgap
   global zoom_gap
   global zoom_min
   global zoom_max
   global zoom_size
   global zoom_sizey

   global flagOption
   global distOption 
   global zeroOption
   global fillOption
   global backOption

   global scripted4
   global scripted

   global xfile
   wm withdraw .

   set countF 0

   set scripted4 0
   set scripted 0

   toplevel .dgraph
   wm title .dgraph "Distribution Graph Options"
   wm resizable .dgraph 0 0
   wm protocol .dgraph WM_DELETE_WINDOW ExitDist

   set xfile 7777

   ##################################
   # Setup First frames
   ##################################
   frame .dgraph.top -bd 2   -relief groove
   pack  .dgraph.top -pady 2 -fill x -side top
   frame .dgraph.top.left  -bd 2 -relief groove
   pack  .dgraph.top.left  -padx 2 -pady 2 -side left
   frame .dgraph.top.left.down -bd 2 -relief groove
   pack  .dgraph.top.left.down -pady 2 -padx 2  -side bottom
   frame .dgraph.top.right -bd 2 -relief groove
   pack  .dgraph.top.right -pady 2 -padx 2 -side right
   frame .dgraph.down
   pack  .dgraph.down -pady 2 -fill x -side bottom

   ##########################
   # LISTBOX1 FOR VIEW FILE
   ##########################
   frame .dgraph.top.right.flows
   pack  .dgraph.top.right.flows -padx 3 -pady 2 -fill both
   label .dgraph.top.right.flows.l -text  "     file info (double click on file list)     "
   pack  .dgraph.top.right.flows.l -padx 3 -anchor c

   listbox .dgraph.top.right.flows.lb -xscrollcommand ".dgraph.top.right.flows.sx set" \
     -yscrollcommand ".dgraph.top.right.flows.sy set" -width 20 -height 18 \
     -selectmode multiple
   scrollbar .dgraph.top.right.flows.sx -orient horizontal -command \
     ".dgraph.top.right.flows.lb xview"
   scrollbar .dgraph.top.right.flows.sy -orient vertical -command \
     ".dgraph.top.right.flows.lb yview"
   pack .dgraph.top.right.flows.sx -side bottom -fill x
   pack .dgraph.top.right.flows.sy -side right -fill y
   pack .dgraph.top.right.flows.lb -fill both -expand true


   ##################################
   # LISTBOX2 File-LIST
   ##################################
   frame .dgraph.top.left.b
   pack  .dgraph.top.left.b -pady 2 -padx 3 -side bottom -anchor c
   frame .dgraph.top.left.lbf
   pack  .dgraph.top.left.lbf -fill both -padx 2 -pady 2 -side top
   label .dgraph.top.left.lbf.l -text " Mgen Results files:"
   pack  .dgraph.top.left.lbf.l -padx 3 -anchor c
   listbox .dgraph.top.left.lbf.lb -xscrollcommand ".dgraph.top.left.lbf.sx set" \
     -yscrollcommand ".dgraph.top.left.lbf.sy set" -width 2 -height 6
   scrollbar .dgraph.top.left.lbf.sx -orient horizontal -command \
     ".dgraph.top.left.lbf.lb xview"
   scrollbar .dgraph.top.left.lbf.sy -orient vertical -command \
     ".dgraph.top.left.lbf.lb yview"
   pack .dgraph.top.left.lbf.sx -side bottom -fill x
   pack .dgraph.top.left.lbf.sy -side right -fill y
   pack .dgraph.top.left.lbf.lb -fill both -expand true
   bind .dgraph.top.left.lbf.lb <Double-1> {  Viewfile }
   #buttons:
   button .dgraph.top.left.b.b1 -text "Add File" -command AddFileDist \
     -width 6
   button .dgraph.top.left.b.b2 -text "Remove File" -command ClearFileDist \
     -width 10
   button .dgraph.top.left.b.b3 -text "Back" -command ExitDist \
     -width 4

   button .dgraph.top.left.b.b4 -text "Mcalc file" -command ProcessDLY \
     -width 9

   button .dgraph.top.left.b.b5 -text "Calc File" -command { UpdateResultFile 1 }\
     -width 9

   pack  .dgraph.top.left.b.b1 .dgraph.top.left.b.b2 \
         .dgraph.top.left.b.b4 .dgraph.top.left.b.b5 \
         .dgraph.top.left.b.b3 \
         -side left  -padx 2

   ##################################
   # Graph Options
   ##################################
   label .dgraph.top.left.down.l -text "Graphic options"
   pack  .dgraph.top.left.down.l -side top -padx 3 -fill x
   frame .dgraph.top.left.down.b -bd 2 -relief groove
   pack  .dgraph.top.left.down.b  -fill x -pady 2 -padx 3 -anchor n -expand true
   frame .dgraph.top.left.down.b.right -bd 2
   pack  .dgraph.top.left.down.b.right  

   radiobutton .dgraph.top.left.down.b.right.rb1 -text "One-Way Delay\ndistribution" \
        -variable distOption -value 0 -width 14
   radiobutton .dgraph.top.left.down.b.right.rb2 -text "IPDV\ndistribution" \
        -variable distOption -value 1 -width 14
   radiobutton .dgraph.top.left.down.b.right.rb4 -text "One-Way Average\ndistribution" \
        -variable distOption -value 6 -width 16

   pack .dgraph.top.left.down.b.right.rb1 .dgraph.top.left.down.b.right.rb2 \
        .dgraph.top.left.down.b.right.rb4 \
        -side left -anchor w -pady 3 -padx 3 

   frame .dgraph.top.left.down.b.right2 -bd 2
   pack  .dgraph.top.left.down.b.right2  -pady 2 -padx 3 -anchor n -expand true

   label  .dgraph.top.left.down.b.right2.l -text "other graph"
   radiobutton .dgraph.top.left.down.b.right2.rc3 -text "One-Way Delay" \
        -variable distOption -value 4 -width 14
   radiobutton .dgraph.top.left.down.b.right2.rc4 -text "IPDV" \
        -variable distOption -value 7 -width 14

   pack .dgraph.top.left.down.b.right2.rc3 \
        .dgraph.top.left.down.b.right2.rc4 \
        -side left -anchor w   -pady 3 -padx 3

   frame .dgraph.top.left.down.outname
   pack  .dgraph.top.left.down.outname -padx 3 -pady 2 -expand true

   set    calcCorrel 0

   set    outputfile "graphs/default.png"
   label  .dgraph.top.left.down.outname.lab -text "Output file name: " -anchor e
   entry  .dgraph.top.left.down.outname.ent -width 31  -textvariable outputfile
   button .dgraph.top.left.down.outname.but -text "Browse ..." \
          -command "fileDialog .dgraph.top.left.down.outname.ent"
   pack   .dgraph.top.left.down.outname.lab -side left
   pack   .dgraph.top.left.down.outname.ent -side left
   pack   .dgraph.top.left.down.outname.but -side left


   ##################################
   # LISTBOX3 Flow-LIST
   ##################################
   frame .dgraph.down.flows  -bd 2 -relief groove
   pack  .dgraph.down.flows -padx 2 -pady 2 -fill both
   frame .dgraph.down.flows.b
   pack  .dgraph.down.flows.b -padx 3 -pady 2  -side right

   button .dgraph.down.flows.b.b5 -text "Plot" -command PlotDist \
     -bd 2  -width 11
   button .dgraph.down.flows.b.b4 -text "Plot option" -command PlotOPT \
     -bd 2  -width 11
   button .dgraph.down.flows.b.b6 -text "Select All" -command SelectAll \
     -bd 2  -width 11
   button .dgraph.down.flows.b.b2 -text "Edit flow name" -command EditTitle \
     -bd 2  -width 11
   pack  .dgraph.down.flows.b.b5 .dgraph.down.flows.b.b4 \
         .dgraph.down.flows.b.b6 .dgraph.down.flows.b.b2  -padx 3 -pady 2

   set title "Title                                                                                                  "
   label .dgraph.down.flows.l -text "File ID  -   Flow ID    -      $title  " -relief raised
   pack  .dgraph.down.flows.l -anchor w -side top -padx 2
   listbox .dgraph.down.flows.lb -xscrollcommand ".dgraph.down.flows.sx set" \
     -yscrollcommand ".dgraph.down.flows.sy set" -width 40 -height 8 \
     -selectmode multiple
   scrollbar .dgraph.down.flows.sx -orient horizontal -command \
     ".dgraph.down.flows.lb xview"
   scrollbar .dgraph.down.flows.sy -orient vertical -command \
     ".dgraph.down.flows.lb yview"
   pack .dgraph.down.flows.sx -side bottom -fill x
   pack .dgraph.down.flows.sy -side right -fill y
   pack .dgraph.down.flows.lb -fill both -expand true
}

###################################################################
#------------------------------------------------------------------
#                    fileDialog (chose Save file as....)
#------------------------------------------------------------------
###################################################################
proc fileDialog {ent } \
{
   set types {
     {"Image Files"           {.png}          }
     {"All files"                     *}
   }
   set file [tk_getSaveFile -filetypes $types  -initialdir graphs/ \
   -initialfile newgraph -defaultextension .png]
   if [string compare $file ""] {
     $ent delete 0 end
     $ent insert 0 $file
     $ent xview end
   }
}

###################################################################
#------------------------------------------------------------------
#                    ExitDist
#------------------------------------------------------------------
###################################################################
proc ExitDist {} \
{
#   destroy .dplotw
   destroy .dgraph
   wm deiconify .
}

###################################################################
#------------------------------------------------------------------
#                       ADDFILEDist
#------------------------------------------------------------------
###################################################################
proc AddFileDist {} \
{
   global fileARRAY
   global countF mclID nr
   global line_bk format_ok

   set newfile ""
   set newfile [tk_getOpenFile -defaultextension .dly \
      -initialdir data -filetypes {{{drec files} {.dly} {}}} -parent .dgraph]

   if {$newfile == ""} {
   return
   }

  #else:
  #update the file listbox and data:
  #tk_messageBox -message "$newfile"

   incr countF

   set fileARRAY($countF) $newfile
   #tk_messageBox -message "countF= $countF"
   #tk_messageBox -message "f()= $fileARRAY($countF)"
   .dgraph.top.left.lbf.lb insert end [format "%02d : %s" $countF  $newfile ]
   .dgraph.top.left.lbf.lb see end

   set newfileMcl "[file rootname $newfile].mcl"

   #open the file:
   if [catch {open $newfileMcl} mclID] {
      tk_messageBox -message "$mclID"
      return
   }
   set line ""
   set line_bk "No title found"
   set nr 1
   set format_ok "0"

   fileevent $mclID readable \
   {
    if ![eof $mclID] {
      gets $mclID line

      ##############################################
      # New CODE: very easy  :)
      ##############################################
      if ![string compare $line "Mgen measure"] { 
        #get the title of measure  
        gets $mclID line
        set line_bk [string range $line 11 [string length $line] ]
        #tk_messageBox -message "X=$line_bk"        
        .dgraph.down.flows.lb insert end \
           [format "File %02d       Flow %02d    -    %s   " $countF $nr $line_bk]
        .dgraph.down.flows.lb see end
        incr nr
        set format_ok "1"
      }
      # CAN BE TRASH THIS
      ################################################################
      # for the compatibility with old file type (netmeter < 19july2001)
      ################################################################
      if ![string compare $line "\x00\x00"] { 
        .dgraph.down.flows.lb insert end \
        [format "File %02d       Flow %02d    -    %s   " $countF $nr $line_bk]
        .dgraph.down.flows.lb see end
        incr nr
        set format_ok "1"
      }
    } else {
      if [catch {close $mclID} err] {
      tk_messageBox -message "$err"
    }
   }
 }
}

###################################################################
#------------------------------------------------------------------
#       NEW Code - Delete only selected
#------------------------------------------------------------------
###################################################################
proc ClearFileDist {} \
{
   global xfile
   global userLB6 head6
   global flow6 mod6 flow6LB
   global countF mclID nr lineNr
   global fileARRAY

   set tmp [.dgraph.top.left.lbf.lb curselection]
   if {$tmp == ""} {
     #nothing selected
     tk_messageBox -message "No file selected..!!!"
     return
   }

   #tk_messageBox -message [selection get]
   set line2 [selection get]
   scan $line2 "%s : " file_num
   #I think that this is a BAD solution :| sorry
   set  file_num [format "%.0f" $file_num]
   set xfile2 $file_num
   #tk_messageBox -message "file selected = $file_num"
   set selList ""
   set selList [.dgraph.down.flows.lb get 0 end]
   if {$selList == ""} \
   {
      tk_messageBox -message "No flows defined..!!!"
      #return
   }
   #tk_messageBox -message "lista completa= $selList"
   set count 0
   foreach lineNr  $selList \
   {
      set line [.dgraph.down.flows.lb get $count]
      scan $line "File %s Flow %s" fiN flN
      set  fiN [format "%.0f" $fiN]
      if {$fiN ==$file_num} \
      {
        #tk_messageBox -message "MATCH FLOW !!!!!"
        .dgraph.down.flows.lb   delete $count
      } else {
        incr count
      }
   }
   #Remove entry in listbox
   .dgraph.top.left.lbf.lb delete $tmp
   #if the actual view-file match... delete it
   if {$xfile2 == $xfile} {.dgraph.top.right.flows.lb delete 0 end }
   #Remove entry in File name Array
   unset fileARRAY($file_num)
}

###################################################################
#------------------------------------------------------------------
#                  Plot Mgen Graphic
#------------------------------------------------------------------
###################################################################
proc PlotDist {} \
{
   global fileARRAY
   global maxDG dgr
   global dataDG
   global maximum minimum distOption
   global graphsNumber

   global zoom_min
   global zoom_max
   global zoom_size
   global auto_zoomx
   global zoom_sizey
   global zoom_gap
   global zoom_tgap
   global kill

   global  max_check
   global  min_check
   global  kill_check

   global flagOption
   global outputfile
   global auxID auxID2 auxID3 auxID4
   global _distrCMD
#   global _graphCMD
   global _xviewCMD
   global _correlCMD
   global calcCorrel           ;# Wether we have correlation calculation or not
   global zeroOption
   global fillOption
   global backOption
   global PatternValue
   global PatternCheck

   global debug

   set maxDG 0
   set graphsNumber 0
   set selList ""
   set selList [.dgraph.down.flows.lb curselection]
   if {$selList == ""} \
   {
      #nothing selected
      tk_messageBox -message "No flow selected"
      return
   }

   if {$outputfile == ""} \
   {
      #nothing selected
      tk_messageBox -message "Need an output file name...!!!"
      return
   }

   ###################################################################
   # Start to make the Grahic - external programs definitions
   ###################################################################
   set distrCMD $_distrCMD
#   set graphCMD $_graphCMD 
   set xviewCMD $_xviewCMD
   set correlCMD $_correlCMD
   ###################################################################
#   append graphCMD " temp/cgraph "

   .dgraph.down.flows.b.b5 config -text "Wait..." -command {;#do nothing}

   if {$kill_check} {
         append distrCMD "% "
         append distrCMD "$kill "
   } else {
      if {$min_check} { 
         append distrCMD "$zoom_min "
      } else {
         append distrCMD "- "
      }
      if {$max_check} {
         append distrCMD "$zoom_max "
      } else {
         append distrCMD "- "
      } 
   }

   append distrCMD " $distOption $flagOption $outputfile "
   if {$auto_zoomx} {
      set final_size 0
      if {$distOption == 4} {	;# Only if handling with OWD without distribution
         foreach lineNr $selList \
         {
             set line [.dgraph.down.flows.lb get $lineNr]
             scan $line "File %s   Flow %s" fiN flN
             set  fiN [format "%.0f" $fiN]
             set size_temp [calcFlow $fileARRAY($fiN) Flow>[format "%0.4d" $flN] ]
	     if {$size_temp > $final_size} {
	       set final_size $size_temp
	     }
         }
         append distrCMD " $final_size "
      } else {
         append distrCMD " $zoom_size "
      }
   } else {
      append distrCMD " $zoom_size "
   }
   append distrCMD " $zoom_gap "
   append distrCMD " $zoom_tgap "
   append distrCMD " $zoom_sizey "

   append distrCMD " $fillOption "
   append distrCMD " $zeroOption "
   append distrCMD " $backOption "

   append correlCMD " -f -i temp/graphDAT-1 -i temp/graphDAT-2 -o temp/correl.dat"
   
   if {$PatternCheck} {
       append distrCMD " $PatternValue"
   } else {
       append distrCMD "- "
   }

   set filenumber 0
   foreach lineNr  $selList \
   {
      set line [.dgraph.down.flows.lb get $lineNr]
      scan $line "File %s   Flow %s" fiN flN
      set  fiN [format "%.0f" $fiN]
      incr filenumber
      lappend distrCMD $fileARRAY($fiN)
      lappend distrCMD $flN
   }
   #########################################################
   # tk_messageBox -message "DISTR.EXE   command : $distrCMD"
   # tk_messageBox -message "Graph       command : $graphCMD"
   # tk_messageBox -message "Xview       command : $xviewCMD"
   # tk_messageBox -message "correlation command : $correlCMD"
   #########################################################
   
   if { $calcCorrel == 1 && $filenumber != 2 } {
      tk_messageBox -message "You need EXACTLY two flows to compute the correlation value"
      .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
      return
   }

   if $debug {
	puts stderr "distribution Command: $distrCMD";
	puts stderr "Graph Command: Dynamic version, omitting";
#	puts stderr "Graph Command: $graphCMD";
   }
   
   if [catch {eval exec $distrCMD} auxID] \
   {
      #err message:
      tk_messageBox -message $auxID
      .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
      return
   }

#   if [catch {eval exec $graphCMD} auxID2] \
#   {
      #err message:
#      tk_messageBox -message $auxID2
#      .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
#      return
#   }

   # Prepare all correlation crap
   if [catch {eval exec "cat temp/graphDAT | cut -f 2 -d\\  > temp/graphDAT-1"} auxID4] {
      #err message:
      tk_messageBox -message $auxID4
      .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
      return
   }
   if [catch {eval exec "cat temp/graphDAT | cut -f 3 -d\\  > temp/graphDAT-2"} auxID4] {
      #err message:
      tk_messageBox -message $auxID4
      .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
      return
   }
   # Correlation stuff
   if [catch {eval exec $correlCMD} auxID4] \
   {
      #err message:
      tk_messageBox -message $auxID4
      .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
      return
   }
   # End of correlation part
   # Now we prepare the graphic visualitzation
#   set xviewCMD "$xviewCMD -geometry `file $outputfile | cut -d\\  -f 5`x`file $outputfile | cut -d\\  -f 7 | sed s/,//`+0+0 $outputfile"
   set xviewCMD "$xviewCMD $outputfile"
   if [catch {open "|$xviewCMD" r} auxID3] \
   {
      #err message:
      tk_messageBox -message $auxID3
      .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
      return
   }

   if { $calcCorrel == 1 } {
      # Now we must show the correlation related information.
      regsub {\.png} $outputfile \.txt  outputtext
      if [catch {open $outputtext w} idfile] {
         tk_messageBox -message "Fatal Error opening correlation file"
         .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
         return
      }
      set corrVal [exec cat temp/correl.dat]
      regsub {\n} $corrVal \  corrVal
      puts $idfile "The Correlation Coefficient is: $corrVal"
      puts $idfile "----------------------------------------"
      puts $idfile "That value ranges from -1 to +1.\nA -1 value means that both statistical variables are inversely proportional, that is when value A grows then value B shrinks."
      puts $idfile "A +1 value means that both statistical variables are directely proportional, that is when value A grows then value B, grows too."
      puts $idfile "Finally a 0 value means that both statistical variables are independent."
      puts $idfile "For our test we want a +1 value, that is, the significance from one variable to another."
      catch {close $idfile}
#-geometry 129x9+0-0 -hold -e
      if [catch {open "| xterm -title \"Statistical Information\" -hold -e cat $outputtext" r} auxID3] \
      {
         #err message:
         tk_messageBox -message $auxID3
         .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
         return
      }
   }

   .dgraph.down.flows.b.b5 config -text "Plot" -command PlotDist
};




###################################################################
#------------------------------------------------------------------
#             View Mgen Result file .MCL
#------------------------------------------------------------------
###################################################################
proc Viewfile {} \
{
   global fileARRAY
   global userLB6 head6
   global flow6 mod6 flow6LB
   global countF mclID nr lineNr
   global dgr
   global xfile      # file number of last viewed_file

   .dgraph.top.right.flows.lb delete 0 end
   set tmp [.dgraph.top.left.lbf.lb curselection]
   if {$tmp == ""} {
   #nothing selected
   return
   }
   #tk_messageBox -message [selection get]
   set line2 [selection get]
   scan $line2 "%s :  " file_num
   set  file_num [format "%.0f" " $file_num"]
   set xfile $file_num
   set newfile $fileARRAY($file_num)

   set lindex    [string first : $line2 1]
   set newfile   [string range $line2 [expr $lindex +1] [string length $line2] ]
   set newfile   [string trim  $newfile]
   set file_name $newfile

   set newfileMcl "[file rootname $newfile].mcl"
   #open the file:
   if [catch {open $newfileMcl} mclID] {
   tk_messageBox -message "$mclID"
   return
   }
   .dgraph.top.right.flows.lb insert end  "------------------------------------------------------------------------------------------------"
   .dgraph.top.right.flows.lb insert end  " $file_name"
   .dgraph.top.right.flows.lb insert end  "------------------------------------------------------------------------------------------------"
   #.dgraph.top.right.flows.lb insert end  " List of .MCL file: "
   .dgraph.top.right.flows.lb see    end
   set line ""
   while {![eof $mclID]} \
   {

        gets $mclID line
        .dgraph.top.right.flows.lb insert end  "$line"
        .dgraph.top.right.flows.lb see    end
   }
   .dgraph.top.right.flows.lb insert end  "------------------------------------------------------------------------------------------------"
   .dgraph.top.right.flows.lb see    end
   close $mclID
}

###################################################################
#------------------------------------------------------------------
#                  EDIT GRAPH TITLE
#------------------------------------------------------------------
###################################################################
proc EditTitle {} \
{
   global maxDG dgr
   global fileARRAY dataDG
   global mclID
   global MCList
   global xfile
   global NewTitle
   global done 

   set selList ""
   set selList [.dgraph.down.flows.lb curselection]
   if {$selList == ""} \
   {
      #nothing selected
      tk_messageBox -message "No flow selected"
      return
   }
   foreach lineNr  $selList \
   {
      set NewTitle  ""
      set line [.dgraph.down.flows.lb get $lineNr]
      set lindex [string first - $line 1]
      set line_bk  [string range $line [expr $lindex +1 ] [string length $line] ]
      set NewTitle [string trim  $line_bk]

      ###################################################################
      #### make a dialog window for the NEW FLOW NAME
      ###################################################################
      set done 0
      toplevel .title
      wm title .title "Plot Options"
      wm resizable .title 0 0
      wm protocol .title WM_DELETE_WINDOW {;#do nothing}

      frame .title.centre -bd 2 -relief groove
      pack .title.centre -fill x -pady 2 -padx 3 -anchor n -expand true

      frame .title.centre.hold 
      pack  .title.centre.hold    -fill x -pady 2 -padx 3 -anchor n -expand true
      label .title.centre.hold.l  -text "Special chars:  (+) New title line "
      pack  .title.centre.hold.l  -side left -padx 3 -fill x

      frame .title.centre.old 
      pack  .title.centre.old    -fill x -pady 2 -padx 3 -anchor n -expand true
      label .title.centre.old.l  -text "Old Flow parameters: $line"
      pack  .title.centre.old.l  -side left -padx 3 -fill x

      frame .title.centre.new
      pack  .title.centre.new    -fill x -pady 2 -padx 3 -anchor n -expand true
      label .title.centre.new.l  -text "Set new Flow Name"
      pack  .title.centre.new.l  -side left -padx 3 -fill x
      entry .title.centre.new.e  -textvariable NewTitle -width 70
      pack  .title.centre.new.e  -padx 3 -side left

      frame .title.down
      pack .title.down -pady 2 -padx 3 -side bottom -anchor c
      button .title.down.ok -text OK -command \
      {
         set done "1" 
         destroy .title
      } -width 6
      button .title.down.cancel -text Cancel -command \
      {
         set done "0"
         destroy .title
         return  
      } -width 6
      pack .title.down.ok .title.down.cancel  -side left -padx 3 -pady 2
      ###################################################################
      #### Wait to END dialog
      ###################################################################
      grab .title
      tkwait window .title


      ###################################################################
      #### Start Modify the .MCL data file
      ###################################################################
      if { $done == "0" } return
      scan $line "File %s   Flow %s " fiN flN
      set  fiN [format "%.0f" $fiN]
      set  flN [format "%.0f" $flN]
      set filename $fileARRAY($fiN)
      set newfileMcl "[file rootname $filename].mcl"
      ###################################################################
      #tk_messageBox -message "File name: $newfileMcl"
      ###################################################################
      if [catch {open $newfileMcl r} mclID] {
         tk_messageBox -message "$mclID"
         return
      }
      set countf 1 
      set line ""
      catch {unset MCList}
      while { [gets $mclID line] != -1  }\
      {
          lappend MCList $line
          #tk_messageBox -message "out: $line"
      } 
      if [catch {close $mclID} err] {
          tk_messageBox -message "$err"
          return
      }
      if [catch {open $newfileMcl w} idfile] {
        tk_messageBox -message  "Failed Edit MCL file..!!!"
        return
      }
      ###################################################################
      #tk_messageBox -message "out: $MCList"
      ###################################################################
      lappend MCList "STOP"
      set xstop "0"  
      set count 0

      foreach line $MCList \
      {
         set line  [lindex $MCList $count] 
         if ![string compare $line "STOP"] { set xstop "1"  }
         if ![string compare $line "Mgen measure"] {
            if { $flN == $countf } \
            {
               puts $idfile $line
               incr count
               #update line of the file .MCL:
               set line  "Flow name: $NewTitle"

               #update finally the listbox
               .dgraph.down.flows.lb delete [expr $lineNr ]
               .dgraph.down.flows.lb insert [expr $lineNr ]  \
               [format "File %02d       Flow %02d    -    %s   " $fiN $flN  $NewTitle ]
               #update the actual show MCL listbox ;-)
               if {$xfile == $fiN } {
                 .dgraph.top.right.flows.lb delete 0 end
               }
            }
            incr countf
         } 
         if { $xstop == "0" } { 
            puts $idfile $line
            #tk_messageBox -message "line: $line"
         }
         incr count
      }
      if [catch {close $idfile} err] {
          tk_messageBox -message "$err"
          return
      }
   } 
}

###################################################################
#------------------------------------------------------------------
#                 Select specific Flows on Listbox ALL
#------------------------------------------------------------------
###################################################################
proc SelectAll {} \
{
   set selList ""
   set selList [.dgraph.down.flows.lb get 0 end]
   if {$selList == ""} \
   {
      #nothing selected
      tk_messageBox -message "No flows defined..!!!"
      return
   }
   set count 0
   foreach lineNr  $selList \
   {
     .dgraph.down.flows.lb selection set $count
     incr count
   }
}


###################################################################
#------------------------------------------------------------------
#                 Process the DLY file with mcalc
#------------------------------------------------------------------
###################################################################
proc ProcessDLY {} \
{
   global fPath
   global logDelayLB
   global scripted4
   global scripted6

   set newfile ""
   set newfile [tk_getOpenFile -defaultextension .dly \
       -initialdir data -filetypes {{{MGen-Broadband files} {.dly} {}}} -parent .dgraph]
   if {$newfile == ""} {
      return
   }
    #if You don't want to launch the Test.... only process .DLY :(
   set fPath $newfile


      toplevel .title
      wm title .title "Making new MCL FILE"
      wm resizable .title 0 0
      wm protocol .title WM_DELETE_WINDOW {;#do nothing}

      frame .title.b
      pack  .title.b -side top
      frame .title.c
      pack  .title.c -side bottom -expand true
      label .title.b.l  -text "Do you want process the file to make the .MCL file?"
      pack  .title.b.l  -side top -padx 3 -fill x -expand true
      label .title.b.l1  -text "(you have to set the same configuration file of measure)"
      pack  .title.b.l1  -side top -padx 3 -fill x -expand true

      button .title.c.ok -text OK -command \
      {
         set done "1" 
         destroy .title
      } -width 6
      button .title.c.cancel -text Cancel -command \
      {
         set done "0"
         destroy .title
         return  
      } -width 6
      pack .title.c.ok .title.c.cancel  -side left -pady 2 
      ###################################################################
      #### Wait to END dialog
      ###################################################################
      grab .title
      tkwait window .title

   $logDelayLB delete 0 end
   ProcessData
}




###################################################################
#------------------------------------------------------------------
#            Mgen Graphic Option (Max,Min,Size)
#------------------------------------------------------------------
###################################################################
proc PlotOPT {} \
{
   global max_check
   global min_check
   global zoom_tgap
   global zoom_gap
   global zoom_min
   global zoom_max
   global zoom_size
   global auto_zoomx
   global zoom_sizey
   global kill
   global kill_check

   global PatternValue
   global PatternCheck

   global fillOption
   global zeroOption
   global backOption
   global _xviewCMD


   #make a dialog window
   toplevel .dialog
   wm title .dialog "Plot Options"
   wm resizable .dialog 0 0
   wm protocol .dialog WM_DELETE_WINDOW {;#do nothing}

   ########
   #TK body
   ########
   label .dialog.l -text "Graphic parameters"
   pack  .dialog.l -side top -padx 3 -fill x
   frame .dialog.top -bd 2 -relief groove
   pack  .dialog.top -fill x -pady 2 -padx 3 -anchor n -expand true
   label .dialog.l2 -text "Analysis parameters"
   pack  .dialog.l2  -padx 3 -fill x
   frame .dialog.down -bd 2 -relief groove
   pack  .dialog.down -fill x -pady 2 -padx 3 -anchor n -expand true
   
   label .dialog.l3 -text "Other Options"
   pack  .dialog.l3  -padx 3 -fill x
   frame .dialog.down2 -bd 2 -relief groove
   pack  .dialog.down2 -fill x -pady 2 -padx 3 -anchor n -expand true

   frame .dialog.top.zsize
   pack  .dialog.top.zsize -pady 2 -fill x
   label .dialog.top.zsize.l -text "Graph X size (pixel)"
   pack  .dialog.top.zsize.l -side left -padx 3

   checkbutton .dialog.top.zsize.c_zoom -variable auto_zoomx -text Auto \
      -command {
      if $auto_zoomx {
           #disable entry
           .dialog.top.zsize.e config -state disabled -fg gray
       } else {
          #enable entry
          .dialog.top.zsize.e config -state normal -fg black
       }
   }
   pack  .dialog.top.zsize.c_zoom -side right -padx 3

   entry .dialog.top.zsize.e -textvariable zoom_size -width 11
   pack  .dialog.top.zsize.e -side right -padx 7

   frame .dialog.top.ysize
   pack  .dialog.top.ysize -pady 2 -fill x
   label .dialog.top.ysize.l -text "Graph Y size (pixel)"
   pack  .dialog.top.ysize.l -side left -padx 3
   entry .dialog.top.ysize.e -textvariable zoom_sizey -width 20
   pack  .dialog.top.ysize.e -side right -padx 3

   frame .dialog.top.gap
   pack  .dialog.top.gap -pady 2 -fill x
   label .dialog.top.gap.l -text "Pixel Gap (pixel)"
   pack  .dialog.top.gap.l -side left -padx 3
   entry .dialog.top.gap.e -textvariable zoom_gap -width 20
   pack  .dialog.top.gap.e -side right -padx 3

   frame .dialog.top.tgap
   pack  .dialog.top.tgap -pady 2 -fill x
   label .dialog.top.tgap.l -text "Text Gap (pixel)"
   pack  .dialog.top.tgap.l -side left -padx 3
   entry .dialog.top.tgap.e -textvariable zoom_tgap -width 20
   pack  .dialog.top.tgap.e -side right -padx 3

   frame .dialog.top.rback -bd 2 -relief groove
   pack  .dialog.top.rback   -expand true -fill both  -pady 4 -padx 3
   label .dialog.top.rback.l -text "Use Extra Layout"
   radiobutton .dialog.top.rback.rc1 -text "enable" \
         -variable backOption -value 1 -width 8
   radiobutton .dialog.top.rback.rc2 -text "disable" \
         -variable backOption -value 0 -width 8
   pack  .dialog.top.rback.l  -side left -padx 5
   pack  .dialog.top.rback.rc1 \
         .dialog.top.rback.rc2 \
         -side right -pady 2 -padx 5

   frame .dialog.top.solid -bd 2 -relief groove
   pack  .dialog.top.solid   -expand true -fill both  -pady 4 -padx 3
   label .dialog.top.solid.l -text "Fill Graphic Distribution"
   radiobutton .dialog.top.solid.rc1 -text "enable" \
         -variable fillOption -value 1 -width 8
   radiobutton .dialog.top.solid.rc2 -text "disable" \
         -variable fillOption -value 0 -width 8
   pack  .dialog.top.solid.l  -side left -padx 5 
   pack  .dialog.top.solid.rc1 \
         .dialog.top.solid.rc2 \
         -side right -pady 2 -padx 5

   frame .dialog.top.rzero -bd 2 -relief groove
   pack  .dialog.top.rzero   -expand true -fill both  -pady 4 -padx 3
   label .dialog.top.rzero.l -text "Zero reference for axis-X"
   radiobutton .dialog.top.rzero.rc1 -text "enable" \
   -variable zeroOption -value 1 -width 8
   radiobutton .dialog.top.rzero.rc2 -text "disable" \
   -variable zeroOption -value 0 -width 8
   pack  .dialog.top.rzero.l  -side left -padx 5
   pack  .dialog.top.rzero.rc1 \
         .dialog.top.rzero.rc2 \
          -side right -pady 2 -padx 5

   frame .dialog.top.pattern
   pack  .dialog.top.pattern -pady 2 -fill x
   checkbutton .dialog.top.pattern.cB -variable PatternCheck \
      -text "Enable Pattern - Gap (pixel)" -command {
      if $PatternCheck {
          #enable entry
          .dialog.top.pattern.e config -state normal -fg black
      } else {
          #disable entry
          .dialog.top.pattern.e config -state disabled -fg gray
      }
   }
   if $PatternCheck {
      entry .dialog.top.pattern.e -textvariable PatternValue -state normal
   } else {
      entry .dialog.top.pattern.e -textvariable PatternValue -state disabled -fg gray
   }
   pack .dialog.top.pattern.cB -padx 3 -side left
   pack .dialog.top.pattern.e  -padx 3  -side right

   frame .dialog.down2.correlation
   pack  .dialog.down2.correlation -pady 2 -fill x
   checkbutton .dialog.down2.correlation.cB -variable calcCorrel \
      -text "Calcule Correlation Coefficient"
   pack  .dialog.down2.correlation.cB -side left -padx 3

   frame .dialog.down.kill
#  pack  .dialog.down.kill -pady 2 -fill x
   checkbutton .dialog.down.kill.cB -variable kill_check \
   -text "Values between  % average" -command {
      if $kill_check {
          #enable entry
          .dialog.down.kill.e config -state normal -fg black
      } else {
          #disable entry
          .dialog.down.kill.e config -state disabled -fg gray
      }
   }
   if $kill_check {
      entry .dialog.down.kill.e -textvariable kill -state normal
   } else {
      entry .dialog.down.kill.e -textvariable kill -state disabled -fg gray
   }
   pack .dialog.down.kill.cB -padx 3 -side left
   pack .dialog.down.kill.e  -padx 3  -side right


   frame .dialog.down.min
   pack  .dialog.down.min -pady 2 -fill x
   checkbutton .dialog.down.min.cB -variable min_check \
   -text "Min time value (ms)" -command {
      if $min_check {
          #enable entry
          .dialog.down.min.e config -state normal -fg black
      } else {
          #disable entry
          .dialog.down.min.e config -state disabled -fg gray
      }
   }
   if $min_check {
      entry .dialog.down.min.e -textvariable zoom_min -state normal
   } else {
      entry .dialog.down.min.e -textvariable zoom_min -state disabled -fg gray
   }
   pack .dialog.down.min.cB -padx 3 -side left
   pack .dialog.down.min.e  -padx 3  -side right
   frame .dialog.down.max
   pack  .dialog.down.max -pady 2 -fill x
   checkbutton .dialog.down.max.cB -variable max_check \
      -text "Max time value (ms)" -command {
      if $max_check {
          #enable entry
          .dialog.down.max.e config -state normal -fg black
      } else {
          #disable entry
          .dialog.down.max.e config -state disabled -fg gray
      }
   }
   if $max_check {
      entry .dialog.down.max.e -textvariable zoom_max -state normal
   } else {
      entry .dialog.down.max.e -textvariable zoom_max -state disabled -fg gray
   }
   pack .dialog.down.max.cB -padx 3 -side left
   pack .dialog.down.max.e  -padx 3 -side right

   frame .dialog.down.trans -bd 2 -relief groove
   pack  .dialog.down.trans  -expand true -fill both  -pady 4 -padx 3
   label .dialog.down.trans.l -text "Transitory analysis"
   radiobutton .dialog.down.trans.rc1 -text "enable" \
      -variable flagOption -value 1 -width 8
   radiobutton .dialog.down.trans.rc2 -text "disable" \
      -variable flagOption -value 0 -width 8
   pack  .dialog.down.trans.l  -side left -padx 5
   pack  .dialog.down.trans.rc1 \
         .dialog.down.trans.rc2 \
          -side right -pady 2 -padx 5 


   button .dialog.ok -text OK -command \
   {
      destroy .dialog
   } -width 6
   pack .dialog.ok
   grab .dialog
   tkwait window .dialog

   if {($zoom_size>1000 || $zoom_size<80) && $auto_zoomx==0 } {
       tk_messageBox -message "Illegal X Graph size..!!!"
       PlotOPT
   }
   if {$zoom_sizey>800 || $zoom_sizey<200} {
       tk_messageBox -message "Illegal Y Graph size..!!!"
       PlotOPT
   }
   if {$zoom_gap<=0 || $zoom_gap>5} {
       tk_messageBox -message "Illegal pixel gap size..!!!"
       PlotOPT
   }
   if {$zoom_tgap<5 || $zoom_tgap>30} {
       tk_messageBox -message "Illegal text gap size..!!!"
       PlotOPT
   }
   if $kill_check {
     if { $kill<20 || $kill>100 }  {
       tk_messageBox -message "Illegal % value..!!!"
       PlotOPT
     }
   }
   if $PatternCheck {
     if { $PatternValue<1 || $PatternValue>100 }  {
       tk_messageBox -message "Illegal Pattern value..!!!"
       PlotOPT
     }
   }
}



