###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                      Roberto Borgione       #
#                                             #
# help.tcl - Help Assistant                   #
#       v2.0 (04-2002)                        #
#       v2.01(10-2002)                        #
#       v2.0.3(01-2004)                       #
#       v2.0.4(01-2005)                       #
#       v2.0.5(02-2005)                       #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


proc Help {} \
{

   global hF

   frame $hF.main   -bd 2 -relief groove
   pack  $hF.main    -fill x
   frame $hF.main.top -bd 2 -relief groove
   pack  $hF.main.top -padx 3 -pady 3
   frame $hF.main.down
   pack  $hF.main.down -fill x
   frame $hF.main.bottom
   pack  $hF.main.bottom -fill x
   frame $hF.main.bottom.left
   pack  $hF.main.bottom.left -fill x
   frame $hF.main.down.right
   pack  $hF.main.down.right -side right 
   frame $hF.main.down.left
   pack  $hF.main.down.left  -side left   -padx 7 -pady 3
   #-expand yes -fill both


   frame $hF.main.top.logo 
   pack  $hF.main.top.logo 
   label $hF.main.top.logo.img -image logoImage -anchor c
   pack  $hF.main.top.logo.img -padx 3 -pady 3
   label $hF.main.top.titleL -text \
   "Netmeter v2.0.5 - (c) Copyright 2004 Advanced Broadband Communications Center (CCABA) - UPC" -relief sunken
   pack  $hF.main.top.titleL -padx 6 -pady 6 -side top  -fill x

   frame $hF.main.down.right.logoc 
   pack  $hF.main.down.right.logoc 
   label $hF.main.down.right.logoc.img -image ccabaImage -anchor c
   pack  $hF.main.down.right.logoc.img -padx 3 -pady 3 -side right

   frame $hF.main.down.left.l
   pack  $hF.main.down.left.l    -side top -fill x -expand yes 

   label $hF.main.down.left.l.a1 -text "Project current developer:"
   label $hF.main.down.left.l.a2 -font {Helvetica 15 bold} -text "    Ren Serral"
   label $hF.main.down.left.l.a3 -text "Project originally developed by:"
   label $hF.main.down.left.l.a4 -font {Helvetica 15 bold} -text "    Roberto Borgione"
   label $hF.main.down.left.l.l1 -text "Project coordinators:"
   label $hF.main.down.left.l.l2 -font {Helvetica 15 bold} -text "    Jordi Domingo Pascual"
   label $hF.main.down.left.l.l3 -font {Helvetica 15 bold} -text "    Josep Mangues Bafalluy"
   pack  $hF.main.down.left.l.a1 $hF.main.down.left.l.a2 $hF.main.down.left.l.a3 $hF.main.down.left.l.a4 \
         $hF.main.down.left.l.l1 $hF.main.down.left.l.l2  \
                                 $hF.main.down.left.l.l3  \
         -side top -expand yes -pady 2 -anchor w
 


   frame $hF.main.bottom.left.flowG
   pack  $hF.main.bottom.left.flowG -padx 3 -pady 3 -fill both -side bottom
   label $hF.main.bottom.left.flowG.l -text "Label ListBox"
   #pack $hF.main.bottom.left.flowG.l -padx 3 -anchor c

   text $hF.main.bottom.left.flowG.lb -xscrollcommand "$hF.main.bottom.left.flowG.sx set" \
   -yscrollcommand "$hF.main.bottom.left.flowG.sy set" -width 81 -height 12

   scrollbar $hF.main.bottom.left.flowG.sx -orient horizontal -command \
   "$hF.main.bottom.left.flowG.lb xview"
   scrollbar $hF.main.bottom.left.flowG.sy -orient vertical -command \
   "$hF.main.bottom.left.flowG.lb yview"
   #pack $hF.main.bottom.left.flowG.sx -side bottom -fill x
   pack $hF.main.bottom.left.flowG.sy -side right -fill y
   pack $hF.main.bottom.left.flowG.lb -fill both -expand true

   set tbox  $hF.main.bottom.left.flowG.lb
   pack $tbox  -expand yes -fill both -side bottom 

$tbox tag configure color1 -background #a0b7ce
$tbox tag configure color2 -foreground red
$tbox tag configure color3 -foreground blue
$tbox tag configure raised -relief raised -borderwidth 1
$tbox tag configure sunken -relief sunken -borderwidth 1

$tbox tag configure bold -font {Courier 12 bold italic}
$tbox tag configure verybig -font {Helvetica 24 bold}
$tbox tag configure bgstipple -background black -borderwidth 0 	-bgstipple gray12
$tbox tag configure fgstipple -fgstipple gray50
$tbox tag configure underline -underline on
$tbox tag configure overstrike -overstrike on
$tbox tag configure right -justify right
$tbox tag configure center -justify center
$tbox tag configure super -offset 4p -font {Courier 10}
$tbox tag configure sub -offset -2p -font {Courier 10}
$tbox tag configure margins -lmargin1 12m -lmargin2 6m -rmargin 10m
$tbox tag configure spacing -spacing1 10p -spacing2 2p -lmargin1 12m -lmargin2 6m -rmargin 10m

  $tbox insert end "--------------------------------------------\n" center
  $tbox insert end "            Netmeter v2.0.5 " bold " - (c) Copyright 2004 \n"
  $tbox insert end "Advanced Broadband Communications Center ("
  $tbox insert end CCABA color3
  $tbox insert end ") - UPC\n"
  $tbox insert end "--------------------------------------------\n" center
  $tbox insert end "\n"

  $tbox insert end "The work has been done as part of my graduation thesis\n" 
  $tbox insert end "within   the   Socrates/Erasmus  program  between  the\n" 
  $tbox insert end "Politecnico  di Torino and the Universitat Politecnica\n" 
  $tbox insert end "de Catalunya.\n"
  
  $tbox insert end "\n"
  $tbox insert end "People that directly  or  indirectly,  collaborated to\n"
  $tbox insert end "the project:\n"
  $tbox insert end "\n"
  $tbox insert end " Albert Renom" bold ", who wrote the core of the Graph program\n"
  $tbox insert end " Carles Kishimoto" bold ", who wrote some tcl/tk routines\n"
  $tbox insert end " Gabriel Lazar" bold ", who wrote the old source code.\n"
  $tbox insert end "\n"
  $tbox insert end "Special thanks to all the people of the CCABA\n"
}

