###############################################
# Copyright 2002, 2003 Ren Serral,           #
#                      Roberto Borgione       #
#                                             #
# netgraph.tcl - Graphic results Widget       #
#       v2.0 (04-2002)                        #
#       v2.01(10-2002)                        #
###############################################

#   This file is part of NetMeter.
#
#   NetMeter is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   NetMeter is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with NetMeter; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


##################################################################
#------------------------------------------------------------------
#      NETmeter new style of graph (from an idea of GRAPHTOOL)
#------------------------------------------------------------------
###################################################################
proc NetGRAPH { typeF } \
{
   global countf
   global countG
   global Xlabel Ylabel retCode
   global count_files
   global distOption
   global flagOption
   global outputfile
   global xfile
   global GlobalTitle
   global graph_lines
   global graph_Xsize
   global graph_Ysize
   global CALL
   global GraphID
   global GraphArray

   global showfileID
   global FileArray



   ####################
   #set var
   ####################
   set CALL $typeF

   set countG 0
   set countf 0
   set xfile 7777

   set graph_lines 15
   set graph_Xsize 450
   set graph_Ysize 400


   ####################
   #set TK_menu buttons
   ####################

   set temp "Graph 00"
   set temp [string trim  $temp]
   set GraphArray($temp) 0
   set GraphID $temp

   set  showfileID "All"
   set  FileArray($showfileID) 0


   ##################
   #init TK interface
   ##################

   set GlobalTitle "Graphic result"
   wm withdraw .
   set count_files 0
   toplevel .graph
#  wm title .graph "Ultimate Graph Tool :-)"
   wm title .graph "Graphic Result"
   wm resizable .graph 0 0
   wm protocol  .graph WM_DELETE_WINDOW ExitResult

   frame .graph.up -bd 2 -relief groove
   pack  .graph.up -pady 3 -fill x -side top
   frame .graph.up.right -bd 2 -relief groove
   pack  .graph.up.right -padx 3 -pady 3 -side right
   frame .graph.down
   pack  .graph.down -pady 3 -fill x -side bottom

   ##########################
   # LISTBOX1 FOR VIEW FILE
   ##########################
   frame .graph.up.right.flows
   pack  .graph.up.right.flows -padx 3 -pady 3 -fill both
   label .graph.up.right.flows.l -text "file info(to select double click on file list)"
   pack  .graph.up.right.flows.l -padx 3 -anchor c

   listbox .graph.up.right.flows.lb -xscrollcommand ".graph.up.right.flows.sx set" \
   -yscrollcommand ".graph.up.right.flows.sy set" -width 1 -height 8 \
   -selectmode multiple
   scrollbar .graph.up.right.flows.sx -orient horizontal -command \
   ".graph.up.right.flows.lb xview"
   scrollbar .graph.up.right.flows.sy -orient vertical -command \
   ".graph.up.right.flows.lb yview"
   pack .graph.up.right.flows.sx -side bottom -fill x
   pack .graph.up.right.flows.sy -side right -fill y
   pack .graph.up.right.flows.lb -fill both -expand true

   ##################################
   # LISTBOX2 GRAPHIC-LIST
   ##################################
   frame .graph.up.right.flowG
   pack  .graph.up.right.flowG -padx 3 -pady 3 -fill both
   label .graph.up.right.flowG.l -text "Graphic List"
   pack .graph.up.right.flowG.l -padx 3 -anchor c

   listbox .graph.up.right.flowG.lb -xscrollcommand ".graph.up.right.flowG.sx set" \
   -yscrollcommand ".graph.up.right.flowG.sy set" -width 1 -height 5

   scrollbar .graph.up.right.flowG.sx -orient horizontal -command \
   ".graph.up.right.flowG.lb xview"
   scrollbar .graph.up.right.flowG.sy -orient vertical -command \
   ".graph.up.right.flowG.lb yview"
   pack .graph.up.right.flowG.sx -side bottom -fill x
   pack .graph.up.right.flowG.sy -side right -fill y
   pack .graph.up.right.flowG.lb -fill both -expand true


   ####################################################3
   #listbox3 for file selection:
   ####################################################3
   frame .graph.up.top -bd 2 -relief groove
   pack .graph.up.top -fill x -padx 2 -pady 2
   frame .graph.up.top.lbf
   pack .graph.up.top.lbf -fill both -padx 2 -pady 2 -side top
   frame .graph.up.top.b
   pack  .graph.up.top.b -pady 3 -padx 3 -side bottom -anchor c
   if ![string compare "npf"  $CALL] \
   {
      label .graph.up.top.lbf.l -text "Netperf Results files:"
   } else {
      label .graph.up.top.lbf.l -text "Mgen Results files:"
   }
   pack  .graph.up.top.lbf.l -padx 3 -anchor c

   listbox .graph.up.top.lbf.lb -xscrollcommand ".graph.up.top.lbf.sx set" \
   -yscrollcommand ".graph.up.top.lbf.sy set" -width 2 -height 7
   scrollbar .graph.up.top.lbf.sx -orient horizontal -command \
   ".graph.up.top.lbf.lb xview"
   scrollbar .graph.up.top.lbf.sy -orient vertical -command \
   ".graph.up.top.lbf.lb yview"
   pack .graph.up.top.lbf.sx -side bottom -fill x
   pack .graph.up.top.lbf.sy -side right -fill y
   pack .graph.up.top.lbf.lb -fill both -expand true
   bind .graph.up.top.lbf.lb <Double-1> { ViewResultFile }

   ### And buttons:
   button .graph.up.top.b.b1 -text "Add File" -command AddResultFile \
   -bd 2 -relief groove -width 8
   button .graph.up.top.b.b2 -text "Remove File" -command RemoveResultFile \
   -bd 2 -relief groove -width 8
   button .graph.up.top.b.b21 -text "Calc File" -command { UpdateResultFile 0 }\
   -bd 2 -relief groove -width 8

   button .graph.up.top.b.b3 -text Back -command  ExitResult \
   -bd 2 -relief groove -width 7
   #button .graph.up.top.b.b3 -text Back -command exit \
   -bd 2 -relief groove -width 10

   button .graph.up.top.b.b4 -text "Remove All" -command  RemoveData \
   -bd 2 -relief groove -width 8

   pack  .graph.up.top.b.b1 .graph.up.top.b.b2 .graph.up.top.b.b21 \
         .graph.up.top.b.b3 .graph.up.top.b.b4  -side left -padx 2

   ####################################################
   # Graphic OPTIONS
   ####################################################
   frame .graph.up.centre2 -bd 2 -relief groove
   pack .graph.up.centre2 -fill x -pady 3 -padx 3 -anchor n -expand true
   label .graph.up.centre2.l -text "Graphic options"
   pack .graph.up.centre2.l -side top -padx 3 -fill x

   frame .graph.up.centre2.title
   pack  .graph.up.centre2.title -padx 3 -pady 3 -expand true
   label .graph.up.centre2.title.l -text "Main Title: "
   pack  .graph.up.centre2.title.l -side left -padx 3
   entry .graph.up.centre2.title.e -textvariable GlobalTitle -width 47
   pack  .graph.up.centre2.title.e -side right -padx 3
   frame .graph.up.centre2.down2
   pack  .graph.up.centre2.down2 -padx 3 -pady 3 -expand true

   set outputfile "graphs/graphic.png"
   label  .graph.up.centre2.down2.lab -text "Output file name: "
   pack   .graph.up.centre2.down2.lab -side left
   entry  .graph.up.centre2.down2.ent -width 31  -textvariable outputfile
   pack   .graph.up.centre2.down2.ent -side left
   button .graph.up.centre2.down2.but -text "Browse ..." -command "SaveFile .graph.up.centre2.down2.ent"
   pack   .graph.up.centre2.down2.but -side right
   ### And buttons:
   frame .graph.up.centre2.b
   pack  .graph.up.centre2.b -padx 3 -pady 3 -expand true -side top
   button .graph.up.centre2.b.b1 -text "Add Graph" -command { AddGraph 0 } \
   -bd 2 -relief groove -width 11
   button .graph.up.centre2.b.b2 -text "Change Name" -command EditGraph\
   -bd 2 -relief groove -width 11
   button .graph.up.centre2.b.b5 -text "Remove Graph" -command RemoveGraph \
   -bd 2 -relief groove -width 11
   pack  .graph.up.centre2.b.b1 .graph.up.centre2.b.b5 \
   .graph.up.centre2.b.b2  -padx 3 -pady 3 -side left


   #############################
   #Listbox4 for flow selection:
   ############################
   frame  .graph.down.flows -bd 2 -relief groove
   pack   .graph.down.flows -fill both
   frame  .graph.down.flows.b
   pack   .graph.down.flows.b -padx 3 -pady 3 -expand true -side top
   button .graph.down.flows.b.b5 -text "Plot Graphs" -command PlotGraph      -bd 2 -relief groove -width 10
   button .graph.down.flows.b.b7 -text "Plot Options" -command PlotOptions   -bd 2 -relief groove -width 10

   frame  .graph.down.flows.b.b8
   button .graph.down.flows.b.b8.cmd -text "Select: " -command SelectFlow -bd 2 -relief groove -width 10
   eval tk_optionMenu .graph.down.flows.b.b8.menu showfileID [lsort [array names FileArray]]
   .graph.down.flows.b.b8.menu configure -width 9

   button .graph.down.flows.b.b1 -text "Link Flows with: " -command LinkFlow -relief groove -bd 2 -width 15
   eval tk_optionMenu .graph.down.flows.b.bx GraphID [lsort [array names GraphArray]]
   .graph.down.flows.b.bx configure -width 9

   pack  .graph.down.flows.b.b5 .graph.down.flows.b.b7 .graph.down.flows.b.b8 \
         .graph.down.flows.b.b1 .graph.down.flows.b.bx \
         -padx 3  -side left
   pack  .graph.down.flows.b.b8.cmd .graph.down.flows.b.b8.menu -padx 3 -side left

   listbox .graph.down.flows.lb -xscrollcommand ".graph.down.flows.sx set" \
   -yscrollcommand ".graph.down.flows.sy set" -width 1 -height 8\
   -selectmode multiple
   scrollbar .graph.down.flows.sx -orient horizontal -command \
   ".graph.down.flows.lb xview"
   scrollbar .graph.down.flows.sy -orient vertical -command \
   ".graph.down.flows.lb yview"
   set title "     -         Title                                      "
   set Ylabel "Flow Y value"
   set Xlabel "Flow X value"
   set flow_label [format \
   "File ID    -   Flow ID    -   Graph ID   -     %-11s    -    %-11s      %s" \
   $Ylabel $Xlabel $title]
   label .graph.down.flows.l -text $flow_label -relief raised
   pack  .graph.down.flows.l -anchor w -side top -padx 2
   pack .graph.down.flows.sx -side bottom -fill x
   pack .graph.down.flows.sy -side right -fill y
   pack .graph.down.flows.lb -fill both -expand true
}





###################################################################
#------------------------------------------------------------------
#                    fileDialog (chose Save file as....)
#------------------------------------------------------------------
###################################################################
proc SaveFile {ent } \
{
   set types {
     {"Image Files"           {.png}          }
     {"All files"                     *}
   }
   set file [tk_getSaveFile -filetypes $types  \
   -initialdir graphs/ -initialfile newgraph -defaultextension .png]
   if [string compare $file ""] {
     $ent delete 0 end
     $ent insert 0 $file
     $ent xview end
   }
}





###################################################################
#------------------------------------------------------------------
#                    Exit from Result Grafic
#------------------------------------------------------------------
###################################################################
proc ExitResult {} \
{

   global FileArray
   global GraphArray

   unset  GraphArray
   unset  FileArray
   destroy .graph
   wm deiconify .
}



###################################################################
#------------------------------------------------------------------
#    Update Flow Listbox  (called from ADDfile)
#------------------------------------------------------------------
###################################################################
proc UpdateFlowListbox {} \
{
   global count_files  fileID nr
   global title title_ok xvalue xvalue_ok yvalue yvalue_ok countv
   global retCode countf
   global count_flow value line
   global Format_error
   global countG

   if  { $xvalue_ok == 0 || $yvalue_ok == 0 || $title_ok == 0} \
   {
        for {set i 1} {$i < $count_flow} {incr i} \
        {
         .graph.down.flows.lb delete end end
        }
        set Format_error 1
        return
   } else {
      .graph.down.flows.lb insert end [format "File %02d         Flow %02d         Graph %02d          %011f          %011f   -     %s"\
      [expr $count_files +1]  $count_flow [expr $countG + 1] $yvalue $xvalue $title]
      .graph.down.flows.lb see end
      set val_index 0
      set title ""
      set title_ok 0
      set xvalue ""
      set xvalue_ok 0
      set yvalue ""
      set yvalue_ok 0
    }
}



###################################################################
#------------------------------------------------------------------
#                    Add Result File
#------------------------------------------------------------------
###################################################################
proc AddResultFile {} \
{
   global count_files fileID nr
   global title title_ok xvalue xvalue_ok yvalue yvalue_ok
   global Xlabel Ylabel
   global retCode countf
   global count_flow value line value_label
   global Format_error
   global CALL
   global showfileID
   global FileArray


   set newfile ""
   if ![string compare "npf"  $CALL] \
   {
      set newfile [tk_getOpenFile -defaultextension .npf \
      -initialdir data -filetypes {{{netperf files} {.npf} {}}} -parent .graph]
   } else {
      set newfile [tk_getOpenFile -defaultextension .mcl \
      -initialdir data -filetypes {{{drec files} {.mcl} {}}} -parent .graph]
   }
   if {$newfile == ""} { #cancel pressed :(
     return
   }

   set newfileMcl $newfile
   ###########################################
   # if open the first file, set the axis
   ###########################################
   if {$countf == 0} {
      GraphValues $newfileMcl
      if {$retCode == 1} {
        #could not open file
        tk_messageBox -message "Error ....!!!! reading the file: \n $newfileMcl"
        return
      }
      if {$retCode == 2} {
        #the user pressed cancel (no axis selected)
        return
      }
   }
   ###########################################################
   #update the flow listbox with the data values of .MCL /.NPF
   ###########################################################
   if [catch {open $newfileMcl} fileID] {
      tk_messageBox -message "$fileID"
      return
   }

   set count_flow 0
   #uhmm.. if something is wrong in the data file  Format_error will be 1
   set Format_error 0
   set line ""
   set title ""
   set title_ok 0
   set xvalue ""
   set xvalue_ok 0
   set yvalue ""
   set yvalue_ok 0
   while { [gets $fileID line] != -1  }\
   {
      set first_char  [string range $line 0 0 ]
      #tk_messageBox -message "  line= $line"
      #tk_messageBox -message " fchar= $first_char"
      if  { ![string compare $line "Mgen measure"] || ![string compare $line "Netperf measure"] }\
      {
         #multiple flow in the file ? if is the second need to update ListBox
         if { $count_flow > 0 } { UpdateFlowListbox }
         #get the title of measure
         gets $fileID line
         set title [string range $line 11 [string length $line] ]
         set title_ok 1
         incr count_flow
         #tk_messageBox -message " title= $title"
      }
      if { ![string compare $first_char "-"] } \
      {
          #tk_messageBox -message "value on line = $line"
          ## Value Found - Take the Label...
          set lindex      [string first : $line 0]
          set value_label [string range   $line 1 [expr $lindex -1]]
          set value_label [string trim    $value_label]
          ## Value Found - ..and the value ;)
          set value [string range $line [expr $lindex +1] [string length $line] ]
          set value [string trim  $value]

          if { ![string compare $Xlabel $value_label] } \
          {
             #tk_messageBox -message "Xvalue = $value"
             set xvalue $value
             set xvalue_ok 1
          }
          if { ![string compare $Ylabel $value_label] } \
          {
             #tk_messageBox -message "Yvalue = $value"
             set yvalue $value
             set yvalue_ok 1
          }
      }
      if { $Format_error == 1 } \
      {
         tk_messageBox -message "Values not found, Error ....!!!!\n reading the file: \n $newfileMcl"
         return
      }
   }
   if [catch {close $fileID} err] { tk_messageBox -message "$err" }
   UpdateFlowListbox
   if { $Format_error == 1 } \
   {
      tk_messageBox -message "Values not found, Error ....!!!!\n reading the file: \n $newfileMcl"
      return
   }

   #finally update the counters
   incr countf
   incr count_files

   #.... the flow listbox
   .graph.down.flows.lb insert end "-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------"

   #.... the file listbox
   .graph.up.top.lbf.lb insert end  [format "%02d : %s   " $count_files  $newfile]
   .graph.up.top.lbf.lb see end

   #.... and the Select-Menu
   set  temp [format "file %02d" $count_files]
   set  FileArray($temp) $count_files
   destroy .graph.down.flows.b.b8.menu
   eval tk_optionMenu .graph.down.flows.b.b8.menu showfileID [lsort [array names FileArray]]
   .graph.down.flows.b.b8.menu configure -width 9
   pack .graph.down.flows.b.b8.menu -padx 3 -side left


   #.... NEW .. ADD a graphic with the name of the file %)
   set name  "[file tail      $newfileMcl]"
   set name  "[file rootname  $name] "
   AddGraph $name
}


###################################################################
#------------------------------------------------------------------
#              Remove Result File from listbox
#------------------------------------------------------------------
###################################################################
proc RemoveResultFile {} \
{
   global countf
   global xfile
   global userLB6 head6
   global flow6 mod6 flow6LB
   global count_files mclID nr lineNr
   global showfileID
   global FileArray

   set tmp [.graph.up.top.lbf.lb curselection]
   if {$tmp == ""} {
     #nothing selected
     tk_messageBox -message "No file selected..!!!"
     return
   }

   #tk_messageBox -message [selection get]
   set line2 [selection get]
   scan $line2 "%s : " file_num
   set  xfile2 $file_num
   set  file_num [format "%.0f" $file_num]
   #tk_messageBox -message "file selected = $file_num"
   set selList ""
   set selList [.graph.down.flows.lb get 0 end]
   if {$selList == ""} \
   {
      tk_messageBox -message "No flows defined..!!!"
      #return
   }
   #tk_messageBox -message "lista completa= $selList"
   set count 0
   foreach lineNr  $selList \
   {
      set line [.graph.down.flows.lb get $count]
      # WHEN reading the string "------ ...---" the value of fiN
      # is NOT update and take the old value; correct for delete
      # the line of associate file
      scan $line "File %s  Flow %s" fiN flN
      set  fiN [format "%.0f" $fiN]
      #test
      if {$fiN ==$file_num} \
      {
        #tk_messageBox -message "MATCH FLOW !!!!!"
        .graph.down.flows.lb   delete $count
      } else {
        incr count
      }
   }
   #update .... the view file listbox
   .graph.up.top.lbf.lb delete $tmp
   if {$xfile2 == $xfile} {
     .graph.up.right.flows.lb delete 0 end
   }

   #update .... the global var
   set countf [expr $countf -1]

   #update .....the Select file menu
   if  { $FileArray($showfileID) ==  $file_num } { set showfileID "All" }
   set  temp [format "file %02d" $file_num]
   unset  FileArray($temp)
   destroy .graph.down.flows.b.b8.menu
   eval tk_optionMenu .graph.down.flows.b.b8.menu showfileID [lsort [array names FileArray]]
   .graph.down.flows.b.b8.menu configure -width 9
   pack .graph.down.flows.b.b8.menu -padx 3 -side left
}







###################################################################
#------------------------------------------------------------------
#             View Mgen Result file .INF
#------------------------------------------------------------------
###################################################################
proc ViewResultFile {} \
{
   global userLB6 head6
   global flow6 mod6 flow6LB
   global mclID nr lineNr
   global dgr
   global xfile      # file number of last viewed_file

   .graph.up.right.flows.lb delete 0 end
   set tmp [.graph.up.top.lbf.lb curselection]
   if {$tmp == ""} {
   #nothing selected
   return
   }
   #tk_messageBox -message [selection get]
   set line2 [selection get]
   scan $line2 "%s : " file_num
   set  xfile $file_num
   set  file_num [format "%.0f" " $file_num"]

   set lindex  [string first : $line2 1]
   set newfile [string range $line2 [expr $lindex +1] [string length $line2] ]

   set newfile [string trim  $newfile]
   #tk_messageBox -message "file ABS num selected = $file_num"
   #tk_messageBox -message "file name selected = $newfile"


   set newfileMcl $newfile
   #open the file:
   if [catch {open $newfileMcl} mclID] {
   tk_messageBox -message "$mclID"
   return
   }
   .graph.up.right.flows.lb insert end  "------------------------------------------------------------------------------------------------"
   .graph.up.right.flows.lb insert end  " $newfile"
   .graph.up.right.flows.lb insert end  "------------------------------------------------------------------------------------------------"
   .graph.up.right.flows.lb see    end
   set line ""
   while {![eof $mclID]} \
   {

        gets $mclID line
        .graph.up.right.flows.lb insert end  "$line"
        .graph.up.right.flows.lb see    end
   }
   .graph.up.right.flows.lb insert end  "------------------------------------------------------------------------------------------------"
   .graph.up.right.flows.lb see    end
   close $mclID
}




######################################################################
#---------------------------------------------------------------------
#                Set Graph Axis parameters
#---------------------------------------------------------------------
# return label: Xlabel, Ylabel
#---------------------------------------------------------------------
#######################################################################
proc GraphValues { filename }\
{
   global retCode
   global Xlabel Ylabel

   if [catch {open $filename} fd] {
     set retCode 1
     return 
   }

   #else, file was open:
   #make a list with all parameter names found:
   set first 1
   set countp 0
   while {![eof $fd]} {
      gets $fd line
      if  { ![string compare $line "Mgen measure"] || ![string compare $line "Netperf measure"] }\
      {
        if { $first != 1 } { break }
        set first 0
      }
      set first_char  [string range $line 0 0 ]
      #tk_messageBox -message "fchar=$first_char="
      if ![string compare $first_char "-"] \
      {                                      ## Value Found - Take the Label
          set lindex [string first : $line 0]
          set dline  [string range   $line 1 [expr $lindex -1]]
          set dline  [string trim    $dline]
          set pNames($dline) $countp
          incr countp
      }
   }
   catch {close $fd}
   if { $countp == 0 }\
   {
      set retCode 1
      return
   }
   
   set ltmp   [lsort [array names pNames]]
   set Xlabel [lindex $ltmp 0]
   set Ylabel [lindex $ltmp 0]

   #create a dialog (modal) window for setting axis
   toplevel .uwdialog
   wm title .uwdialog "Graphic Axis"
   wm protocol  .uwdialog WM_DELETE_WINDOW {;#do nothing}
   wm resizable .uwdialog 0 0

   #define widgets:
   frame .uwdialog.body  -bd 2 -relief groove
   pack  .uwdialog.body -fill x -pady 3 -padx 3 -anchor n -expand true
   label .uwdialog.body.l  -text "Select the values to be used to plot all the Graphics"
   pack  .uwdialog.body.l -pady 3 -fill x

   frame .uwdialog.body.one
   label .uwdialog.body.one.lone -text " (Y Axis)"

   eval tk_optionMenu .uwdialog.body.one.tone Ylabel [lsort [array names pNames]]
   .uwdialog.body.one.tone configure -width 34
   pack .uwdialog.body.one -pady 3 -fill x
   pack .uwdialog.body.one.lone -padx 3 -side left
   pack .uwdialog.body.one.tone -padx 3 -side right
   frame .uwdialog.body.two
   label .uwdialog.body.two.ltwo -text " (X Axis)"

   eval tk_optionMenu .uwdialog.body.two.ttwo Xlabel [lsort [array names pNames]]
   .uwdialog.body.two.ttwo configure -width 34
   pack .uwdialog.body.two -pady 3 -fill x
   pack .uwdialog.body.two.ltwo -padx 3 -side left -anchor c
   pack .uwdialog.body.two.ttwo -padx 3 -side right -anchor c
   frame .uwdialog.three
   button .uwdialog.three.b1 -text OK -command {
      set retCode 0
   }
   button .uwdialog.three.b2 -text Cancel -command {
      set retCode 2
   }
   pack .uwdialog.three -pady 3 -padx 3 -side bottom -anchor c
   pack .uwdialog.three.b1 .uwdialog.three.b2  -side left -padx 3
   grab release .chartw
   grab .uwdialog
   set retCode not_yet
   tkwait variable retCode
   grab release .uwdialog
   destroy .uwdialog


   #Fixing the parameters
   set Xlabel  [string trim    $Xlabel]
   set Ylabel  [string trim    $Ylabel]
   #tk_messageBox -message "X label = $Xlabel"
   #tk_messageBox -message "Y label = $Ylabel"
}



###################################################################
#------------------------------------------------------------------
#                  Add GRAPH
#------------------------------------------------------------------
###################################################################
proc AddGraph { action } \
{
   global dgr
   global countG
   global doneAdd
   global NewName
   global GraphID
   global GraphArray

if ![string compare "0"  $action] \
{
   ###################################################################
   #### make a dialog window for the Add GRAPH option
   ###################################################################
   set NewName ""
   set doneAdd 0
   toplevel .add
   wm title .add "Add Graphic"
   wm resizable .add 0 0
   wm protocol .add WM_DELETE_WINDOW {;#do nothing}
   frame .add.centre -bd 2 -relief groove
   pack .add.centre -fill x -pady 3 -padx 3 -anchor n -expand true
   frame .add.centre.hold
   pack  .add.centre.hold    -fill x -pady 3 -padx 3 -anchor n -expand true
   label .add.centre.hold.l  -text "Special chars for the name:  (+) New line "
   pack  .add.centre.hold.l  -side left -padx 3 -fill x

   frame .add.centre.new
   pack  .add.centre.new    -fill x -pady 3 -padx 3 -anchor n -expand true
   label .add.centre.new.l  -text "New Graphic name"
   pack  .add.centre.new.l  -side left -padx 3 -fill x
   entry .add.centre.new.e  -textvariable NewName -width 70
   pack  .add.centre.new.e  -padx 3 -side left

   frame .add.down
   pack .add.down -pady 3 -padx 3 -side bottom -anchor c
   button .add.down.ok -text OK -command \
   {
      set doneAdd "1"
      destroy .add
   } -width 6
   button .add.down.cancel -text Cancel -command \
   {
      set doneAdd "0"
      destroy .add
      return
   } -width 6
   pack .add.down.ok .add.down.cancel  -side left -padx 3 -pady 3
   ###################################################################
   #### Wait to END dialog
   ###################################################################
   grab .add
   tkwait window .add

   if { $doneAdd == "0" } return
} else {
  #to eliminate any space
  set action  [string trim $action] 
  set NewName $action
}

   incr countG
   #Update the Graphic Listbox
   .graph.up.right.flowG.lb insert end \
   [format "Graph %02d - %s" $countG $NewName]
   .graph.up.right.flowG.lb see end

   #Update the Graphic Menu
   set temp [format "Graph %02d" $countG]
   set temp [string trim  $temp]
   set GraphArray($temp) $countG
   destroy .graph.down.flows.b.bx
   eval tk_optionMenu .graph.down.flows.b.bx GraphID [lsort [array names GraphArray]]
   .graph.down.flows.b.bx configure -width 9
   pack  .graph.down.flows.b.bx  -padx 3  -side left
}


###################################################################
#------------------------------------------------------------------
#             RemoveGraph
#------------------------------------------------------------------
###################################################################
proc RemoveGraph {} \
{
   global .graph
   global countG count countL
   global GraphArray GraphID

   set tmp [.graph.up.right.flowG.lb curselection]
   if {$tmp == ""} {
     tk_messageBox -message "No Graphic selected..!!!"
     return
   }
   set line [selection get]
   scan $line "%s %s - %s" label num title
   set  num [format "%.0f" $num]

   #Update the Graphic listbox
   .graph.up.right.flowG.lb delete $tmp

   #Update the Graphic Menu
   if { $GraphArray($GraphID) == $num } { set GraphID "Graph 00" }
   set temp [format "Graph %02d" $num]
   set temp [string trim  $temp]

   #Remove the entry for the Graph ID
   unset GraphArray($temp)
   destroy .graph.down.flows.b.bx
   eval tk_optionMenu .graph.down.flows.b.bx GraphID [lsort [array names GraphArray]]
   .graph.down.flows.b.bx configure -width 9
   pack  .graph.down.flows.b.bx  -padx 3  -side left


   #UnLink all the linked Flows to the GRAPH removed
   set selList ""
   set selList [.graph.down.flows.lb get 0 end]
   if {$selList == ""} { return  }
   set count 0
   foreach countL  $selList \
   {
      #tk_messageBox -message "count= $count"
      set line [.graph.down.flows.lb get [expr $count] ]
      if { [string compare [string range $line 0  5]  "------"] }\
      {
         #tk_messageBox -message "line= $line"
         scan $line "File %s   Flow %s   Graph %s    %s %s" ID1 ID2 ID3 N1 N2
         set  ID1 [format "%.0f" $ID1]
         set  ID2 [format "%.0f" $ID2]
         set  ID3 [format "%.0f" $ID3]
         set lindex [string first - $line 1]
         set T  [string range $line [expr $lindex +1] [string length $line] ]
         set T  [string trim  $T]
         #The countL-flow is linked with the graph to delete ?
         if { $ID3 == $num } \
         {
            .graph.down.flows.lb delete [expr $count]
            .graph.down.flows.lb insert [expr $count]  \
             [format "File %02d         Flow %02d         Graph %02d          %011f          %011f   -     %s"\
             $ID1 $ID2 "0" $N1  $N2 $T]
         }
      }
      incr count
   }
}

###################################################################
#------------------------------------------------------------------
#                  Edit GRAPH
#------------------------------------------------------------------
###################################################################
proc EditGraph {} \
{
   global dgr
   global countG
   global doneAdd
   global NewName


   set tmp [.graph.up.right.flowG.lb curselection]
   if {$tmp == ""} {
     tk_messageBox -message "No Graphic selected..!!!"
     return
   }
   set line   [selection get]
   scan $line  "%s %s - %s" label num name
   set  num [format "%.0f" $num]

   set index  [string first - $line 0]
   set title  [string range   $line [expr $index +1] [string length $line] ]
   set title  [string trim    $title]
   #tk_messageBox -message "Old Graph Title=$title"


   ###################################################################
   #### make a dialog window for the Add GRAPH option
   ###################################################################
   set NewName $title
   set doneAdd 0
   toplevel .add
   wm title .add "Edit Graph"
   wm resizable .add 0 0
   wm protocol .add WM_DELETE_WINDOW {;#do nothing}
   frame .add.centre -bd 2 -relief groove
   pack .add.centre -fill x -pady 3 -padx 3 -anchor n -expand true

   frame .add.centre.hold
   pack  .add.centre.hold    -fill x -pady 3 -padx 3 -anchor n -expand true
   label .add.centre.hold.l  -text "Special chars for the name:  (+) New line "
   pack  .add.centre.hold.l  -side left -padx 3 -fill x

   frame .add.centre.new
   pack  .add.centre.new    -fill x -pady 3 -padx 3 -anchor n -expand true
   label .add.centre.new.l  -text "New Graphic name"
   pack  .add.centre.new.l  -side left -padx 3 -fill x
   entry .add.centre.new.e  -textvariable NewName -width 70
   pack  .add.centre.new.e  -padx 3 -side left

   frame .add.down
   pack .add.down -pady 3 -padx 3 -side bottom -anchor c
   button .add.down.ok -text OK -command \
   {
      set doneAdd "1"
      destroy .add
   } -width 6
   button .add.down.cancel -text Cancel -command \
   {
      set doneAdd "0"
      destroy .add
      return
   } -width 6
   pack .add.down.ok .add.down.cancel  -side left -padx 3 -pady 3
   ###################################################################
   #### Wait to END dialog
   ###################################################################
   grab .add
   tkwait window .add
   if { $doneAdd == "0" } return

   #and finally update the entry
   .graph.up.right.flowG.lb delete $tmp
   .graph.up.right.flowG.lb insert $tmp \
   [format "Graph %02d - %s" $num $NewName]
}



###################################################################
#------------------------------------------------------------------
#               Link Flows with Graphic
#------------------------------------------------------------------
###################################################################
proc LinkFlow {} \
{
   global GraphArray GraphID

   set selList ""
   set selList [.graph.down.flows.lb curselection]
   if {$selList == ""} \
   {
      #nothing selected
      tk_messageBox -message "No flow selected"
      return
   }
   foreach countL  $selList \
   {
      set line [.graph.down.flows.lb get $countL]
      if { [string compare [string range $line 0  5]  "------"] }\
      {
         scan $line "File %s   Flow %s   Graph %s    %s %s" ID1 ID2 ID3 N1 N2
         set  ID1 [format "%.0f" $ID1]
         set  ID2 [format "%.0f" $ID2]
         set lindex [string first - $line 1]
         set T  [string range $line [expr $lindex +1] [string length $line] ]
         set T  [string trim  $T]
         .graph.down.flows.lb delete [expr $countL ]
         .graph.down.flows.lb insert [expr $countL ]  \
         [format "File %02d         Flow %02d         Graph %02d          %011f          %011f   -     %s"\
          $ID1 $ID2 $GraphArray($GraphID) $N1  $N2 $T]
      }
   }
}



###################################################################
#------------------------------------------------------------------
#            Plot Graphics Option (Size & co.)
#------------------------------------------------------------------
###################################################################
proc PlotOptions {} \
{
   global graph_lines
   global graph_Xsize
   global graph_Ysize
   global backOption
   global _xviewCMD


   #make a dialog window
   toplevel .opt
   wm title .opt "Plot Options"
   wm resizable .opt 0 0
   wm protocol .opt WM_DELETE_WINDOW {;#do nothing}

   frame .opt.centre -bd 2 -relief groove
   pack .opt.centre -fill x -pady 3 -padx 3 -anchor n -expand true
   label .opt.centre.l -text "Graphic parameters options"
   pack .opt.centre.l -side top -padx 3 -fill x



   frame .opt.centre.right -bd 2 -relief groove
   pack  .opt.centre.right -fill x -pady 3 -padx 3 -anchor n -expand true -side top

   frame .opt.centre.right.zsize
   pack  .opt.centre.right.zsize -pady 3 -fill x
   label .opt.centre.right.zsize.l -text "X Graph size (pixel)"
   pack  .opt.centre.right.zsize.l -side left -padx 3
   entry .opt.centre.right.zsize.e -textvariable graph_Xsize -width 30
   pack  .opt.centre.right.zsize.e -side right -padx 3

   frame .opt.centre.right.ysize
   pack  .opt.centre.right.ysize -pady 3 -fill x
   label .opt.centre.right.ysize.l -text "Y Graph size (pixel)"
   pack  .opt.centre.right.ysize.l -side left -padx 3
   entry .opt.centre.right.ysize.e -textvariable graph_Ysize -width 30
   pack  .opt.centre.right.ysize.e -side right -padx 3

   frame .opt.centre.right.lines
   pack  .opt.centre.right.lines -pady 3 -fill x
   label .opt.centre.right.lines.l -text "Number of lines\n on Y-Axe:"
   pack  .opt.centre.right.lines.l -side left -padx 3
   entry .opt.centre.right.lines.e -textvariable graph_lines -width 30
   pack  .opt.centre.right.lines.e -side right -padx 3



   frame .opt.centre.rback
   pack  .opt.centre.rback -pady 3 -fill x -side bottom

   label  .opt.centre.rback.l -text "Use Extra Layout"
   radiobutton .opt.centre.rback.rc1 -text "enable" \
   -variable backOption -value 1 -width 8
   radiobutton .opt.centre.rback.rc2 -text "disable" \
   -variable backOption -value 0 -width 8

   pack  .opt.centre.rback.l  -side left -padx 5 
   pack  .opt.centre.rback.rc1 \
         .opt.centre.rback.rc2 \
          -side right -pady 2 -padx 5 



   button .opt.ok -text OK -command \
   {
      destroy .opt
   } -width 6
   pack .opt.ok
   grab .opt
   tkwait window .opt
   if {$graph_Xsize>=1000 || $graph_Xsize<50} {
       tk_messageBox -message "Illegal X Graph size..!!!"
       PlotOptions
   }
   if {$graph_Ysize>=800 || $graph_Ysize<50} {
       tk_messageBox -message "Illegal Y Graph size..!!!"
       PlotOptions
   }
   if {$graph_lines>=100 || $graph_lines<3 } {
       tk_messageBox -message "Illegal lines number..!!!"
       PlotOptions
   }
}



###################################################################
#------------------------------------------------------------------
#                  Plot Ultimate Graphic
#------------------------------------------------------------------
###################################################################
proc PlotGraph {} \
{
   global selList
   global outputfile
   global scriptID dataID
   global count countGRAPH countMATCH
   global ID3 N1 N2 T
   global countG       #number of Graphic fixed
   global Xlabel Ylabel
   global dataLIST
   global county
   global GlobalTitle
   global graph_lines
   global graph_Xsize
   global graph_Ysize
   global _distrCMD
   global _graphCMD
   global _xviewCMD
   global backOption
   global patternOption

   if {$outputfile == ""} \
   {
      #nothing selected
      tk_messageBox -message "Need an output file name...!!!"
      return
   }

   set selList ""
   set selList [.graph.down.flows.lb get 0 end]
   if {$selList == ""} \
   {
      #nothing selected
      tk_messageBox -message "No flows found...!!!"
      return
   }

   if {$countG == 0 } \
   {
      #nothing selected
      tk_messageBox -message "No graphics found...!!!"
      return
   }
   if {$GlobalTitle == ""} \
   {
      #nothing selected
      tk_messageBox -message "No Main title found...!!!"
      return
   }


   ###############################################################
   # Start to Write the data file for the GRAPH
   ###############################################################
   set line ""
   if [catch {open "temp/graph.dat" w} dataID] \
   {
     tk_messageBox -message  "Failed saving data file for graph"
     return
   }
   set countGRAPH 0
   #tk_messageBox -message  "countG= $countG"

   set countMATCH 0
   for {set countGRAPH 1} {$countGRAPH <= $countG} {incr countGRAPH} \
   {
      set dataLIST ""
      set first 0
      set count 0
      foreach countL  $selList \
      {
         #tk_messageBox -message "count= $count"
         set line [.graph.down.flows.lb get [expr $count] ]
         if { [string compare [string range $line 0  5]  "------"] }\
         {
            #tk_messageBox -message "line= $line"
            scan $line "File %s   Flow %s   Graph %s    %s %s %s " ID1 ID2 ID3 N1 N2 T
            set  ID3 [format "%.0f" $ID3]
            if { $ID3 == $countGRAPH } \
            {
               if { $first==0 } \
               {
                  #This is the line to start a new flow datas
                  set line "NEW GRAPH"
                  puts $dataID $line
               }
               set first 1
   
         set Xsize  [string length $N2]
         set Xfill "" 
         for {set count0 0} {$count0 <= 15-$Xsize} {incr count0} \
         {
            append Xfill "0"
         }
         append Xfill $N2
         set N2 $Xfill
         #tk_messageBox -message "$N2"
                                  


               set line "$N2   $N1"
               lappend dataLIST $line
               #tk_messageBox -message "lista= $dataLIST"
               incr countMATCH
            }
         }
         incr count
      }
      set county 0
      #sort the data for the GRAPH algorithmic
      set dataLIST [lsort $dataLIST]
      foreach xxx  $selList \
      {
         set line [lindex $dataLIST $county ]
         #tk_messageBox -message "line= $line"
         if { $line != "" } \
         {
            puts $dataID $line
         }
         incr county
      }
   }
   #This is the line to end file data
   set line "NEW END"
   puts $dataID $line
   #and finally close the file data
   catch {close $dataID}

   if {$countMATCH == 0 } \
   {
      #nothing selected
      tk_messageBox -message "No data found for the graphics...!!!"
      return
   }

   ###############################################################
   # Start to Write the script file for the GRAPH
   ###############################################################
   set line ""
   if [catch {open "temp/graph.cfg" w} scriptID] \
   {
     tk_messageBox -message  "Failed saving script file for graph"
     return
   }

   #That's my name R-TYPE (Roberto ;-)
   set line "Type R"
   puts $scriptID $line

   set line "RLINES $graph_lines"
   puts $scriptID $line
   set line "RXSIZE $graph_Xsize"
   puts $scriptID $line
   set line "RYSIZE $graph_Ysize"
   puts $scriptID $line
   set line "Lab 0"
   puts $scriptID $line
   set line "Font FS"
   puts $scriptID $line
   set line "Output $outputfile"
   puts $scriptID $line
   set line "Input temp/graph.dat"
   puts $scriptID $line
   set line "Dat  1"
   puts $scriptID $line
   set line "Legend Este FM  "

   set count 0 
   set selList ""
   set selList [.graph.up.right.flowG.lb get 0 end]
   foreach xxx  $selList \
   {
      set   tmp  [.graph.up.right.flowG.lb get $count]
      scan $tmp  "%s %s - %s" label num name
      set  num [format "%.0f" $num]
      set index  [string first - $tmp 0]
      set title  [string range   $tmp [expr $index +1] [string length $tmp] ]
      set title  [string trim    $title]
      #tk_messageBox -message "count $count"
      #tk_messageBox -message "title= $title"
      append line "  ?$title!"
      incr count
   }
   puts $scriptID $line
   set line "Title Oeste FM $Ylabel"
   puts $scriptID $line
   set line "Title Sur FM $Xlabel"
   puts $scriptID $line
   set line "EJE flt"
   puts $scriptID $line
   set line "Title Norte FM  $GlobalTitle"
   puts $scriptID $line


   if { $backOption } \
   {
      set line "RBACK ON"
      puts $scriptID $line
   }

   #and finally close the script data
   catch {close $scriptID}


   ###################################################################
   # Start to make the Graphic - external programs definitions
   ###################################################################
   set graphCMD $_graphCMD 
   set xviewCMD $_xviewCMD
   ###################################################################
   append graphCMD " temp/graph.cfg"
   lappend xviewCMD "$outputfile"
   .graph.down.flows.b.b5 config -text "Wait..." -command {;#do nothing}

   #########################################################
   #tk_messageBox -message "Graph     command : $graphCMD"
   #tk_messageBox -message "Xview     command : $xviewCMD"
   #########################################################

   if [catch {eval exec $graphCMD} auxID2] \
   {
      #err message:
      tk_messageBox -message $auxID2
      .graph.down.flows.b.b5 config -text "Plot Graphs" -command PlotGraph
      return
   }

   if [catch {open "|$xviewCMD" r} auxID3] \
   {
      #err message:
      tk_messageBox -message $auxID3
      .graph.down.flows.b.b5 config -text "Plot Graphs" -command PlotGraph
      return
   }
   .graph.down.flows.b.b5 config -text "Plot Graphs" -command PlotGraph
}






###################################################################
#------------------------------------------------------------------
#                 Update Result File
#------------------------------------------------------------------
###################################################################
proc UpdateResultFile { action } \
{
   global CALL
   global _distrCMD
   global _graphCMD
   global _xviewCMD
   global .dgraph

   if { $action == 0 } \
   {
      if ![string compare "npf"  $CALL] \
      {
       tk_messageBox -message "This feature is only for Mgen Results files, sorry!"
       return
      }
   }

   if { $action == 0 } \
   {
      set line2   [.graph.up.top.lbf.lb curselection]
   }  else { 
      set line2   [.dgraph.top.left.lbf.lb curselection]
   }

   if {$line2 == ""} {
      #nothing selected
      tk_messageBox -message "No file selected..!!!"
      return
   }
   set line2   [selection get]
   set lindex  [string first : $line2 0]
   set newfile [string range $line2 [expr $lindex +1] [string length $line2] ]
   set newfile [string trim  $newfile]

   #tk_messageBox -message "file name selected = $newfile"

   set newfileDLY "[file rootname $newfile].dly"
   if { $action == 1 } \
   {
      set newfile "[file rootname $newfile].mcl"
   }
   #Exist the file DLY (data)?
   if [catch {open $newfileDLY} fileID] \
   {
      tk_messageBox -message "$fileID"
      return
   }
   close $fileID

   #Exist the file MCL ?
   if [catch {open $newfile} fileID] \
   {
      tk_messageBox -message "$fileID"
      return
   }

   #Open the MCL
   set count_flows 0
   set line ""
   while { [gets $fileID line] != -1  }\
   {
      if ![string compare $line "Mgen measure"] \
      {
         incr count_flows
      }
   }
   close $fileID
   #tk_messageBox -message "count_flows: $count_flows"
   #.graph.up.top.b.b21  config -text "Wait..." -command {;#do nothing}



   ###################################################################
   # Start to update file - external programs definitions
   ###################################################################
      set distrCMD $_distrCMD
      append distrCMD "- - 5 1 no_need 1 1 1 1 1 1 1 1"
      for {set count 1} {$count <= $count_flows} {incr count}  { 
         append distrCMD " $newfileDLY $count"    
      }
      #########################################################
      #tk_messageBox -message "DISTR.EXE command : $distrCMD"
      #########################################################
      if [catch {eval exec $distrCMD} auxID] \
      {
         #err message:
         tk_messageBox -message $auxID
         #.graph.up.top.b.b21 config -text "Update File" -command { UpdateResultFile 0 }
         return
      }
   tk_messageBox -message "File update, Done!"

   #.graph.up.top.b.b21 config -text "Update File" -command { UpdateResultFile 0 }

}


###################################################################
#------------------------------------------------------------------
#                 Select specific Flows on Listbox
#------------------------------------------------------------------
###################################################################
proc SelectFlow {} \
{
   global showfileID
   global FileArray


   set selList ""
   set selList [.graph.down.flows.lb get 0 end]
   if {$selList == ""} \
   {
      tk_messageBox -message "No flows defined..!!!"
      return
   }
   #tk_messageBox -message "lista completa= $selList"
   set count 0
   foreach lineNr  $selList \
   {
      set line [.graph.down.flows.lb get $count]
      #tk_messageBox -message "$line"
      if { [string compare [string range $line 0  5]  "------"] }\
      {
         if  { $FileArray($showfileID) ==  0 } \
         {
            #"All"
            .graph.down.flows.lb selection set $count
         } else \
         {
            #File XX
            scan $line "File %s  Flow %s" fiN flN
            set  fiN [format "%.0f" $fiN]
            #test
            if {$fiN == $FileArray($showfileID) } \
            {
              #tk_messageBox -message "MATCH FLOW !!!!!"
              .graph.down.flows.lb selection set $count
            }
         }
      }
      incr count
   }
}


###################################################################
#------------------------------------------------------------------
#                 Clean ALL GRAPH  Data
#------------------------------------------------------------------
###################################################################
proc RemoveData {} \
{

  global .graph
  global countf countG
  global GraphID
  global GraphArray
  global FileArray
  global showfileID
  global count_files 0

  unset  FileArray
  unset  GraphArray

  set  showfileID "All"
  set  FileArray($showfileID) 0

  set temp "Graph 00"
  set temp [string trim  $temp]
  set GraphArray($temp) 0
  set GraphID $temp
 
  ###############
  #Remove Listbox 
  ###############
  #Files list 
  .graph.up.top.lbf.lb      delete 0 end 
  #viewfile 
  .graph.up.right.flows.lb  delete 0 end
  #Graph
  .graph.up.right.flowG.lb  delete 0 end
  #Flows data
  .graph.down.flows.lb      delete 0 end

  #file counter
  set countf 0 
  set count_files 0

  #graph counter
  set countG 0

  ###############
  #Remove TK_menu
  ###############
  destroy .graph.down.flows.b.b8.menu
  eval tk_optionMenu .graph.down.flows.b.b8.menu showfileID [lsort [array names FileArray]]
  .graph.down.flows.b.b8.menu configure -width 9
  pack .graph.down.flows.b.b8.menu -padx 3 -side left

  destroy .graph.down.flows.b.bx
  eval tk_optionMenu .graph.down.flows.b.bx GraphID [lsort [array names GraphArray]]
  .graph.down.flows.b.bx configure -width 9
  pack  .graph.down.flows.b.bx  -padx 3  -side left
}


